//
//  Animation.cpp
//
#include <math.h>
#include "wx/wx.h"
#include "resource.h"
#include "KidsCindyCanvas.h"
#include "KidsCindyFrame.h"
#ifdef __WXMSW__
	#include "word.h"
#else
	#include "word_e.h"
#endif
#include "wx/radiobut.h"
#include "wx/listctrl.h"
#include "wx/button.h"
#include "wx/dialog.h"

enum{
	ANIM_LIST=0,
	ANIM_IN,
	ANIM_OUT,
	ANIM_CLICK,
	ANIM_SOON,
	ANIM_FADE,
	ANIM_RIGHT,
	ANIM_LEFT,
	ANIM_TOP,
	ANIM_BOTTOM,
	ANIM_EFFECTON,
	ANIM_EFFECTOFF,
	ANIM_DELETE,
	ANIM_UP,
	ANIM_DOWN,
	ANIM_OK,
	ANIM_CANCEL,
	ANIM_MAX
};

// 0 : fade , 1 : right , 2 : left , 3 : top , 4 : bottom
enum{
	DIR_FADE=0,
	DIR_RIGHT,
	DIR_LEFT,
	DIR_TOP,
	DIR_BOTTOM
};

class AnimationDialog : public wxDialog
{
public:
	// ctor
	AnimationDialog(MyFrame* parent);

	MyCanvas* grandparent;
	wxListCtrl *Line;
	wxRadioButton *B1a,*B1b,*B2a,*B2b,*B3a,*B3b,*B3c,*B3d,*B3e,*B4a,*B4b;
	wxButton *C1,*C2,*C3,*C4,*C5;
	GConst* entry[100];
	int direction[100],effect[100],inout[100],click[100];
	int maxphase,NOentry;
	int idx;
	void OnDelete(wxCommandEvent& event);
	void OnUp(wxCommandEvent& event);
	void OnDown(wxCommandEvent& event);
	void OnItemFocused(wxListEvent& event);
	void OnIn(wxCommandEvent& event);
	void OnOut(wxCommandEvent& event);
	void OnClick(wxCommandEvent& event);
	void OnSoon(wxCommandEvent& event);
	void OnFade(wxCommandEvent& event);
	void OnRight(wxCommandEvent& event);
	void OnLeft(wxCommandEvent& event);
	void OnTop(wxCommandEvent& event);
	void OnBottom(wxCommandEvent& event);
	void OnEffecton(wxCommandEvent& event);
	void OnEffectoff(wxCommandEvent& event);

private:
	DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(AnimationDialog, wxDialog)
	EVT_BUTTON (ANIM_DELETE,	AnimationDialog::OnDelete)
	EVT_BUTTON (ANIM_UP,		AnimationDialog::OnUp)
	EVT_BUTTON (ANIM_DOWN,		AnimationDialog::OnDown)
	EVT_LIST_ITEM_FOCUSED(ANIM_LIST, AnimationDialog::OnItemFocused)
	EVT_RADIOBUTTON(ANIM_IN, AnimationDialog::OnIn)
	EVT_RADIOBUTTON(ANIM_OUT, AnimationDialog::OnOut)
	EVT_RADIOBUTTON(ANIM_CLICK, AnimationDialog::OnClick)
	EVT_RADIOBUTTON(ANIM_SOON, AnimationDialog::OnSoon)
	EVT_RADIOBUTTON(ANIM_FADE, AnimationDialog::OnFade)
	EVT_RADIOBUTTON(ANIM_RIGHT, AnimationDialog::OnRight)
	EVT_RADIOBUTTON(ANIM_LEFT, AnimationDialog::OnLeft)
	EVT_RADIOBUTTON(ANIM_TOP, AnimationDialog::OnTop)
	EVT_RADIOBUTTON(ANIM_BOTTOM, AnimationDialog::OnBottom)
	EVT_RADIOBUTTON(ANIM_EFFECTON, AnimationDialog::OnEffecton)
	EVT_RADIOBUTTON(ANIM_EFFECTOFF, AnimationDialog::OnEffectoff)
END_EVENT_TABLE()


#ifdef __WXMSW__
AnimationDialog::AnimationDialog(MyFrame *parent)
:wxDialog((wxWindow*)parent,wxID_ANY,AnimationPropertyTitle,wxPoint(50,50),wxSize(380,400),wxDEFAULT_DIALOG_STYLE,wxT(""))
{
	grandparent = parent->m_canvas;
	Line = new wxListCtrl(this,ANIM_LIST,wxPoint(10,30),wxSize(350,150),wxLC_LIST | wxLC_ALIGN_LEFT | wxLC_SINGLE_SEL,
		wxDefaultValidator, wxT("List"));
	B1a  = new wxRadioButton(this,ANIM_IN,AnimDlogLabels[ANIM_IN],wxPoint(10,190),wxSize(100,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B1b  = new wxRadioButton(this,ANIM_OUT,AnimDlogLabels[ANIM_OUT],wxPoint(120,190),wxSize(100,25), 0 , wxDefaultValidator, wxT("button"));
	B2a  = new wxRadioButton(this,ANIM_SOON,AnimDlogLabels[ANIM_SOON],wxPoint(10,220),wxSize(100,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B2b  = new wxRadioButton(this,ANIM_CLICK,AnimDlogLabels[ANIM_CLICK],wxPoint(120,220),wxSize(100,25), 0 , wxDefaultValidator, wxT("button"));
	B3a  = new wxRadioButton(this,ANIM_FADE,AnimDlogLabels[ANIM_FADE],wxPoint(10,250),wxSize(55,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B3b  = new wxRadioButton(this,ANIM_RIGHT,AnimDlogLabels[ANIM_RIGHT],wxPoint(70,250),wxSize(55,25), 0 , wxDefaultValidator, wxT("button"));
	B3c  = new wxRadioButton(this,ANIM_LEFT,AnimDlogLabels[ANIM_LEFT],wxPoint(130,250),wxSize(55,25), 0 , wxDefaultValidator, wxT("button"));
	B3d  = new wxRadioButton(this,ANIM_TOP,AnimDlogLabels[ANIM_TOP],wxPoint(190,250),wxSize(55,25), 0 , wxDefaultValidator, wxT("button"));
	B3e  = new wxRadioButton(this,ANIM_BOTTOM,AnimDlogLabels[ANIM_BOTTOM],wxPoint(250,250),wxSize(55,25), 0 , wxDefaultValidator, wxT("button"));
	B4a  = new wxRadioButton(this,ANIM_EFFECTOFF,AnimDlogLabels[ANIM_EFFECTOFF],wxPoint(10,280),wxSize(100,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B4b  = new wxRadioButton(this,ANIM_EFFECTON,AnimDlogLabels[ANIM_EFFECTON],wxPoint(120,280),wxSize(100,25), 0 , wxDefaultValidator, wxT("button"));
	C1 = new wxButton(this,ANIM_DELETE,AnimDlogLabels[ANIM_DELETE],wxPoint(10,310),wxSize(65,25),0, wxDefaultValidator, wxT("button"));
	C2 = new wxButton(this,ANIM_UP,AnimDlogLabels[ANIM_UP],wxPoint(80,310),wxSize(65,25),0, wxDefaultValidator, wxT("button"));
	C3 = new wxButton(this,ANIM_DOWN,AnimDlogLabels[ANIM_DOWN],wxPoint(150,310),wxSize(65,25),0, wxDefaultValidator, wxT("button"));
	C4 = new wxButton(this,wxID_OK,AnimDlogLabels[ANIM_OK],wxPoint(220,310),wxSize(65,25),0, wxDefaultValidator, wxT("button"));
	C5 = new wxButton(this,wxID_CANCEL,AnimDlogLabels[ANIM_CANCEL],wxPoint(290,310),wxSize(65,25),0, wxDefaultValidator, wxT("button"));
	NOentry=0;	
	maxphase=0;
	idx=-1;
}
#else
AnimationDialog::AnimationDialog(MyFrame *parent)
:wxDialog((wxWindow*)parent,wxID_ANY,AnimationPropertyTitle,wxPoint(50,50),wxSize(450,360),wxDEFAULT_DIALOG_STYLE,wxT(""))
{
	grandparent = parent->m_canvas;
	Line = new wxListCtrl(this,ANIM_LIST,wxPoint(10,30),wxSize(410,150),wxLC_LIST | wxLC_ALIGN_LEFT | wxLC_SINGLE_SEL,
		wxDefaultValidator, wxT("List"));
	B1a  = new wxRadioButton(this,ANIM_IN,AnimDlogLabels[ANIM_IN],wxPoint(10,190),wxSize(130,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B1b  = new wxRadioButton(this,ANIM_OUT,AnimDlogLabels[ANIM_OUT],wxPoint(150,190),wxSize(130,25), 0 , wxDefaultValidator, wxT("button"));
	B2a  = new wxRadioButton(this,ANIM_SOON,AnimDlogLabels[ANIM_SOON],wxPoint(10,220),wxSize(130,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B2b  = new wxRadioButton(this,ANIM_CLICK,AnimDlogLabels[ANIM_CLICK],wxPoint(150,220),wxSize(130,25), 0 , wxDefaultValidator, wxT("button"));
	B3a  = new wxRadioButton(this,ANIM_FADE,AnimDlogLabels[ANIM_FADE],wxPoint(10,250),wxSize(70,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B3b  = new wxRadioButton(this,ANIM_RIGHT,AnimDlogLabels[ANIM_RIGHT],wxPoint(85,250),wxSize(70,25), 0 , wxDefaultValidator, wxT("button"));
	B3c  = new wxRadioButton(this,ANIM_LEFT,AnimDlogLabels[ANIM_LEFT],wxPoint(160,250),wxSize(70,25), 0 , wxDefaultValidator, wxT("button"));
	B3d  = new wxRadioButton(this,ANIM_TOP,AnimDlogLabels[ANIM_TOP],wxPoint(235,250),wxSize(70,25), 0 , wxDefaultValidator, wxT("button"));
	B3e  = new wxRadioButton(this,ANIM_BOTTOM,AnimDlogLabels[ANIM_BOTTOM],wxPoint(310,250),wxSize(70,25), 0 , wxDefaultValidator, wxT("button"));
	B4a  = new wxRadioButton(this,ANIM_EFFECTOFF,AnimDlogLabels[ANIM_EFFECTOFF],wxPoint(10,280),wxSize(130,25), wxRB_GROUP , wxDefaultValidator, wxT("button"));
	B4b  = new wxRadioButton(this,ANIM_EFFECTON,AnimDlogLabels[ANIM_EFFECTON],wxPoint(150,280),wxSize(130,25), 0 , wxDefaultValidator, wxT("button"));
	C1 = new wxButton(this,ANIM_DELETE,AnimDlogLabels[ANIM_DELETE],wxPoint(10,310),wxSize(70,25),0, wxDefaultValidator, wxT("button"));
	C2 = new wxButton(this,ANIM_UP,AnimDlogLabels[ANIM_UP],wxPoint(95,310),wxSize(70,25),0, wxDefaultValidator, wxT("button"));
	C3 = new wxButton(this,ANIM_DOWN,AnimDlogLabels[ANIM_DOWN],wxPoint(180,310),wxSize(70,25),0, wxDefaultValidator, wxT("button"));
	C4 = new wxButton(this,wxID_OK,AnimDlogLabels[ANIM_OK],wxPoint(265,310),wxSize(70,25),0, wxDefaultValidator, wxT("button"));
	C5 = new wxButton(this,wxID_CANCEL,AnimDlogLabels[ANIM_CANCEL],wxPoint(350,310),wxSize(70,25),0, wxDefaultValidator, wxT("button"));
	NOentry=0;	
	maxphase=0;
	idx=-1;
}
#endif

void AnimationDialog::OnDelete(wxCommandEvent& event)
{
	int i;
	char buff[256];
	wxString str;
	if(idx>=0 && idx<maxphase){
		for(i=idx;i<maxphase-1;i++){
			entry[i]=entry[i+1];
			direction[i]=direction[i+1];
			effect[i]=effect[i+1];
			inout[i]=inout[i+1];
			click[i]=click[i+1];
		}
		maxphase--;
		Line->DeleteAllItems();
		for(int i=0;i<maxphase;i++){
			entry[i]->anim_entry->ConstSrc(buff);
			str=wxString(buff,*wxConvCurrent);
			Line->InsertItem(i,str);
		}
	}
}

void AnimationDialog::OnUp(wxCommandEvent& event)
{
	char buff[256];
	wxString str;
	if(idx>0){
		GConst* t_entry=entry[idx];
		int t_direction=direction[idx];
		int t_effect=effect[idx];
		int t_inout=inout[idx];
		int t_click=click[idx];
		entry[idx]=entry[idx-1];
		direction[idx]=direction[idx-1];
		effect[idx]=effect[idx-1];
		inout[idx]=inout[idx-1];
		click[idx]=click[idx-1];
		entry[idx-1]=t_entry;
		direction[idx-1]=t_direction;
		effect[idx-1]=t_effect;
		inout[idx-1]=t_inout;
		click[idx-1]=t_click;
		Line->DeleteAllItems();
		for(int i=0;i<maxphase;i++){
			entry[i]->anim_entry->ConstSrc(buff);
			str=wxString(buff,*wxConvCurrent);
			Line->InsertItem(i,str);
		}
	}
}

void AnimationDialog::OnDown(wxCommandEvent& event)
{
	char buff[256];
	wxString str;
	if(idx<maxphase-1){
		GConst* t_entry=entry[idx];
		int t_direction=direction[idx];
		int t_effect=effect[idx];
		int t_inout=inout[idx];
		int t_click=click[idx];
		entry[idx]=entry[idx+1];
		direction[idx]=direction[idx+1];
		effect[idx]=effect[idx+1];
		inout[idx]=inout[idx+1];
		click[idx]=click[idx+1];
		entry[idx+1]=t_entry;
		direction[idx+1]=t_direction;
		effect[idx+1]=t_effect;
		inout[idx+1]=t_inout;
		click[idx+1]=t_click;
		Line->DeleteAllItems();
		for(int i=0;i<maxphase;i++){
			entry[i]->anim_entry->ConstSrc(buff);
			str=wxString(buff,*wxConvCurrent);
			Line->InsertItem(i,str);
		}
	}
}

void AnimationDialog::OnItemFocused(wxListEvent& event)
{
	idx=event.GetIndex();
	if(idx<0 || idx>maxphase){
		return;
	}
	switch(click[idx]){
	case 0:
		B2a->SetValue(true);
		break;
	case 1:
		B2b->SetValue(true);
		break;
	}
	switch(direction[idx]){
	case 0:
		B3a->SetValue(true);
		break;
	case 1:
		B3b->SetValue(true);
		break;
	case 2:
		B3c->SetValue(true);
		break;
	case 3:
		B3d->SetValue(true);
		break;
	case 4:
		B3e->SetValue(true);
		break;
	}
	switch(effect[idx]){
	case 0:
		B4a->SetValue(true);
		break;
	case 1:
		B4b->SetValue(true);
		break;
	}
	switch(inout[idx]){
	case 0:
		B1a->SetValue(true);
		break;
	case 1:
		B1b->SetValue(true);
		break;
	}

}

void AnimationDialog::OnIn(wxCommandEvent& event)
{
	if(idx>=0){
		inout[idx]=0;
	}
}

void AnimationDialog::OnOut(wxCommandEvent& event)
{
	if(idx>=0){
		inout[idx]=1;
	}
}

void AnimationDialog::OnClick(wxCommandEvent& event)
{
	if(idx>=0){
		click[idx]=1;
	}
}

void AnimationDialog::OnSoon(wxCommandEvent& event)
{
	if(idx>=0){
		click[idx]=0;
	}
}

void AnimationDialog::OnFade(wxCommandEvent& event)
{
	if(idx>=0){
		direction[idx]=0;
	}
}

void AnimationDialog::OnRight(wxCommandEvent& event)
{
	if(idx>=0){
		direction[idx]=1;
	}
}

void AnimationDialog::OnLeft(wxCommandEvent& event)
{
	if(idx>=0){
		direction[idx]=2;
	}
}

void AnimationDialog::OnTop(wxCommandEvent& event)
{
	if(idx>=0){
		direction[idx]=3;
	}
}

void AnimationDialog::OnBottom(wxCommandEvent& event)
{
	if(idx>=0){
		direction[idx]=4;
	}
}

void AnimationDialog::OnEffecton(wxCommandEvent& event)
{
	if(idx>=0){
		effect[idx]=1;
	}
}

void AnimationDialog::OnEffectoff(wxCommandEvent& event)
{
	if(idx>=0){
		effect[idx]=0;
	}
}

void MyCanvas::AnimationProperty()
{
	AnimationDialog MyD(m_owner);
	GConst* cnp;
	char buff[256];
	int maxphase=0;
	for(cnp=cns;cnp!=NULL;cnp=cnp->next){
		switch(cnp->Const_Type){
		case CONST_EFFECT_POINT:
		case CONST_EFFECT_LINE:
		case CONST_EFFECT_CIRCLE:
		case CONST_EFFECT_CURVE:
		case CONST_EFFECT_TEXT:
			cnp->anim_entry->ConstSrc(buff);
			wxString str(buff,*wxConvCurrent);
			MyD.Line->InsertItem(maxphase,str);
			MyD.entry[maxphase]=cnp->anim_entry;
			MyD.click[maxphase]=cnp->anim_click;
			MyD.direction[maxphase]=cnp->anim_direction;
			MyD.effect[maxphase]=cnp->anim_effect;
			MyD.inout[maxphase]=cnp->anim_inout;
			maxphase++;
			break;
		}
	}
	for(cnp=cns;cnp!=NULL;cnp=cnp->next){
		switch(cnp->Output_Type()){
		case OUTPUT_POINT:
			if(cnp->POutput->hilighted){
				cnp->ConstSrc(buff);
				wxString str(buff,*wxConvCurrent);
				MyD.Line->InsertItem(maxphase,str);
				MyD.entry[maxphase]=cnp;
				MyD.click[maxphase]=0;
				MyD.direction[maxphase]=0;
				MyD.effect[maxphase]=0;
				MyD.inout[maxphase]=0;
				maxphase++;
			}
			break;
		case OUTPUT_LINE:
			if(cnp->LOutput->hilighted){
				cnp->ConstSrc(buff);
				wxString str(buff,*wxConvCurrent);
				MyD.Line->InsertItem(maxphase,str);
				MyD.entry[maxphase]=cnp;
				MyD.click[maxphase]=0;
				MyD.direction[maxphase]=0;
				MyD.effect[maxphase]=0;
				MyD.inout[maxphase]=0;
				maxphase++;
			}
			break;
		case OUTPUT_CIRCLE:
			if(cnp->COutput->hilighted){
				cnp->ConstSrc(buff);
				wxString str(buff,*wxConvCurrent);
				MyD.Line->InsertItem(maxphase,str);
				MyD.entry[maxphase]=cnp;
				MyD.click[maxphase]=0;
				MyD.direction[maxphase]=0;
				MyD.effect[maxphase]=0;
				MyD.inout[maxphase]=0;
				maxphase++;
			}
			break;
		case OUTPUT_TEXT:
			if(cnp->TextOutput->hilighted){
				cnp->ConstSrc(buff);
				wxString str(buff,*wxConvCurrent);
				MyD.Line->InsertItem(maxphase,str);
				MyD.entry[maxphase]=cnp;
				MyD.click[maxphase]=0;
				MyD.direction[maxphase]=0;
				MyD.effect[maxphase]=0;
				MyD.inout[maxphase]=0;
				maxphase++;
			}
			break;
		case OUTPUT_CURVE:
			if(cnp->CurveOutput->hilighted){
				cnp->ConstSrc(buff);
				wxString str(buff,*wxConvCurrent);
				MyD.Line->InsertItem(maxphase,str);
				MyD.entry[maxphase]=cnp;
				MyD.click[maxphase]=0;
				MyD.direction[maxphase]=0;
				MyD.effect[maxphase]=0;
				MyD.inout[maxphase]=0;
				maxphase++;
			}
			break;
		}
	}
	MyD.maxphase=maxphase;
	if(MyD.ShowModal()==wxID_OK)
	{
		ClearConstEffect();
		int i;
		for(i=0;i<MyD.maxphase;i++){
			AddConstEffect(MyD.entry[i],MyD.click[i],MyD.direction[i],MyD.effect[i],MyD.inout[i]);
		}
	}
}

void MyCanvas::AddConstEffect(GConst* entry, int click, int direction, int effect, int inout)
{
	GConst*cnp=NULL;
	switch(entry->Output_Type()){
	case OUTPUT_POINT:
		cnp=NewConst(CONST_EFFECT_POINT);
		break;
	case OUTPUT_LINE:
		cnp=NewConst(CONST_EFFECT_LINE);
		break;
	case OUTPUT_CIRCLE:
		cnp=NewConst(CONST_EFFECT_CIRCLE);
		break;
	case OUTPUT_TEXT:
		cnp=NewConst(CONST_EFFECT_TEXT);
		break;
	case OUTPUT_CURVE:
		cnp=NewConst(CONST_EFFECT_CURVE);
		break;
	}
	cnp->anim_entry=entry;
	cnp->anim_inout=inout;
	cnp->anim_click=click;
	cnp->anim_direction=direction;
	cnp->anim_effect=effect;
}

void MyCanvas::ClearConstEffect()
{
	if(cns==NULL){
		return ; 
	}
	GConst *cnp;
	GConst **cnh;
	cnh=&cns;
	for(cnp=cns;cnp!=NULL;cnp=cnp->next){
		switch(cnp->Const_Type){
		case CONST_EFFECT_POINT:
		case CONST_EFFECT_LINE:
		case CONST_EFFECT_CIRCLE:
		case CONST_EFFECT_CURVE:
		case CONST_EFFECT_TEXT:
			cnp->used=false;
			*cnh=cnp->next;
			if(cnp->next==NULL){
				lastcn=cnh;
			}
			break;
		default:
			cnh=&(cnp->next);
			break;
		}
	}
}

double min(double a, double b){
	return(a>b)?b:a;
}
double max(double a, double b){
	return(a<b)?b:a;
}

void MyCanvas::SlideShowStart(GConst* cnp)
{
	double geomx;
	double geomy;
	double dispx0;
	double dispy0;
	double dispx1;
	double dispy1;
	int dispx;
	int dispy;
	int length,height;
	int x,y,r;
	wxPaintDC pDC(this);
	if(cnp->next!=NULL){
		SlideShowStart(cnp->next);
	}
	switch(cnp->Const_Type){
	case CONST_EFFECT_POINT:
		anim_cn=cnp;
		if(cnp->anim_click==1){
			anim_wait=true;
		}
		else{
			anim_wait=false;
		}
		geomx=cnp->anim_entry->POutput->xz().real();
		geomy=cnp->anim_entry->POutput->yz().real();
		dispx=centerx+(int)floor((geomx-geomcx)/geomperdot);
		dispy=centery-(int)floor((geomy-geomcy)/geomperdot);
		cnp->anim_entry->POutput->expand=1.0;
		cnp->anim_entry->POutput->interval=0.2;
		cnp->anim_entry->POutput->hilighted=false;
		if(cnp->anim_inout==0){
			switch(cnp->anim_direction){
				case DIR_FADE:
					cnp->anim_entry->POutput->vanishing=4;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=0;
					break;
				case DIR_RIGHT:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=relRect.GetRight()-dispx+30;
					cnp->anim_entry->POutput->offsety=0;
					cnp->anim_entry->POutput->velocity=(relRect.GetRight()-dispx+30)/10;
					break;
				case DIR_LEFT:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=relRect.GetLeft()-dispx-30;
					cnp->anim_entry->POutput->offsety=0;
					cnp->anim_entry->POutput->velocity=(relRect.GetLeft()-dispx-30)/10;
					break;
				case DIR_TOP:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=relRect.GetTop()-dispy-30;
					cnp->anim_entry->POutput->velocity=(relRect.GetTop()-dispy-30)/10;
					break;
				case DIR_BOTTOM:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=relRect.GetBottom()-dispy+30;
					cnp->anim_entry->POutput->velocity=(relRect.GetBottom()-dispy+30)/10;
					break;
			}
		}
		else{
			switch(cnp->anim_direction){
				case DIR_FADE:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=0;
					break;
				case DIR_RIGHT:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=0;
					cnp->anim_entry->POutput->velocity=(relRect.GetRight()-dispx+30)/10;
					break;
				case DIR_LEFT:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=0;
					cnp->anim_entry->POutput->velocity=(relRect.GetLeft()-dispx-30)/10;
					break;
				case DIR_TOP:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=0;
					cnp->anim_entry->POutput->velocity=(relRect.GetTop()-dispy-30)/10;
					break;
				case DIR_BOTTOM:
					cnp->anim_entry->POutput->vanishing=0;
					cnp->anim_entry->POutput->offsetx=0;
					cnp->anim_entry->POutput->offsety=0;
					cnp->anim_entry->POutput->velocity=(relRect.GetBottom()-dispy+30)/10;
					break;
			}
		}
		break;
	case CONST_EFFECT_LINE:
		cnp->anim_entry->LOutput->hilighted=false;
		anim_cn=cnp;
		if(cnp->anim_click==1){
			anim_wait=true;
		}
		else{
			anim_wait=false;
		}
		GetGeomXY(cnp->anim_entry->LOutput, &dispx0, &dispy0, &dispx1, &dispy1);
		cnp->anim_entry->LOutput->expand=1.0;
		cnp->anim_entry->LOutput->interval=0.2;
			if(cnp->anim_inout==0){
				switch(cnp->anim_direction){
				case DIR_FADE:
					cnp->anim_entry->LOutput->vanishing=4;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=0;
					break;
				case DIR_RIGHT:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=relRect.GetRight()-(int)floor(min(dispx0,dispx1))+30;
					cnp->anim_entry->LOutput->offsety=0;
					cnp->anim_entry->LOutput->velocity=(relRect.GetRight()-(int)floor(min(dispx0,dispx1))+30)/10;
					break;
				case DIR_LEFT:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=relRect.GetLeft()-(int)floor(max(dispx0,dispx1))-30;
					cnp->anim_entry->LOutput->offsety=0;
					cnp->anim_entry->LOutput->velocity=(relRect.GetLeft()-(int)floor(max(dispx0,dispx1))-30)/10;
					break;
				case DIR_TOP:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=relRect.GetTop()-(int)floor(max(dispy0,dispy1))-30;
					cnp->anim_entry->LOutput->velocity=(relRect.GetTop()-(int)floor(max(dispy0,dispy1))-30)/10;
					break;
				case DIR_BOTTOM:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=relRect.GetBottom()-(int)floor(min(dispy0,dispy1))+30;
					cnp->anim_entry->LOutput->velocity=(relRect.GetBottom()-(int)floor(min(dispy0,dispy1))+30)/10;
					break;
				}
			}
			else{
				switch(cnp->anim_direction){
				case DIR_FADE:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=0;
					break;
				case DIR_RIGHT:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=0;
					cnp->anim_entry->LOutput->velocity=(relRect.GetRight()-(int)floor(min(dispx0,dispx1))+30)/10;
					break;
				case DIR_LEFT:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=0;
					cnp->anim_entry->LOutput->velocity=(relRect.GetLeft()-(int)floor(max(dispx0,dispx1))-30)/10;
					break;
				case DIR_TOP:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=0;
					cnp->anim_entry->LOutput->velocity=(relRect.GetTop()-(int)floor(max(dispy0,dispy1))-30)/10;
					break;
				case DIR_BOTTOM:
					cnp->anim_entry->LOutput->vanishing=0;
					cnp->anim_entry->LOutput->offsetx=0;
					cnp->anim_entry->LOutput->offsety=0;
					cnp->anim_entry->LOutput->velocity=(relRect.GetBottom()-(int)floor(min(dispy0,dispy1))+30)/10;
					break;
				}
			}
		break;	
	case CONST_EFFECT_TEXT:
		PrepareDC(pDC);
		m_owner->PrepareDC(pDC);
		GetMultiTextSize(cnp->anim_entry->TextOutput->str,(wxMemoryDC*) &pDC, &length, &height);
		cnp->anim_entry->TextOutput->hilighted=false;
		anim_cn=cnp;
		if(cnp->anim_click==1){
			anim_wait=true;
		}
		else{
			anim_wait=false;
		}
		cnp->anim_entry->TextOutput->expand=1.0;
		cnp->anim_entry->TextOutput->interval=0.2;
		if(cnp->anim_inout==0){
			switch(cnp->anim_direction){
			case DIR_FADE:
				cnp->anim_entry->TextOutput->vanishing=4;
				cnp->anim_entry->TextOutput->offsety=0;
				cnp->anim_entry->TextOutput->offsetx=0;
				break;
			case DIR_RIGHT:
				cnp->anim_entry->TextOutput->vanishing=0;
				cnp->anim_entry->TextOutput->offsetx=relRect.GetRight()-cnp->anim_entry->TextOutput->tx+30;
				cnp->anim_entry->TextOutput->offsety=0;
				cnp->anim_entry->TextOutput->velocity=(relRect.GetRight()-cnp->anim_entry->TextOutput->tx+30)/10;
				break;
			case DIR_LEFT:
				cnp->anim_entry->TextOutput->vanishing=0;
				cnp->anim_entry->TextOutput->offsetx=relRect.GetLeft()-cnp->anim_entry->TextOutput->tx-length-30;
				cnp->anim_entry->TextOutput->offsety=0;
				cnp->anim_entry->TextOutput->velocity=(relRect.GetLeft()-cnp->anim_entry->TextOutput->tx-length-30)/10;
				break;
			case DIR_TOP:
				cnp->anim_entry->TextOutput->vanishing=0;
				cnp->anim_entry->TextOutput->offsetx=0;
				cnp->anim_entry->TextOutput->offsety=relRect.GetTop()-cnp->anim_entry->TextOutput->ty-height-30;
				cnp->anim_entry->TextOutput->velocity=(relRect.GetTop()-cnp->anim_entry->TextOutput->ty-height-30)/10;
				break;
			case DIR_BOTTOM:
				cnp->anim_entry->TextOutput->vanishing=0;
				cnp->anim_entry->TextOutput->offsetx=0;
				cnp->anim_entry->TextOutput->offsety=relRect.GetBottom()-cnp->anim_entry->TextOutput->ty+30;
				cnp->anim_entry->TextOutput->velocity=(relRect.GetBottom()-cnp->anim_entry->TextOutput->ty+30)/10;
				break;
			}
		}
		else{
			switch(cnp->anim_direction){
			case DIR_FADE:
				cnp->anim_entry->TextOutput->vanishing=0;
				cnp->anim_entry->TextOutput->offsety=0;
				cnp->anim_entry->TextOutput->offsetx=0;
				break;
			case DIR_RIGHT:
				cnp->anim_entry->TextOutput->vanishing=0;
				cnp->anim_entry->TextOutput->offsety=0;
				cnp->anim_entry->TextOutput->offsetx=0;
				cnp->anim_entry->TextOutput->velocity=(relRect.GetRight()-cnp->anim_entry->TextOutput->tx+30)/10;
				break;
			case DIR_LEFT:
				cnp->anim_entry->TextOutput->vanishing=0;
				cnp->anim_entry->TextOutput->offsetx=0;
				cnp->anim_entry->TextOutput->offsety=0;
				cnp->anim_entry->TextOutput->velocity=(relRect.GetLeft()-cnp->anim_entry->TextOutput->tx-length-30)/10;
				break;
			case DIR_TOP:
				cnp->anim_entry->TextOutput->vanishing=0;
				cnp->anim_entry->TextOutput->offsetx=0;
				cnp->anim_entry->TextOutput->offsety=0;
				cnp->anim_entry->TextOutput->velocity=(relRect.GetTop()-cnp->anim_entry->TextOutput->ty-height-30)/10;
				break;
			case DIR_BOTTOM:
				cnp->anim_entry->TextOutput->vanishing=0;
				cnp->anim_entry->TextOutput->offsetx=0;
				cnp->anim_entry->TextOutput->offsety=0;
				cnp->anim_entry->TextOutput->velocity=(relRect.GetBottom()-cnp->anim_entry->TextOutput->ty+30)/10;
				break;
			}
		}
		break;
	case CONST_EFFECT_CIRCLE:
		cnp->anim_entry->COutput->hilighted=false;
		anim_cn=cnp;
		if(cnp->anim_click==1){
			anim_wait=true;
		}
		else{
			anim_wait=false;
		}
		x=centerx+(int)floor((cnp->anim_entry->COutput->xx.real()-geomcx)/geomperdot);
		y=centery-(int)floor((cnp->anim_entry->COutput->yy.real()-geomcy)/geomperdot);
		r=(int)floor(cnp->anim_entry->COutput->rr.real()/geomperdot);
		cnp->anim_entry->COutput->expand=1.0;
		cnp->anim_entry->COutput->interval=0.2;
		if(cnp->anim_inout==0){
			switch(cnp->anim_direction){
			case DIR_FADE:
				cnp->anim_entry->COutput->vanishing=4;
				cnp->anim_entry->COutput->offsetx=0;
				cnp->anim_entry->COutput->offsety=0;
				break;
			case DIR_RIGHT:
				cnp->anim_entry->COutput->vanishing=0;
				cnp->anim_entry->COutput->offsetx=relRect.GetRight()-x+r+30;
				cnp->anim_entry->COutput->offsety=0;
				cnp->anim_entry->COutput->velocity=(relRect.GetRight()-x+r+30)/10;
				break;
			case DIR_LEFT:
				cnp->anim_entry->COutput->vanishing=0;
				cnp->anim_entry->COutput->offsetx=relRect.GetLeft()-x-r-30;
				cnp->anim_entry->COutput->offsety=0;
				cnp->anim_entry->COutput->velocity=(relRect.GetLeft()-x-r-30)/10;
				break;
			case DIR_TOP:
				cnp->anim_entry->COutput->vanishing=0;
				cnp->anim_entry->COutput->offsetx=0;
				cnp->anim_entry->COutput->offsety=relRect.GetTop()-y-r-30;
				cnp->anim_entry->COutput->velocity=(relRect.GetTop()-y-r-30)/10;
				break;
			case DIR_BOTTOM:
				cnp->anim_entry->COutput->vanishing=0;
				cnp->anim_entry->COutput->offsetx=0;
				cnp->anim_entry->COutput->offsety=relRect.GetBottom()-y+r+30;
				cnp->anim_entry->COutput->velocity=(relRect.GetBottom()-y+r+30)/10;
				break;
			}
		}
		else{
			switch(cnp->anim_direction){
			case DIR_FADE:
				cnp->anim_entry->COutput->vanishing=0;
				cnp->anim_entry->COutput->offsetx=0;
				break;
			case DIR_RIGHT:
				cnp->anim_entry->COutput->vanishing=0;
				cnp->anim_entry->COutput->offsetx=0;
				cnp->anim_entry->COutput->offsety=0;
				cnp->anim_entry->COutput->velocity=(relRect.GetRight()-x+r+30)/10;
				break;
			case DIR_LEFT:
				cnp->anim_entry->COutput->vanishing=0;
				cnp->anim_entry->COutput->offsetx=0;
				cnp->anim_entry->COutput->offsety=0;
				cnp->anim_entry->COutput->velocity=(relRect.GetLeft()-x-r-30)/10;
				break;
			case DIR_TOP:
				cnp->anim_entry->COutput->vanishing=0;
				cnp->anim_entry->COutput->offsetx=0;
				cnp->anim_entry->COutput->offsety=0;
				cnp->anim_entry->COutput->velocity=(relRect.GetTop()-y-r-30)/10;
				break;
			case DIR_BOTTOM:
				cnp->anim_entry->COutput->vanishing=0;
				cnp->anim_entry->COutput->offsetx=0;
				cnp->anim_entry->COutput->offsety=0;
				cnp->anim_entry->COutput->velocity=(relRect.GetBottom()-y+r+30)/10;
				break;
			}
		}
		break;	
	case CONST_EFFECT_CURVE:
		break;
	}
}

void MyCanvas::Animnext()
{
	double geomx;
	double geomy;
	double dispx0;
	double dispy0;
	double dispx1;
	double dispy1;
	int dispx;
	int dispy;
	int length,height;
	int x,y,r;
	wxPaintDC pDC(this);
	if(anim_cn==NULL){
		if(NextSheet()){
			anim_cn=NULL;
			SlideShowStart(cns);
			anim_wait=false;
		}
		else {
			SMode=false;
			anim_cn=NULL;
			wxStartTimer();
			do {;
			} while (wxGetElapsedTime(false)<1000);
			wxMessageBox(EndSlideShow,wxT(""),wxOK | wxICON_INFORMATION, this);
		}
		return;
	}
	switch(anim_cn->Const_Type){
	case CONST_EFFECT_POINT:
		geomx=anim_cn->anim_entry->POutput->xz().real();
		geomy=anim_cn->anim_entry->POutput->yz().real();
		dispx=centerx+(int)floor((geomx-geomcx)/geomperdot);
		dispy=centery-(int)floor((geomy-geomcy)/geomperdot);
		if(anim_cn->anim_inout==0){
			switch(anim_cn->anim_direction){
			case DIR_FADE:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->POutput->vanishing --;
					if(anim_cn->anim_entry->POutput->vanishing <= 0){
						anim_cn->anim_entry->POutput->vanishing = 0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->POutput->vanishing > 0){
						anim_cn->anim_entry->POutput->vanishing --;
					}
					else {
						anim_cn->anim_entry->POutput->vanishing = 0;
						anim_cn->anim_entry->POutput->expand += anim_cn->anim_entry->POutput->interval;
						if(anim_cn->anim_entry->POutput->expand>=2.0){
							anim_cn->anim_entry->POutput->interval *= -1;
						}
						if(anim_cn->anim_entry->POutput->expand <= 1.0 && anim_cn->anim_entry->POutput->interval <0){
							anim_cn->anim_entry->POutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_RIGHT:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->POutput->offsetx-=anim_cn->anim_entry->POutput->velocity;
					if(anim_cn->anim_entry->POutput->offsetx<0){
						anim_cn->anim_entry->POutput->offsetx=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->POutput->offsetx>0){
						anim_cn->anim_entry->POutput->offsetx-=anim_cn->anim_entry->POutput->velocity;
						if(anim_cn->anim_entry->POutput->offsetx<0){
							anim_cn->anim_entry->POutput->offsetx=0;
						}
					}
					else {
						anim_cn->anim_entry->POutput->offsetx=0;
						anim_cn->anim_entry->POutput->expand += anim_cn->anim_entry->POutput->interval;
						if(anim_cn->anim_entry->POutput->expand>=2.0){
							anim_cn->anim_entry->POutput->interval *= -1;
						}
						if(anim_cn->anim_entry->POutput->expand <= 1.0 && anim_cn->anim_entry->POutput->interval <0){
							anim_cn->anim_entry->POutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_LEFT:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->POutput->offsetx-=anim_cn->anim_entry->POutput->velocity;
					if(anim_cn->anim_entry->POutput->offsetx>0){
						anim_cn->anim_entry->POutput->offsetx=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->POutput->offsetx<0){
						anim_cn->anim_entry->POutput->offsetx-=anim_cn->anim_entry->POutput->velocity;
						if(anim_cn->anim_entry->POutput->offsetx>0){
							anim_cn->anim_entry->POutput->offsetx=0;
						}
					}
					else {
						anim_cn->anim_entry->POutput->offsetx=0;
						anim_cn->anim_entry->POutput->expand += anim_cn->anim_entry->POutput->interval;
						if(anim_cn->anim_entry->POutput->expand>=2.0){
							anim_cn->anim_entry->POutput->interval *= -1;
						}
						if(anim_cn->anim_entry->POutput->expand <= 1.0 && anim_cn->anim_entry->POutput->interval <0){
							anim_cn->anim_entry->POutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_TOP:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->POutput->offsety-=anim_cn->anim_entry->POutput->velocity;
					if(anim_cn->anim_entry->POutput->offsety>0){
						anim_cn->anim_entry->POutput->offsety=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->POutput->offsety<0){
						anim_cn->anim_entry->POutput->offsety -= anim_cn->anim_entry->POutput->velocity;
						if(anim_cn->anim_entry->POutput->offsety>0){
							anim_cn->anim_entry->POutput->offsety=0;
						}
					}
					else {
						anim_cn->anim_entry->POutput->offsety=0;
						anim_cn->anim_entry->POutput->expand += anim_cn->anim_entry->POutput->interval;
						if(anim_cn->anim_entry->POutput->expand>=2.0){
							anim_cn->anim_entry->POutput->interval *= -1;
						}
						if(anim_cn->anim_entry->POutput->expand <= 1.0 && anim_cn->anim_entry->POutput->interval <0){
							anim_cn->anim_entry->POutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_BOTTOM:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->POutput->offsety-=anim_cn->anim_entry->POutput->velocity;
					if(anim_cn->anim_entry->POutput->offsety<0){
						anim_cn->anim_entry->POutput->offsety=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->POutput->offsety>0){
						anim_cn->anim_entry->POutput->offsety -= anim_cn->anim_entry->POutput->velocity;
						if(anim_cn->anim_entry->POutput->offsety<0){
							anim_cn->anim_entry->POutput->offsety=0;
						}
					}
					else {
						anim_cn->anim_entry->POutput->offsety=0;
						anim_cn->anim_entry->POutput->expand += anim_cn->anim_entry->POutput->interval;
						if(anim_cn->anim_entry->POutput->expand>=2.0){
							anim_cn->anim_entry->POutput->interval *= -1;
						}
						if(anim_cn->anim_entry->POutput->expand <= 1.0 && anim_cn->anim_entry->POutput->interval <0){
							anim_cn->anim_entry->POutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			}
		}
		else{
			switch(anim_cn->anim_direction){
			case DIR_FADE:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->POutput->vanishing>0){
					anim_cn->anim_entry->POutput->vanishing ++;
					if(anim_cn->anim_entry->POutput->vanishing >= 5){
						anim_cn->anim_entry->POutput->vanishing = 5;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->POutput->expand += anim_cn->anim_entry->POutput->interval;
					if(anim_cn->anim_entry->POutput->expand>=2.0){
						anim_cn->anim_entry->POutput->interval *= -1;
					}
					if(anim_cn->anim_entry->POutput->expand <= 1.0 && anim_cn->anim_entry->POutput->interval <0){
						anim_cn->anim_entry->POutput->expand=1.0;
						anim_cn->anim_entry->POutput->vanishing=1;
					}
				}
				break;
			case DIR_RIGHT:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->POutput->offsetx>0){
					anim_cn->anim_entry->POutput->offsetx += anim_cn->anim_entry->POutput->velocity;
					if(anim_cn->anim_entry->POutput->offsetx > relRect.GetRight()-dispx+30){
						anim_cn->anim_entry->POutput->offsetx = relRect.GetRight()-dispx+30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->POutput->expand += anim_cn->anim_entry->POutput->interval;
					if(anim_cn->anim_entry->POutput->expand>=2.0){
						anim_cn->anim_entry->POutput->interval *= -1;
					}
					if(anim_cn->anim_entry->POutput->expand <= 1.0 && anim_cn->anim_entry->POutput->interval <0){
						anim_cn->anim_entry->POutput->expand = 1.0;
						anim_cn->anim_entry->POutput->offsetx = anim_cn->anim_entry->POutput->velocity;
					}
				}
				break;
			case DIR_LEFT:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->POutput->offsetx < 0){
					anim_cn->anim_entry->POutput->offsetx+=anim_cn->anim_entry->POutput->velocity;
					if(anim_cn->anim_entry->POutput->offsetx<relRect.GetLeft()-dispx-30){
						anim_cn->anim_entry->POutput->offsetx=relRect.GetLeft()-dispx-30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->POutput->expand += anim_cn->anim_entry->POutput->interval;
					if(anim_cn->anim_entry->POutput->expand>=2.0){
						anim_cn->anim_entry->POutput->interval *= -1;
					}
					if(anim_cn->anim_entry->POutput->expand <= 1.0 && anim_cn->anim_entry->POutput->interval <0){
						anim_cn->anim_entry->POutput->expand = 1.0;
						anim_cn->anim_entry->POutput->offsetx = anim_cn->anim_entry->POutput->velocity;
					}
				}
				break;
			case DIR_TOP:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->POutput->offsety < 0){
					anim_cn->anim_entry->POutput->offsety += anim_cn->anim_entry->POutput->velocity;
					if(anim_cn->anim_entry->POutput->offsety < relRect.GetTop()-dispy-30){
						anim_cn->anim_entry->POutput->offsety = relRect.GetTop()-dispy-30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->POutput->expand += anim_cn->anim_entry->POutput->interval;
					if(anim_cn->anim_entry->POutput->expand>=2.0){
						anim_cn->anim_entry->POutput->interval *= -1;
					}
					if(anim_cn->anim_entry->POutput->expand <= 1.0 && anim_cn->anim_entry->POutput->interval <0){
						anim_cn->anim_entry->POutput->expand = 1.0;
						anim_cn->anim_entry->POutput->offsety = anim_cn->anim_entry->POutput->velocity;
					}
				}
				break;
			case DIR_BOTTOM:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->POutput->offsety > 0){
					anim_cn->anim_entry->POutput->offsety+=anim_cn->anim_entry->POutput->velocity;
					if(anim_cn->anim_entry->POutput->offsety>relRect.GetBottom()-dispy+30){
						anim_cn->anim_entry->POutput->offsety=relRect.GetBottom()-dispy+30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->POutput->expand += anim_cn->anim_entry->POutput->interval;
					if(anim_cn->anim_entry->POutput->expand>=2.0){
						anim_cn->anim_entry->POutput->interval *= -1;
					}
					if(anim_cn->anim_entry->POutput->expand <= 1.0 && anim_cn->anim_entry->POutput->interval <0){
						anim_cn->anim_entry->POutput->expand = 1.0;
						anim_cn->anim_entry->POutput->offsety = anim_cn->anim_entry->POutput->velocity;
					}
				}
				break;
			}
		}
		break;
	case CONST_EFFECT_LINE:
		GetGeomXY(anim_cn->anim_entry->LOutput, &dispx0, &dispy0, &dispx1, &dispy1);
		if(anim_cn->anim_inout==0){
			switch(anim_cn->anim_direction){
			case DIR_FADE:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->LOutput->vanishing --;
					if(anim_cn->anim_entry->LOutput->vanishing <= 0){
						anim_cn->anim_entry->LOutput->vanishing = 0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->LOutput->vanishing > 0){
						anim_cn->anim_entry->LOutput->vanishing --;
					}
					else {
						anim_cn->anim_entry->LOutput->vanishing = 0;
						anim_cn->anim_entry->LOutput->expand += anim_cn->anim_entry->LOutput->interval;
						if(anim_cn->anim_entry->LOutput->expand>=2.0){
							anim_cn->anim_entry->LOutput->interval *= -1;
						}
						if(anim_cn->anim_entry->LOutput->expand <= 1.0 && anim_cn->anim_entry->LOutput->interval <0){
							anim_cn->anim_entry->LOutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_RIGHT:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->LOutput->offsetx-=anim_cn->anim_entry->LOutput->velocity;
					if(anim_cn->anim_entry->LOutput->offsetx<0){
						anim_cn->anim_entry->LOutput->offsetx=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->LOutput->offsetx>0){
						anim_cn->anim_entry->LOutput->offsetx-=anim_cn->anim_entry->LOutput->velocity;
						if(anim_cn->anim_entry->LOutput->offsetx<=0){
							anim_cn->anim_entry->LOutput->offsetx=0;
						}
					}
					else {
						anim_cn->anim_entry->LOutput->offsetx=0;
						anim_cn->anim_entry->LOutput->expand += anim_cn->anim_entry->LOutput->interval;
						if(anim_cn->anim_entry->LOutput->expand>=2.0){
							anim_cn->anim_entry->LOutput->interval *= -1;
						}
						if(anim_cn->anim_entry->LOutput->expand <= 1.0 && anim_cn->anim_entry->LOutput->interval <0){
							anim_cn->anim_entry->LOutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_LEFT:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->LOutput->offsetx-=anim_cn->anim_entry->LOutput->velocity;
					if(anim_cn->anim_entry->LOutput->offsetx>0){
						anim_cn->anim_entry->LOutput->offsetx=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->LOutput->offsetx<0){
						anim_cn->anim_entry->LOutput->offsetx-=anim_cn->anim_entry->LOutput->velocity;
						if(anim_cn->anim_entry->LOutput->offsetx>0){
							anim_cn->anim_entry->LOutput->offsetx=0;
						}
					}
					else {
						anim_cn->anim_entry->LOutput->offsetx=0;
						anim_cn->anim_entry->LOutput->expand += anim_cn->anim_entry->LOutput->interval;
						if(anim_cn->anim_entry->LOutput->expand>=2.0){
							anim_cn->anim_entry->LOutput->interval *= -1;
						}
						if(anim_cn->anim_entry->LOutput->expand <= 1.0 && anim_cn->anim_entry->LOutput->interval <0){
							anim_cn->anim_entry->LOutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_TOP:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->LOutput->offsety-=anim_cn->anim_entry->LOutput->velocity;
					if(anim_cn->anim_entry->LOutput->offsety>0){
						anim_cn->anim_entry->LOutput->offsety=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->LOutput->offsety<0){
						anim_cn->anim_entry->LOutput->offsety -= anim_cn->anim_entry->LOutput->velocity;
						if(anim_cn->anim_entry->LOutput->offsety>0){
							anim_cn->anim_entry->LOutput->offsety=0;
						}
					}
					else {
						anim_cn->anim_entry->LOutput->offsety=0;
						anim_cn->anim_entry->LOutput->expand += anim_cn->anim_entry->LOutput->interval;
						if(anim_cn->anim_entry->LOutput->expand>=2.0){
							anim_cn->anim_entry->LOutput->interval *= -1;
						}
						if(anim_cn->anim_entry->LOutput->expand <= 1.0 && anim_cn->anim_entry->LOutput->interval <0){
							anim_cn->anim_entry->LOutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_BOTTOM:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->LOutput->offsety-=anim_cn->anim_entry->LOutput->velocity;
					if(anim_cn->anim_entry->LOutput->offsety<0){
						anim_cn->anim_entry->LOutput->offsety=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->LOutput->offsety>0){
						anim_cn->anim_entry->LOutput->offsety -= anim_cn->anim_entry->LOutput->velocity;
						if(anim_cn->anim_entry->LOutput->offsety<0){
							anim_cn->anim_entry->LOutput->offsety=0;
						}
					}
					else {
						anim_cn->anim_entry->LOutput->offsety=0;
						anim_cn->anim_entry->LOutput->expand += anim_cn->anim_entry->LOutput->interval;
						if(anim_cn->anim_entry->LOutput->expand>=2.0){
							anim_cn->anim_entry->LOutput->interval *= -1;
						}
						if(anim_cn->anim_entry->LOutput->expand <= 1.0 && anim_cn->anim_entry->LOutput->interval <0){
							anim_cn->anim_entry->LOutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			}
		}
		else{
			switch(anim_cn->anim_direction){
			case DIR_FADE:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->LOutput->vanishing>0){
					anim_cn->anim_entry->LOutput->vanishing ++;
					if(anim_cn->anim_entry->LOutput->vanishing >= 5){
						anim_cn->anim_entry->LOutput->vanishing = 5;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->LOutput->expand += anim_cn->anim_entry->LOutput->interval;
					if(anim_cn->anim_entry->LOutput->expand>=2.0){
						anim_cn->anim_entry->LOutput->interval *= -1;
					}
					if(anim_cn->anim_entry->LOutput->expand <= 1.0 && anim_cn->anim_entry->LOutput->interval <0){
						anim_cn->anim_entry->LOutput->expand=1.0;
						anim_cn->anim_entry->LOutput->vanishing=1;
					}
				}
				break;
			case DIR_RIGHT:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->LOutput->offsetx>0){
					anim_cn->anim_entry->LOutput->offsetx += anim_cn->anim_entry->LOutput->velocity;
					if(anim_cn->anim_entry->LOutput->offsetx > relRect.GetRight()-(int)floor(min(dispx0,dispx1))+30){
						anim_cn->anim_entry->LOutput->offsetx = relRect.GetRight()-(int)floor(min(dispx0,dispx1))+30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->LOutput->expand += anim_cn->anim_entry->LOutput->interval;
					if(anim_cn->anim_entry->LOutput->expand>=2.0){
						anim_cn->anim_entry->LOutput->interval *= -1;
					}
					if(anim_cn->anim_entry->LOutput->expand <= 1.0 && anim_cn->anim_entry->LOutput->interval <0){
						anim_cn->anim_entry->LOutput->expand = 1.0;
						anim_cn->anim_entry->LOutput->offsetx = anim_cn->anim_entry->LOutput->velocity;
					}
				}
				break;
			case DIR_LEFT:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->LOutput->offsetx < 0){
					anim_cn->anim_entry->LOutput->offsetx+=anim_cn->anim_entry->LOutput->velocity;
					if(anim_cn->anim_entry->LOutput->offsetx<relRect.GetLeft()-(int)floor(max(dispx0,dispx1))-30){
						anim_cn->anim_entry->LOutput->offsetx=relRect.GetLeft()-(int)floor(max(dispx0,dispx1))-30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->LOutput->expand += anim_cn->anim_entry->LOutput->interval;
					if(anim_cn->anim_entry->LOutput->expand>=2.0){
						anim_cn->anim_entry->LOutput->interval *= -1;
					}
					if(anim_cn->anim_entry->LOutput->expand <= 1.0 && anim_cn->anim_entry->LOutput->interval <0){
						anim_cn->anim_entry->LOutput->expand = 1.0;
						anim_cn->anim_entry->LOutput->offsetx = anim_cn->anim_entry->LOutput->velocity;
					}
				}
				break;
			case DIR_TOP:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->LOutput->offsety < 0){
					anim_cn->anim_entry->LOutput->offsety += anim_cn->anim_entry->LOutput->velocity;
					if(anim_cn->anim_entry->LOutput->offsety < relRect.GetTop()-(int)floor(max(dispy0,dispy1))-30){
						anim_cn->anim_entry->LOutput->offsety = relRect.GetTop()-(int)floor(max(dispy0,dispy1))-30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->LOutput->expand += anim_cn->anim_entry->LOutput->interval;
					if(anim_cn->anim_entry->LOutput->expand>=2.0){
						anim_cn->anim_entry->LOutput->interval *= -1;
					}
					if(anim_cn->anim_entry->LOutput->expand <= 1.0 && anim_cn->anim_entry->LOutput->interval <0){
						anim_cn->anim_entry->LOutput->expand = 1.0;
						anim_cn->anim_entry->LOutput->offsety = anim_cn->anim_entry->LOutput->velocity;
					}
				}
				break;
			case DIR_BOTTOM:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->LOutput->offsety > 0){
					anim_cn->anim_entry->LOutput->offsety+=anim_cn->anim_entry->LOutput->velocity;
					if(anim_cn->anim_entry->LOutput->offsety>relRect.GetBottom()-(int)floor(min(dispy0,dispy1))+30){
						anim_cn->anim_entry->LOutput->offsety=relRect.GetBottom()-(int)floor(min(dispy0,dispy1))+30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->LOutput->expand += anim_cn->anim_entry->LOutput->interval;
					if(anim_cn->anim_entry->LOutput->expand>=2.0){
						anim_cn->anim_entry->LOutput->interval *= -1;
					}
					if(anim_cn->anim_entry->LOutput->expand <= 1.0 && anim_cn->anim_entry->LOutput->interval <0){
						anim_cn->anim_entry->LOutput->expand = 1.0;
						anim_cn->anim_entry->LOutput->offsety = anim_cn->anim_entry->LOutput->velocity;
					}
				}
				break;
			}
		}
		break;	
	case CONST_EFFECT_TEXT:
		PrepareDC(pDC);
		m_owner->PrepareDC(pDC);
		GetMultiTextSize(anim_cn->anim_entry->TextOutput->str,(wxMemoryDC*) &pDC, &length, &height);
		if(anim_cn->anim_inout==0){
			switch(anim_cn->anim_direction){
			case DIR_FADE:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->TextOutput->vanishing --;
					if(anim_cn->anim_entry->TextOutput->vanishing <= 0){
						anim_cn->anim_entry->TextOutput->vanishing = 0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->TextOutput->vanishing > 0){
						anim_cn->anim_entry->TextOutput->vanishing --;
					}
					else {
						anim_cn->anim_entry->TextOutput->vanishing = 0;
						anim_cn->anim_entry->TextOutput->expand += anim_cn->anim_entry->TextOutput->interval;
						if(anim_cn->anim_entry->TextOutput->expand>=2.0){
							anim_cn->anim_entry->TextOutput->interval *= -1;
						}
						if(anim_cn->anim_entry->TextOutput->expand <= 1.0 && anim_cn->anim_entry->TextOutput->interval <0){
							anim_cn->anim_entry->TextOutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_RIGHT:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->TextOutput->offsetx-=anim_cn->anim_entry->TextOutput->velocity;
					if(anim_cn->anim_entry->TextOutput->offsetx<0){
						anim_cn->anim_entry->TextOutput->offsetx=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->TextOutput->offsetx>0){
						anim_cn->anim_entry->TextOutput->offsetx-=anim_cn->anim_entry->TextOutput->velocity;
						if(anim_cn->anim_entry->TextOutput->offsetx<0){
							anim_cn->anim_entry->TextOutput->offsetx=0;
						}
					}
					else {
						anim_cn->anim_entry->TextOutput->offsetx=0;
						anim_cn->anim_entry->TextOutput->expand += anim_cn->anim_entry->TextOutput->interval;
						if(anim_cn->anim_entry->TextOutput->expand>=2.0){
							anim_cn->anim_entry->TextOutput->interval *= -1;
						}
						if(anim_cn->anim_entry->TextOutput->expand <= 1.0 && anim_cn->anim_entry->TextOutput->interval <0){
							anim_cn->anim_entry->TextOutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_LEFT:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->TextOutput->offsetx-=anim_cn->anim_entry->TextOutput->velocity;
					if(anim_cn->anim_entry->TextOutput->offsetx>0){
						anim_cn->anim_entry->TextOutput->offsetx=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->TextOutput->offsetx<0){
						anim_cn->anim_entry->TextOutput->offsetx-=anim_cn->anim_entry->TextOutput->velocity;
						if(anim_cn->anim_entry->TextOutput->offsetx>0){
							anim_cn->anim_entry->TextOutput->offsetx=0;
						}
					}
					else {
						anim_cn->anim_entry->TextOutput->offsetx=0;
						anim_cn->anim_entry->TextOutput->expand += anim_cn->anim_entry->TextOutput->interval;
						if(anim_cn->anim_entry->TextOutput->expand>=2.0){
							anim_cn->anim_entry->TextOutput->interval *= -1;
						}
						if(anim_cn->anim_entry->TextOutput->expand <= 1.0 && anim_cn->anim_entry->TextOutput->interval <0){
							anim_cn->anim_entry->TextOutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_TOP:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->TextOutput->offsety-=anim_cn->anim_entry->TextOutput->velocity;
					if(anim_cn->anim_entry->TextOutput->offsety>0){
						anim_cn->anim_entry->TextOutput->offsety=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->TextOutput->offsety<0){
						anim_cn->anim_entry->TextOutput->offsety -= anim_cn->anim_entry->TextOutput->velocity;
						if(anim_cn->anim_entry->TextOutput->offsety>0){
							anim_cn->anim_entry->TextOutput->offsety=0;
						}
					}
					else {
						anim_cn->anim_entry->TextOutput->offsety=0;
						anim_cn->anim_entry->TextOutput->expand += anim_cn->anim_entry->TextOutput->interval;
						if(anim_cn->anim_entry->TextOutput->expand>=2.0){
							anim_cn->anim_entry->TextOutput->interval *= -1;
						}
						if(anim_cn->anim_entry->TextOutput->expand <= 1.0 && anim_cn->anim_entry->TextOutput->interval <0){
							anim_cn->anim_entry->TextOutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_BOTTOM:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->TextOutput->offsety-=anim_cn->anim_entry->TextOutput->velocity;
					if(anim_cn->anim_entry->TextOutput->offsety<0){
						anim_cn->anim_entry->TextOutput->offsety=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->TextOutput->offsety>0){
						anim_cn->anim_entry->TextOutput->offsety -= anim_cn->anim_entry->TextOutput->velocity;
						if(anim_cn->anim_entry->TextOutput->offsety<0){
							anim_cn->anim_entry->TextOutput->offsety=0;
						}
					}
					else {
						anim_cn->anim_entry->TextOutput->offsety=0;
						anim_cn->anim_entry->TextOutput->expand += anim_cn->anim_entry->TextOutput->interval;
						if(anim_cn->anim_entry->TextOutput->expand>=2.0){
							anim_cn->anim_entry->TextOutput->interval *= -1;
						}
						if(anim_cn->anim_entry->TextOutput->expand <= 1.0 && anim_cn->anim_entry->TextOutput->interval <0){
							anim_cn->anim_entry->TextOutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			}
		}
		else{
			switch(anim_cn->anim_direction){
			case DIR_FADE:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->TextOutput->vanishing>0){
					anim_cn->anim_entry->TextOutput->vanishing ++;
					if(anim_cn->anim_entry->TextOutput->vanishing >= 5){
						anim_cn->anim_entry->TextOutput->vanishing = 5;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->TextOutput->expand += anim_cn->anim_entry->TextOutput->interval;
					if(anim_cn->anim_entry->TextOutput->expand>=2.0){
						anim_cn->anim_entry->TextOutput->interval *= -1;
					}
					if(anim_cn->anim_entry->TextOutput->expand <= 1.0 && anim_cn->anim_entry->TextOutput->interval <0){
						anim_cn->anim_entry->TextOutput->expand=1.0;
						anim_cn->anim_entry->TextOutput->vanishing=1;
					}
				}
				break;
			case DIR_RIGHT:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->TextOutput->offsetx>0){
					anim_cn->anim_entry->TextOutput->offsetx += anim_cn->anim_entry->TextOutput->velocity;
					if(anim_cn->anim_entry->TextOutput->offsetx > relRect.GetRight()-anim_cn->anim_entry->TextOutput->tx+30){
						anim_cn->anim_entry->TextOutput->offsetx = relRect.GetRight()-anim_cn->anim_entry->TextOutput->tx+30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->TextOutput->expand += anim_cn->anim_entry->TextOutput->interval;
					if(anim_cn->anim_entry->TextOutput->expand>=2.0){
						anim_cn->anim_entry->TextOutput->interval *= -1;
					}
					if(anim_cn->anim_entry->TextOutput->expand <= 1.0 && anim_cn->anim_entry->TextOutput->interval <0){
						anim_cn->anim_entry->TextOutput->expand = 1.0;
						anim_cn->anim_entry->TextOutput->offsetx = anim_cn->anim_entry->TextOutput->velocity;
					}
				}
				break;
			case DIR_LEFT:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->TextOutput->offsetx < 0){
					anim_cn->anim_entry->TextOutput->offsetx+=anim_cn->anim_entry->TextOutput->velocity;
					if(anim_cn->anim_entry->TextOutput->offsetx<relRect.GetLeft()-anim_cn->anim_entry->TextOutput->tx-length-30){
						anim_cn->anim_entry->TextOutput->offsetx=relRect.GetLeft()-anim_cn->anim_entry->TextOutput->tx-length-30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->TextOutput->expand += anim_cn->anim_entry->TextOutput->interval;
					if(anim_cn->anim_entry->TextOutput->expand>=2.0){
						anim_cn->anim_entry->TextOutput->interval *= -1;
					}
					if(anim_cn->anim_entry->TextOutput->expand <= 1.0 && anim_cn->anim_entry->TextOutput->interval <0){
						anim_cn->anim_entry->TextOutput->expand = 1.0;
						anim_cn->anim_entry->TextOutput->offsetx = anim_cn->anim_entry->TextOutput->velocity;
					}
				}
				break;
			case DIR_TOP:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->TextOutput->offsety < 0){
					anim_cn->anim_entry->TextOutput->offsety += anim_cn->anim_entry->TextOutput->velocity;
					if(anim_cn->anim_entry->TextOutput->offsety < relRect.GetTop()-anim_cn->anim_entry->TextOutput->ty-height-30){
						anim_cn->anim_entry->TextOutput->offsety = relRect.GetTop()-anim_cn->anim_entry->TextOutput->ty-height-30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->TextOutput->expand += anim_cn->anim_entry->TextOutput->interval;
					if(anim_cn->anim_entry->TextOutput->expand>=2.0){
						anim_cn->anim_entry->TextOutput->interval *= -1;
					}
					if(anim_cn->anim_entry->TextOutput->expand <= 1.0 && anim_cn->anim_entry->TextOutput->interval <0){
						anim_cn->anim_entry->TextOutput->expand = 1.0;
						anim_cn->anim_entry->TextOutput->offsety = anim_cn->anim_entry->TextOutput->velocity;
					}
				}
				break;
			case DIR_BOTTOM:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->TextOutput->offsety > 0){
					anim_cn->anim_entry->TextOutput->offsety+=anim_cn->anim_entry->TextOutput->velocity;
					if(anim_cn->anim_entry->TextOutput->offsety>relRect.GetBottom()-anim_cn->anim_entry->TextOutput->ty+30){
						anim_cn->anim_entry->TextOutput->offsety=relRect.GetBottom()-anim_cn->anim_entry->TextOutput->ty+30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->TextOutput->expand += anim_cn->anim_entry->TextOutput->interval;
					if(anim_cn->anim_entry->TextOutput->expand>=2.0){
						anim_cn->anim_entry->TextOutput->interval *= -1;
					}
					if(anim_cn->anim_entry->TextOutput->expand <= 1.0 && anim_cn->anim_entry->TextOutput->interval <0){
						anim_cn->anim_entry->TextOutput->expand = 1.0;
						anim_cn->anim_entry->TextOutput->offsety = anim_cn->anim_entry->TextOutput->velocity;
					}
				}
				break;
			}
		}
		break;
	case CONST_EFFECT_CIRCLE:
		x=centerx+(int)floor((anim_cn->anim_entry->COutput->xx.real()-geomcx)/geomperdot);
		y=centery-(int)floor((anim_cn->anim_entry->COutput->yy.real()-geomcy)/geomperdot);
		r=(int)floor(anim_cn->anim_entry->COutput->rr.real()/geomperdot);
		if(anim_cn->anim_inout==0){
			switch(anim_cn->anim_direction){
			case DIR_FADE:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->COutput->vanishing --;
					if(anim_cn->anim_entry->COutput->vanishing <= 0){
						anim_cn->anim_entry->COutput->vanishing = 0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->COutput->vanishing > 0){
						anim_cn->anim_entry->COutput->vanishing --;
					}
					else {
						anim_cn->anim_entry->COutput->vanishing = 0;
						anim_cn->anim_entry->COutput->expand += anim_cn->anim_entry->COutput->interval;
						if(anim_cn->anim_entry->COutput->expand>=2.0){
							anim_cn->anim_entry->COutput->interval *= -1;
						}
						if(anim_cn->anim_entry->COutput->expand <= 1.0 && anim_cn->anim_entry->COutput->interval <0){
							anim_cn->anim_entry->COutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_RIGHT:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->COutput->offsetx-=anim_cn->anim_entry->COutput->velocity;
					if(anim_cn->anim_entry->COutput->offsetx<0){
						anim_cn->anim_entry->COutput->offsetx=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->COutput->offsetx>0){
						anim_cn->anim_entry->COutput->offsetx-=anim_cn->anim_entry->COutput->velocity;
						if(anim_cn->anim_entry->COutput->offsetx<=0){
							anim_cn->anim_entry->COutput->offsetx=0;
						}
					}
					else {
						anim_cn->anim_entry->COutput->offsetx=0;
						anim_cn->anim_entry->COutput->expand += anim_cn->anim_entry->COutput->interval;
						if(anim_cn->anim_entry->COutput->expand>=2.0){
							anim_cn->anim_entry->COutput->interval *= -1;
						}
						if(anim_cn->anim_entry->COutput->expand <= 1.0 && anim_cn->anim_entry->COutput->interval <0){
							anim_cn->anim_entry->COutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_LEFT:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->COutput->offsetx-=anim_cn->anim_entry->COutput->velocity;
					if(anim_cn->anim_entry->COutput->offsetx>0){
						anim_cn->anim_entry->COutput->offsetx=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->COutput->offsetx<0){
						anim_cn->anim_entry->COutput->offsetx-=anim_cn->anim_entry->COutput->velocity;
						if(anim_cn->anim_entry->COutput->offsetx>0){
							anim_cn->anim_entry->COutput->offsetx=0;
						}
					}
					else {
						anim_cn->anim_entry->COutput->offsetx=0;
						anim_cn->anim_entry->COutput->expand += anim_cn->anim_entry->COutput->interval;
						if(anim_cn->anim_entry->COutput->expand>=2.0){
							anim_cn->anim_entry->COutput->interval *= -1;
						}
						if(anim_cn->anim_entry->COutput->expand <= 1.0 && anim_cn->anim_entry->COutput->interval <0){
							anim_cn->anim_entry->COutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_TOP:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->COutput->offsety-=anim_cn->anim_entry->COutput->velocity;
					if(anim_cn->anim_entry->COutput->offsety>0){
						anim_cn->anim_entry->COutput->offsety=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->COutput->offsety<0){
						anim_cn->anim_entry->COutput->offsety -= anim_cn->anim_entry->COutput->velocity;
						if(anim_cn->anim_entry->COutput->offsety>0){
							anim_cn->anim_entry->COutput->offsety=0;
						}
					}
					else {
						anim_cn->anim_entry->COutput->offsety=0;
						anim_cn->anim_entry->COutput->expand += anim_cn->anim_entry->COutput->interval;
						if(anim_cn->anim_entry->COutput->expand>=2.0){
							anim_cn->anim_entry->COutput->interval *= -1;
						}
						if(anim_cn->anim_entry->COutput->expand <= 1.0 && anim_cn->anim_entry->COutput->interval <0){
							anim_cn->anim_entry->COutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			case DIR_BOTTOM:
				if(anim_cn->anim_effect==0){
					anim_cn->anim_entry->COutput->offsety-=anim_cn->anim_entry->COutput->velocity;
					if(anim_cn->anim_entry->COutput->offsety<0){
						anim_cn->anim_entry->COutput->offsety=0;
						FindNextEffectFromCns();
					}
				}
				else {
					if(anim_cn->anim_entry->COutput->offsety>0){
						anim_cn->anim_entry->COutput->offsety -= anim_cn->anim_entry->COutput->velocity;
						if(anim_cn->anim_entry->COutput->offsety<0){
							anim_cn->anim_entry->COutput->offsety=0;
						}
					}
					else {
						anim_cn->anim_entry->COutput->offsety=0;
						anim_cn->anim_entry->COutput->expand += anim_cn->anim_entry->COutput->interval;
						if(anim_cn->anim_entry->COutput->expand>=2.0){
							anim_cn->anim_entry->COutput->interval *= -1;
						}
						if(anim_cn->anim_entry->COutput->expand <= 1.0 && anim_cn->anim_entry->COutput->interval <0){
							anim_cn->anim_entry->COutput->expand=1.0;
							FindNextEffectFromCns();
						}
					}
				}
				break;
			}
		}
		else{
			switch(anim_cn->anim_direction){
			case DIR_FADE:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->COutput->vanishing>0){
					anim_cn->anim_entry->COutput->vanishing ++;
					if(anim_cn->anim_entry->COutput->vanishing >= 5){
						anim_cn->anim_entry->COutput->vanishing = 5;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->COutput->expand += anim_cn->anim_entry->COutput->interval;
					if(anim_cn->anim_entry->COutput->expand>=2.0){
						anim_cn->anim_entry->COutput->interval *= -1;
					}
					if(anim_cn->anim_entry->COutput->expand <= 1.0 && anim_cn->anim_entry->COutput->interval <0){
						anim_cn->anim_entry->COutput->expand=1.0;
						anim_cn->anim_entry->COutput->vanishing=1;
					}
				}
				break;
			case DIR_RIGHT:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->COutput->offsetx>0){
					anim_cn->anim_entry->COutput->offsetx += anim_cn->anim_entry->COutput->velocity;
					if(anim_cn->anim_entry->COutput->offsetx > relRect.GetRight()-x+r+30){
						anim_cn->anim_entry->COutput->offsetx = relRect.GetRight()-x+r+30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->COutput->expand += anim_cn->anim_entry->COutput->interval;
					if(anim_cn->anim_entry->COutput->expand>=2.0){
						anim_cn->anim_entry->COutput->interval *= -1;
					}
					if(anim_cn->anim_entry->COutput->expand <= 1.0 && anim_cn->anim_entry->COutput->interval <0){
						anim_cn->anim_entry->COutput->expand = 1.0;
						anim_cn->anim_entry->COutput->offsetx = anim_cn->anim_entry->COutput->velocity;
					}
				}
				break;
			case DIR_LEFT:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->COutput->offsetx < 0){
					anim_cn->anim_entry->COutput->offsetx+=anim_cn->anim_entry->COutput->velocity;
					if(anim_cn->anim_entry->COutput->offsetx<relRect.GetLeft()-x-r-30){
						anim_cn->anim_entry->COutput->offsetx=relRect.GetLeft()-x-r-30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->COutput->expand += anim_cn->anim_entry->COutput->interval;
					if(anim_cn->anim_entry->COutput->expand>=2.0){
						anim_cn->anim_entry->COutput->interval *= -1;
					}
					if(anim_cn->anim_entry->COutput->expand <= 1.0 && anim_cn->anim_entry->COutput->interval <0){
						anim_cn->anim_entry->COutput->expand = 1.0;
						anim_cn->anim_entry->COutput->offsetx = anim_cn->anim_entry->COutput->velocity;
					}
				}
				break;
			case DIR_TOP:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->COutput->offsety < 0){
					anim_cn->anim_entry->COutput->offsety += anim_cn->anim_entry->COutput->velocity;
					if(anim_cn->anim_entry->COutput->offsety < relRect.GetTop()-y-r-30){
						anim_cn->anim_entry->COutput->offsety = relRect.GetTop()-y-r-30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->COutput->expand += anim_cn->anim_entry->COutput->interval;
					if(anim_cn->anim_entry->COutput->expand>=2.0){
						anim_cn->anim_entry->COutput->interval *= -1;
					}
					if(anim_cn->anim_entry->COutput->expand <= 1.0 && anim_cn->anim_entry->COutput->interval <0){
						anim_cn->anim_entry->COutput->expand = 1.0;
						anim_cn->anim_entry->COutput->offsety = anim_cn->anim_entry->COutput->velocity;
					}
				}
				break;
			case DIR_BOTTOM:
				if(anim_cn->anim_effect==0 || anim_cn->anim_entry->COutput->offsety > 0){
					anim_cn->anim_entry->COutput->offsety+=anim_cn->anim_entry->COutput->velocity;
					if(anim_cn->anim_entry->COutput->offsety>relRect.GetBottom()-y+r+30){
						anim_cn->anim_entry->COutput->offsety=relRect.GetBottom()-y+r+30;
						FindNextEffectFromCns();
					}
				}
				else {
					anim_cn->anim_entry->COutput->expand += anim_cn->anim_entry->COutput->interval;
					if(anim_cn->anim_entry->COutput->expand>=2.0){
						anim_cn->anim_entry->COutput->interval *= -1;
					}
					if(anim_cn->anim_entry->COutput->expand <= 1.0 && anim_cn->anim_entry->COutput->interval <0){
						anim_cn->anim_entry->COutput->expand = 1.0;
						anim_cn->anim_entry->COutput->offsety = anim_cn->anim_entry->COutput->velocity;
					}
				}
				break;
			}
		}
		break;
	case CONST_EFFECT_CURVE:
		break;
	}
}
