//
//   ConstSrc.cpp
//
//

#include "GConst.h"
#include <math.h>

#include "resource.h"
#ifdef __WXMSW__
	#include "word.h"
#else
	#include "word_e.h"
#endif
#include "incident.h"
#include "wx/wx.h"
#include "wx/string.h"
#include "KidsCindyCanvas.h"
#include "KidsCindyFrame.h"
void Meet_CL(CComplex aa,CComplex bb,CComplex cc, CComplex pp,CComplex qq,CComplex rr,CComplex *xx1 ,CComplex *xx2);

#include <string.h>

wxString mMid(wxString &src,int i)
{
	char *p=(char*)src.c_str();
	int l=strlen(p);
	if(i<0 || i>=l)return (wxString)wxT("");
	char *tgt=new char[l+1];
	int k;
	for(k=i;k<l;k++){
		tgt[k-i]=p[k];
	}
	tgt[k-i]=0;
	wxString ret=wxString::Format((wxChar*)tgt);
	delete tgt;
	return ret;
}

wxString mMid(wxString &src,int i,int j)
{
	char *p=(char*)src.c_str();
	int l=strlen(p);
	if(i<0 || i>=l)return (wxString)wxT("");
	char *tgt=new char[l+1];
	int k;
	for(k=i;k<l && k<i+j;k++){
		tgt[k-i]=p[k];
	}
	tgt[k-i]=0;
	wxString ret=wxString::Format((wxChar*)tgt);
	delete tgt;
	return ret;
}

wxString mLeft(wxString &src,int i)
{
	char *p=(char*)src.c_str();
	int l=strlen(p);
	if(i<0 || i>l)return (wxString)wxT("");
	char *tgt=new char[l+1];
	int k;
	for(k=0;k<i;k++){
		tgt[k]=p[k];
	}
	tgt[k]=0;
	wxString ret=wxString::Format((wxChar*)tgt);
	delete tgt;
	return ret;
}

bool mStrcmp(wxString src,wxString tgt)
{
	char *p=(char*)src.c_str();
	char *q=(char*)tgt.c_str();
	return (strcmp(p,q)==0);
}

bool mStrcmp(wxString src,char* tgt)
{
	char *p=(char*)src.c_str();
	return (strcmp(p,tgt)==0);
}

bool mAppend(wxString& src,wxString& tgt)
{
	char *p=(char*)src.c_str();
	char *q=(char*)tgt.c_str();
	int lp=strlen(p);
	int lq=strlen(q);
	char *ret=new char[lp+lq+1];
	int k;
	for(k=0;k<lp;k++){
		ret[k]=p[k];
	}
	for(k=0;k<lq;k++){
		ret[k+lp]=q[k];
	}
	ret[lp+lq]=0x00;
	src=wxString((wxChar*)ret);
	delete ret;
	return false;
}


void GConst::ConstSrc(char* tgt)
{
	float gx,gy;
	int offset=0;
	wxString str;
	switch(Const_Type){
	case CONST_FREE:
		gx = (float)(POutput->xz().real());
		gy = (float)(POutput->yz().real());
		sprintf(tgt,"point %s=Pt(%.3f,%.3f",(char*)POutput->_name.c_str(),gx,gy);
		offset=strlen(tgt);
		break;
	case CONST_JOIN:
		sprintf(tgt,"line %s=Join(%s,%s",LOutput->_name.c_str(),PInput1->_name.c_str(),PInput2->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_ON_LINE:
		gx = (float)(para1.real());
		gy = (float)(para2.real());
		sprintf(tgt,"point %s=PtOnLine(%s,%s,%.3f,%.3f",POutput->_name.c_str(),PInput1->_name.c_str(),PInput2->_name.c_str(),gx,gy);
		offset=strlen(tgt);
		break;
	case CONST_MEET:
		sprintf(tgt,"point %s=Meet(%s,%s",POutput->_name.c_str(),LInput1->_name.c_str(),LInput2->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_PARALLEL:
		sprintf(tgt,"line %s=Parallel(%s,%s",LOutput->_name.c_str(),LInput1->_name.c_str(),PInput1->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_PERP:
		sprintf(tgt,"line %s=Perp(%s,%s",LOutput->_name.c_str(),LInput1->_name.c_str(),PInput1->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_MID:
		sprintf(tgt,"point %s=Mid(%s,%s",POutput->_name.c_str(),PInput1->_name.c_str() , PInput2->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_PT_ON_PARA:
		gx = (float)(para1.real());
		sprintf(tgt,"point %s=PtOnParallel(%s,%s,%.3f",POutput->_name.c_str(),LInput1->_name.c_str(),PInput1->_name.c_str(),gx);
		offset=strlen(tgt);
		break;
	case CONST_PT_ON_PERP:
		gx = (float)(para1.real());
		sprintf(tgt,"point %s=PtOnPerp(%s,%s,%.3f",POutput->_name.c_str(),LInput1->_name.c_str(),PInput1->_name.c_str(),gx);
		offset=strlen(tgt);
		break;
	case CONST_MULTI_CIRCLE:
		sprintf(tgt,"circle %s=Circle(%s,%s",COutput->_name.c_str(),PInput1->_name.c_str(),PInput2->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_PT_ON_CIRCLE:
		gx = (float)(para1.real());
		sprintf(tgt,"point %s=PtOnCircle(%s,%.3f",POutput->_name.c_str(),CInput1->_name.c_str(),gx);
		offset=strlen(tgt);
		break;
	case CONST_MEET_CL:
		gx = (float)(para1.real());
		gy = (float)(para1.imag());
		sprintf(tgt,"point %s=MeetCircleAndLine(%s,%s,%.3f,%.3f",POutput->_name.c_str(),CInput1->_name.c_str(),LInput1->_name.c_str(),gx,gy);
		offset=strlen(tgt);
		gx = (float)(para2.real());
		gy = (float)(para2.imag());
		sprintf(tgt+offset,",%.3f,%.3f",gx,gy);
		offset=strlen(tgt);
		if(PInput1!=NULL){
			sprintf(tgt+offset,",not%s",PInput1->_name.c_str());
			offset=strlen(tgt);
		}
		break;
	case CONST_MEET_CC:
		gx = (float)(para1.real());
		gy = (float)(para1.imag());
		sprintf(tgt,"point %s=Meet2Circles(%s,%s,%.3f,%.3f",POutput->_name.c_str(),CInput1->_name.c_str(),CInput2->_name.c_str(),gx,gy);
		offset=strlen(tgt);
		gx = (float)(para2.real());
		gy = (float)(para2.imag());
		sprintf(tgt+offset,",%.3f,%.3f",gx,gy);
		offset=strlen(tgt);
		if(PInput1!=NULL){
			sprintf(tgt+offset,",not%s",PInput1->_name.c_str());
			offset=strlen(tgt);
		}
		break;
	case CONST_BISECTOR:
		gx = (float)(para1.real());
		sprintf(tgt,"line %s=Bisector(%s,%s,%.3f",LOutput->_name.c_str(),LInput1->_name.c_str(),LInput2->_name.c_str(),gx);
		offset=strlen(tgt);
		break;
	case CONST_3P_BISECTOR:
		gx = (float)(para1.real());
		sprintf(tgt,"line %s=3PBisector(%s,%s,%s",LOutput->_name.c_str(),PInput1->_name.c_str(),PInput2->_name.c_str(),PInput3->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_GRAPH:
		sprintf(tgt,"curve %s=Graph(%s,%.3f,%.3f",
			CurveOutput->_name.c_str(),CurveOutput->str_y.c_str(),CurveOutput->para_min,CurveOutput->para_max);
		offset=strlen(tgt);
		break;
	case CONST_PT_ON_CURVE:
		gx=(float)para1.real();
		sprintf(tgt,"point %s=PtOnCurve(%s,%.3f",POutput->_name.c_str(),CurveInput1->_name.c_str(),gx);
		offset=strlen(tgt);
		break;
	case CONST_CURVE_TANGENT:
		sprintf(tgt,"line %s=CurveTangent(%s,%s",LOutput->_name.c_str(),CurveInput1->_name.c_str(),PInput1->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_TANGENT:
		sprintf(tgt,"line %s=Tangent(%s,%s",LOutput->_name.c_str(),CInput1->_name.c_str(),PInput1->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_TEXT:
		str=ConvertText4Script(TextOutput->str);
		sprintf(tgt,"text %s=Text(%s,%d,%d,%d",TextOutput->_name.c_str(),str.c_str(),TextOutput->tx,TextOutput->ty,TextOutput->fontsize);
		offset=strlen(tgt);
		break;
	case CONST_COMPASS:
		sprintf(tgt,"circle %s=Compass(%s,%s,%s",COutput->_name.c_str(),PInput1->_name.c_str(),PInput2->_name.c_str(),PInput3->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_ORBIT1:
		sprintf(tgt,"curve %s=OrbitOnCircle(%s,%s",CurveOutput->_name.c_str(),PInput1->_name.c_str(),PInput2->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_ORBIT2:
		sprintf(tgt,"curve %s=OrbitOnLine(%s,%s",CurveOutput->_name.c_str(),PInput1->_name.c_str(),PInput2->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_ORTHOCENTER:
		sprintf(tgt,"point %s=Orthocenter(%s,%s,%s",POutput->_name.c_str(),PInput1->_name.c_str(),PInput2->_name.c_str(),PInput3->_name.c_str());
		offset=strlen(tgt);
		break;
	case  CONST_PT_ON_3P_BISECTOR:
		gx = (float)(para1.real());
		sprintf(tgt,"point %s=PtOn3PBisector(%s,%s,%s,%.3f",POutput->_name.c_str(),PInput1->_name.c_str(),PInput2->_name.c_str(),PInput3->_name.c_str(),gx);
		offset=strlen(tgt);
		break;
	case CONST_PT_ON_BISECTOR:
		gx = (float)(para1.real());
		gy = (float)(para2.real());
		sprintf(tgt,"point %s=PtOnBisector(%s,%s,%.3f,%.3f",POutput->_name.c_str(),LInput1->_name.c_str(),LInput2->_name.c_str(),gx,gy);
		offset=strlen(tgt);
		break;
	case CONST_PT_ON_TANGENT:
		gx = (float)(para1.real());
		sprintf(tgt,"point %s=PtOnTangent(%s,%s,%.3f",POutput->_name.c_str(),CInput1->_name.c_str(),PInput1->_name.c_str(),gx);
		break;
	case CONST_PT_ON_CURVE_TANGENT:
		gx = (float)(para1.real());
		sprintf(tgt,"point %s=PtOnCurveTangent(%s,%s,%.3f",POutput->_name.c_str(),CurveInput1->_name.c_str(),PInput1->_name.c_str(),gx);
		offset=strlen(tgt);
		break;
	case CONST_PARA_CURVE:
		sprintf(tgt,"curve %s=ParaCurve(%s,%s,%.3f,%.3f",CurveOutput->_name.c_str(),CurveOutput->str_x.c_str(),CurveOutput->str_y.c_str(),CurveOutput->para_min,CurveOutput->para_max);
		offset=strlen(tgt);
		break;
	case CONST_EFFECT_POINT:
		sprintf(tgt,"void EffectPoint(%s",anim_entry->POutput->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_EFFECT_LINE:
		sprintf(tgt,"void EffectLine(%s",anim_entry->LOutput->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_EFFECT_CIRCLE:
		sprintf(tgt,"void EffectCircle(%s",anim_entry->COutput->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_EFFECT_CURVE:
		sprintf(tgt,"void EffectCurve(%s",anim_entry->CurveOutput->_name.c_str());
		offset=strlen(tgt);
		break;
	case CONST_EFFECT_TEXT:
		sprintf(tgt,"void EffectText(%s",anim_entry->TextOutput->_name.c_str());
		offset=strlen(tgt);
		break;
	}
	switch(Output_Type()){
	case OUTPUT_POINT:
		if(POutput->invisible){
			sprintf(tgt+offset,",invisible");
			offset=strlen(tgt);
		}
		if(POutput->ptbmp>0){
			sprintf(tgt+offset,",color%d",POutput->ptbmp + 1);
			offset=strlen(tgt);
		}
		if(7<POutput->_fontsize && POutput->_fontsize<100 && POutput->_fontsize!=14){
			sprintf(tgt+offset,",fontsize%d",POutput->_fontsize);
			offset=strlen(tgt);
		}
		if(POutput->_name_theta!=0.0){
			sprintf(tgt+offset,",nametheta%f",POutput->_name_theta);
			offset=strlen(tgt);
		}
#ifdef __WXMSW__
		sprintf(tgt+offset,");\r\n");
#else
		sprintf(tgt+offset,");\n");
#endif
		break;
	case OUTPUT_LINE:
		if(LOutput->clipping){
			sprintf(tgt+offset,",clipping");
			offset=strlen(tgt);
		}
		if(LOutput->invisible){
			sprintf(tgt+offset,",invisible");
			offset=strlen(tgt);
		}
		if(LOutput->lndsn>0){
			sprintf(tgt+offset,",color%d",LOutput->lndsn + 1);
			offset=strlen(tgt);
		}
#ifdef __WXMSW__
		sprintf(tgt+offset,");\r\n");
#else
		sprintf(tgt+offset,");\n");
#endif
		break;
	case OUTPUT_CIRCLE:
		if(COutput->clipping){
			sprintf(tgt+offset,",clipping");
			offset=strlen(tgt);
		}
		if(COutput->invisible){
			sprintf(tgt+offset,",invisible");
			offset=strlen(tgt);
		}
		if(COutput->lndsn>0){
			sprintf(tgt+offset,",color%d",COutput->lndsn + 1);
			offset=strlen(tgt);
		}
#ifdef __WXMSW__
		sprintf(tgt+offset,");\r\n");
#else
		sprintf(tgt+offset,");\n");
#endif
		break;
	case OUTPUT_CURVE:
		if(CurveOutput->invisible){
			sprintf(tgt+offset,",invisible");
			offset=strlen(tgt);
		}
		if(CurveOutput->lndsn>0){
			sprintf(tgt+offset,",color%d",CurveOutput->lndsn + 1);
			offset=strlen(tgt);
		}
#ifdef __WXMSW__
		sprintf(tgt+offset,");\r\n");
#else
		sprintf(tgt+offset,");\n");
#endif
		break;
	case OUTPUT_TEXT:
#ifdef __WXMSW__
		sprintf(tgt+offset,");\r\n");
#else
		sprintf(tgt+offset,");\n");
#endif
		break;
	case OUTPUT_EFFECT:
		if(anim_click==1){
			sprintf(tgt+offset,",withClick");
			offset=strlen(tgt);
		}
		else{
			sprintf(tgt+offset,",immediately");
			offset=strlen(tgt);
		}
		switch(anim_direction){
		case 0: 
			sprintf(tgt+offset,",fade");
			offset=strlen(tgt);
			break;
		case 1: 
			sprintf(tgt+offset,",right");
			offset=strlen(tgt);
			break;
		case 2: 
			sprintf(tgt+offset,",left");
			offset=strlen(tgt);
			break;
		case 3: 
			sprintf(tgt+offset,",top");
			offset=strlen(tgt);
			break;
		case 4: 
			sprintf(tgt+offset,",bottom");
			offset=strlen(tgt);
			break;
		}
		if(anim_inout==0){
			sprintf(tgt+offset,",in");
			offset=strlen(tgt);
		}
		else{
			sprintf(tgt+offset,",out");
			offset=strlen(tgt);
		}
		if(anim_effect==0){
			sprintf(tgt+offset,",noEffect");
			offset=strlen(tgt);
		}
		else{
			sprintf(tgt+offset,",withEffect");
			offset=strlen(tgt);
		}
#ifdef __WXMSW__
		sprintf(tgt+offset,");\r\n");
#else
		sprintf(tgt+offset,");\n");
#endif
		break;
	}
}

bool MyCanvas::SetConstSrc(GConst* cn)
{
	if(cn==NULL){
		return false;
	}
	char buff1[256];
	cn->ConstSrc(buff1);
	char *p=(char*)const_src.c_str();
	int l=strlen(p);
	char *buff2=new char[l+256];
	strcpy(buff2,p);
	strcpy(buff2+l,buff1);
	const_src =wxString((wxChar*)buff2);
	delete buff2;
	if(cn->next!=NULL){
		SetConstSrc(cn->next);
	}
	return false;
}

bool MyCanvas::const_src2cns(bool clean,bool texton)
{
	wxString message;
	int linecount=1;
	wxString a_line;
	wxString prefix,name,function,var[10];
	int offset=0;
	int NOVar=0;
	int i,fs/*,sn*/;
	double ntheta;
	double dd0=0,dd1=0,dd2=0,dd3=0,dd4=0;
	GConst *cn1,*cn2,*cn3,*cn4;
	GConst *cnp=NULL;
	bool loopend=false,commentline;
	int sheetcount=0;
	bool error;
	CComplex xx1,yy1,zz1,xx2,yy2;
	CComplex c1x,c1y,c1r,c2x,c2y,c2r,lx,ly,lz;
	CComplex px1,px2,px3,py1,py2,py3;
	NOConstStock=0;
	int NOMinInput=1;
	char *p;
	wxString fontsize,nametheta;
	
	if(clean) {
		ClearConst();	
	}
	do{
		commentline=false;
		error=false;
		if(loopend = GetALine(a_line,const_src,&offset)) break;
		while (mStrcmp(mLeft(a_line,1),"\n") || mStrcmp(mLeft(a_line,1),"\r")){
			a_line=mMid(a_line,1);
		}
		if(mStrcmp(mLeft(a_line,2),"//")){
			commentline=true;
			if(mStrcmp(mLeft(a_line,8),"//Sheet ")){
				if(sheetcount>0){
					currentSheet++;
					NOMySheet++;
				}
				cns = sheetbuffer[currentSheet].MyConst=NULL;
				lastcn = sheetbuffer[currentSheet].MyLastConst = &cns;
				pts = sheetbuffer[currentSheet].MyPoint=NULL;
				lastpt = sheetbuffer[currentSheet].MyLastPoint = &pts;
				lns = sheetbuffer[currentSheet].MyLine=NULL;
				lastln = sheetbuffer[currentSheet].MyLastLine = &lns;
				cis = sheetbuffer[currentSheet].MyCircle=NULL;
				lastci = sheetbuffer[currentSheet].MyLastCircle = &cis;
				texts = sheetbuffer[currentSheet].MyText=NULL;
				lasttext = sheetbuffer[currentSheet].MyLastText = &texts;
				curves = sheetbuffer[currentSheet].MyParaCurve=NULL;
				lastcurve = sheetbuffer[currentSheet].MyLastParaCurve = &curves;
				sheetcount++;
			}
		}
		loopend = Check_Prefix(prefix,a_line);
		if(!commentline && loopend){
			message.Printf(OnPrefixSyntaxError,linecount);
			wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				return false;
		}
		if(!commentline && !mStrcmp(prefix,"void")){
			if(loopend = Get_ElementName(name,a_line)){
				message.Printf(wxT("line %d : element name error "),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
					return false;
			}
		}
		loopend = Get_FunctionName(function,a_line);
		if(!commentline && loopend){
			message.Printf(wxT("line %d : illegal function name"),linecount);
			wxMessageBox(message,function,wxOK | wxICON_INFORMATION, this);
				return false;
		}
		loopend = Get_Variables(var,a_line,&NOVar);
		if(!commentline && loopend){
			message.Printf(wxT("line %d : illegal variable name"),linecount);
			wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				return false;
		}
		error=true;
		if(commentline){
			;
		}
		else if(mStrcmp(function,"Pt")){
			if(NOVar>=2){
				error=false;
			}
			if(!error){
				p=(char*)var[0].c_str();dd1=atof(p);
				p=(char*)var[1].c_str();dd2=atof(p);
				cnp = NewConst(CONST_FREE);
				cnp->PInput1=NewPoint(CComplex(dd1,0.0),CComplex(dd2,0.0));
				cnp->POutput = cnp->PInput1;
				cnp->POutput->_name= name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				AssignPoint(cnp->PInput1);
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(mStrcmp(mLeft(var[i],8),"fontsize")){
							fontsize=mMid(var[i],8);
							p=(char*)fontsize.c_str();
							fs=atoi(p);
							if(7<=fs && fs<=100){
								cnp->POutput->_fontsize=fs;
							}
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(-6.28<=ntheta && ntheta<=6.28){
								cnp->POutput->_name_theta=ntheta;
							}
						}
					}
				}
			}
			else {
				message.Printf(wxT("line %d : Pt : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"Join")){
			if(NOVar>=2 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				if(cn1->POutput!=NULL && cn2->POutput!=NULL){
					if(cn1->POutput!=cn2->POutput){
						error=false;
					}
				}
			}
			if(!error){
				cnp = NewConst(CONST_JOIN);
				cnp->PInput1=cn1->POutput;
				cnp->PInput2=cn2->POutput;
				cnp->LOutput = NewLine(cn1->POutput->xz().real(),cn1->POutput->yz().real(),
					cn2->POutput->xz().real(),cn2->POutput->yz().real());
				cnp->LOutput->_name= wxString((char*)name.c_str(),*wxConvCurrent);
				cnp->LOutput->invisible=false;
				cnp->LOutput->lndsn=0;
				AssignLine(cnp->LOutput);
				AssignIncident(cnp->LOutput,cnp->PInput1,0.0);
				AssignIncident(cnp->LOutput,cnp->PInput2,1.0);
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"clipping")){
							cnp->LOutput->clipping=true;
						}
						if(mStrcmp(var[i],"invisible")){
							cnp->LOutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->LOutput->lndsn=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->LOutput->lndsn=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->LOutput->lndsn=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->LOutput->lndsn=4;
						}
					}
				}
				if(!CheckCoincidency(cnp->LOutput)) {
					CheckIncidency(cnp->LOutput,false);
				}
			}
			else {
				message.Printf(wxT("line %d : Join : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"PtOnLine")){
			if(NOVar>=4 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2) ){
				p=(char*)var[2].c_str();dd1=atof(p);
				p=(char*)var[3].c_str();dd2=atof(p);
				if(cn1->POutput!=NULL && cn2->POutput!=NULL && dd1+dd2!=0.0){
					if(FindJoinFromCns(cns,cn1->POutput,cn2->POutput,&cn3)){
						error=false;
					}
				}
			}
			if(!error){
				cnp = NewConst(CONST_ON_LINE);
				cnp->PInput1=cn1->POutput;
				cnp->PInput2=cn2->POutput;
				cnp->para1=CComplex(dd1,0.0);
				cnp->para2=CComplex(dd2,0.0);
				cnp->POutput = NewPoint(
					(cnp->PInput1->xz() * cnp->para2 + cnp->PInput2->xz() * cnp->para1)/(cnp->para1+ cnp->para2),
					(cnp->PInput1->yz() * cnp->para2 + cnp->PInput2->yz() * cnp->para1)/(cnp->para1+ cnp->para2) );
				cnp->POutput->_name=name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;				
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				AssignIncident(cn3->LOutput,cnp->POutput,(cnp->para1/(cnp->para1+cnp->para2)).real());
				AssignPoint(cnp->POutput);
				if(NOVar>=5){
					for(i=4;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(mStrcmp(mLeft(var[i],8),"fontsize")){
							fontsize=mMid(var[i],8);
							p=(char*)fontsize.c_str();
							fs=atoi(p);
							if(7<=fs && fs<=100){
								cnp->POutput->_fontsize=fs;
							}
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(-6.28<=ntheta && ntheta<=6.28){
								cnp->POutput->_name_theta=ntheta;
							}
						}
					}
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"Meet")){
			if(NOVar>=2 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				if(cn1->LOutput!=NULL && cn2->LOutput!=NULL){
					if(cn1->LOutput!=cn2->LOutput){
						error=false;
					}
				}
			}
			if(!error){
				cnp = NewConst(CONST_MEET);
				cnp->LInput1=cn1->LOutput;
				cnp->LInput2=cn2->LOutput;
				cnp->POutput = NewPoint(
					cnp->LInput1->yy * cnp->LInput2->zz - cnp->LInput1->zz * cnp->LInput2->yy,
					cnp->LInput1->zz * cnp->LInput2->xx - cnp->LInput1->xx * cnp->LInput2->zz,
					cnp->LInput1->xx * cnp->LInput2->yy - cnp->LInput1->yy * cnp->LInput2->xx);
				cnp->POutput->_name=name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				AssignIncident(cnp->LInput1,cnp->POutput,1.0);
				ResetLineIcPara(cnp->LInput1);
				AssignIncident(cnp->LInput2,cnp->POutput);
				ResetLineIcPara(cnp->LInput2);
				AssignPoint(cnp->POutput);
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(mStrcmp(mLeft(var[i],8),"fontsize")){
							fontsize=mMid(var[i],8);
							p=(char*)fontsize.c_str();
							fs=atoi(p);
							if(7<=fs && fs<=100){
								cnp->POutput->_fontsize=fs;
							}
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(-6.28<=ntheta && ntheta<=6.28){
								cnp->POutput->_name_theta=ntheta;
							}
						}
					}
				}
				if(!CheckCoincidency(cnp->POutput)) {
					CheckIncidency(cnp->POutput,false);
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"Parallel")){
			if(NOVar>=2 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				if(cn1->LOutput!=NULL && cn2->POutput!=NULL){
					error=false;
				}
			}
			if(!error){
				cnp = NewConst(CONST_PARALLEL);
				cnp->LInput1=cn1->LOutput;
				cnp->PInput1=cn2->POutput;
				cnp->LOutput = NewLine(
					cnp->LInput1->xx,
					cnp->LInput1->yy,
					(cnp->LInput1->xx * cnp->PInput1->xz() + cnp->LInput1->yy * cnp->PInput1->yz())*CComplex(-1.0,0.0) );
				cnp->LOutput->_name=name;
				cnp->LOutput->invisible=false;
				cnp->LOutput->lndsn=0;
				AssignLine(cnp->LOutput);
				AssignIncident(cnp->LOutput,cnp->PInput1);
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"clipping")){
							cnp->LOutput->clipping=true;
						}
						if(mStrcmp(var[i],"invisible")){
							cnp->LOutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->LOutput->lndsn=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->LOutput->lndsn=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->LOutput->lndsn=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->LOutput->lndsn=4;
						}
					}
				}
				if(!CheckCoincidency(cnp->LOutput)) {
					CheckIncidency(cnp->LOutput,false);
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"Perp")){
			if(NOVar>=2 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				if(cn1->LOutput!=NULL && cn2->POutput!=NULL){
					error=false;
				}
			}
			if(!error){
				cnp = NewConst(CONST_PERP);
				cnp->LInput1=cn1->LOutput;
				cnp->PInput1=cn2->POutput;
				cnp->LOutput = NewLine(
					cnp->LInput1->yy,
					cnp->LInput1->xx * CComplex(-1.0,0.0),
					(cnp->LInput1->yy * cnp->PInput1->xz() - cnp->LInput1->xx * cnp->PInput1->yz())*CComplex(-1.0,0.0) );
				cnp->LOutput->_name=name;
				cnp->LOutput->invisible=false;
				cnp->LOutput->lndsn=0;
				AssignLine(cnp->LOutput);
				AssignIncident(cnp->LOutput,cnp->PInput1);
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"clipping")){
							cnp->LOutput->clipping=true;
						}
						if(mStrcmp(var[i],"invisible")){
							cnp->LOutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->LOutput->lndsn=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->LOutput->lndsn=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->LOutput->lndsn=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->LOutput->lndsn=4;
						}
					}
				}
				if(!CheckCoincidency(cnp->LOutput)) {
					CheckIncidency(cnp->LOutput,false);
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"Mid")){
			if(NOVar>=2 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				if(cn1->POutput!=NULL && cn2->POutput!=NULL){
					error=false;
				}
			}
			if(!error){
				cnp = NewConst(CONST_MID);
				cnp->PInput1=cn1->POutput;
				cnp->PInput2=cn2->POutput;
				cnp->POutput = NewPoint(
					cnp->PInput1->xx * cnp->PInput2->zz + cnp->PInput1->zz * cnp->PInput2->xx,
					cnp->PInput1->yy * cnp->PInput2->zz + cnp->PInput1->zz * cnp->PInput2->yy,
					cnp->PInput1->zz * cnp->PInput2->zz * CComplex(2.0,0.0) );
				cnp->POutput->_name=name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				AssignPoint(cnp->POutput);
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(mStrcmp(mLeft(var[i],8),"fontsize")){
							fontsize=mMid(var[i],8);
							p=(char*)fontsize.c_str();
							fs=atoi(p);
							if(7<=fs && fs<=100){
								cnp->POutput->_fontsize=fs;
							}
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(-6.28<=ntheta && ntheta<=6.28){
								cnp->POutput->_name_theta=ntheta;
							}
						}
					}
				}
				if(!CheckCoincidency(cnp->POutput)) {
					CheckIncidency(cnp->POutput,false);
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"PtOnParallel")){
			if(NOVar>=3 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				p=(char*)var[2].c_str();dd1=atof(p);
				if(cn1->LOutput!=NULL && cn2->POutput!=NULL){
					if(FindParaFromCns(cns,cn1->LOutput,cn2->POutput,&cn3)){
						error=false;
					}
				}
			}
			if(!error){
				cnp = NewConst(CONST_PT_ON_PARA);
				cnp->LInput1=cn1->LOutput;
				cnp->PInput1=cn2->POutput;
				cnp->para1=CComplex(dd1,0.0);
				cnp->POutput = NewPoint(
					cnp->PInput1->xz() - cnp->LInput1->yy * cnp->para1,
					cnp->PInput1->yz() + cnp->LInput1->xx * cnp->para1,
					CComplex(1.0,0.0) );
				cnp->POutput->_name=name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				AssignPoint(cnp->POutput);
				AssignIncident(cn3->LOutput,cnp->POutput);
				if(NOVar>=4){
					for(i=3;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(mStrcmp(mLeft(var[i],8),"fontsize")){
							fontsize=mMid(var[i],8);
							p=(char*)fontsize.c_str();
							fs=atoi(p);
							if(7<=fs && fs<=100){
								cnp->POutput->_fontsize=fs;
							}
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(-6.28<=ntheta && ntheta<=6.28){
								cnp->POutput->_name_theta=ntheta;
							}
						}
					}
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"PtOnPerp")){
			if(NOVar>=2 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				p=(char*)var[2].c_str();dd1=atof(p);
				if(cn1->LOutput!=NULL && cn2->POutput!=NULL){
					if(FindPerpFromCns(cns,cn1->LOutput,cn2->POutput,&cn3)){
						error=false;
					}
				}
			}
			if(!error){
				cnp = NewConst(CONST_PT_ON_PERP);
				cnp->LInput1=cn1->LOutput;
				cnp->PInput1=cn2->POutput;
				cnp->para1=CComplex(dd1,0.0);
				cnp->POutput = NewPoint(
					cnp->PInput1->xz() + cnp->LInput1->xx * cnp->para1,
					cnp->PInput1->yz() + cnp->LInput1->yy * cnp->para1,
					CComplex(1.0,0.0) );
				cnp->POutput->_name=name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				AssignPoint(cnp->POutput);
				FindPerpFromCns(cns,cnp->LInput1,cnp->PInput1,&cn3);
				AssignIncident(cn3->LOutput,cnp->POutput);
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(mStrcmp(mLeft(var[i],8),"fontsize")){
							fontsize=mMid(var[i],8);
							p=(char*)fontsize.c_str();
							fs=atoi(p);
							if(7<=fs && fs<=100){
								cnp->POutput->_fontsize=fs;
							}
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(-6.28<=ntheta && ntheta<=6.28){
								cnp->POutput->_name_theta=ntheta;
							}
						}
					}
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"Circle")){
			if(NOVar>=2 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				if(cn1->POutput!=NULL && cn2->POutput!=NULL){
					error=false;
				}
			}
			if(!error){
				cnp = NewConst(CONST_MULTI_CIRCLE);
				cnp->PInput1=cn1->POutput;
				cnp->PInput2=cn2->POutput;
				cnp->COutput = NewCircle(
					cnp->PInput1->xz().real(),
					cnp->PInput1->yz().real(),
					((cnp->PInput1->xz()- cnp->PInput2->xz())*( cnp->PInput1->xz()- cnp->PInput2->xz())+( cnp->PInput1->yz()- cnp->PInput2->yz())*( cnp->PInput1->yz()- cnp->PInput2->yz())).real() );
				cnp->COutput->_name=name;
				cnp->COutput->invisible=false;
				cnp->COutput->lndsn=0;
				AssignCircle(cnp->COutput);
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"clipping")){
							cnp->COutput->clipping=true;
						}
						if(mStrcmp(var[i],"invisible")){
							cnp->COutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->COutput->lndsn=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->COutput->lndsn=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->COutput->lndsn=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->COutput->lndsn=4;
						}
					}
				}
				if(!CheckCoincidency(cnp->COutput)) {
					CheckIncidency(cnp->COutput,false);
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"PtOnCircle")){
			if(NOVar>=2 && FindNameFromCns(cns,var[0],&cn1)){
				p=(char*)var[1].c_str();dd1=atof(p);
				if(cn1->COutput!=NULL){
					error=false;
				}
			}
			if(!error){
				cnp = NewConst(CONST_PT_ON_CIRCLE);
				cnp->CInput1=cn1->COutput;
				cnp->para1=CComplex(dd1,0.0);
				cnp->POutput = NewPoint(
					cnp->CInput1->xx + CComplex(sqrt(cnp->CInput1->rr.real()) * cos(dd1),0.0),
					cnp->CInput1->yy - CComplex(sqrt(cnp->CInput1->rr.real()) * sin(dd1),0.0),
					CComplex(1.0,0.0) );
				cnp->POutput->_name=name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				AssignPoint(cnp->POutput);
				AssignIncident(cn1->COutput,cnp->POutput,atan2( - cnp->POutput->yz().real() + cn1->COutput->yy.real(),
					cnp->POutput->xz().real()-cn1->COutput->xx.real()));
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(mStrcmp(mLeft(var[i],8),"fontsize")){
							fontsize=mMid(var[i],8);
							p=(char*)fontsize.c_str();
							fs=atoi(p);
							if(7<=fs && fs<=100){
								cnp->POutput->_fontsize=fs;
							}
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(-6.28<=ntheta && ntheta<=6.28){
								cnp->POutput->_name_theta=ntheta;
							}
						}
					}
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"MeetCircleAndLine")){
			if(NOVar>=6 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				p=(char*)var[2].c_str();dd1=atof(p);
				p=(char*)var[3].c_str();dd2=atof(p);
				p=(char*)var[4].c_str();dd3=atof(p);
				p=(char*)var[5].c_str();dd4=atof(p);
				if(cn1->COutput!=NULL && cn2->LOutput!=NULL){
					error=false;
				}
			}
			if(!error){
				cnp = NewConst(CONST_MEET_CL);
				cnp->CInput1=cn1->COutput;
				cnp->LInput1=cn2->LOutput;
				cnp->PInput1=NULL;
				cnp->para1=CComplex(dd1,dd2);
				cnp->para2=CComplex(dd3,dd4);
				cnp->para3=CComplex(999.0,999.0);
				cnp->para4=CComplex(999.0,999.0);
				if(cnp->LInput1->yy.zerop()){
					Meet_CL(cnp->LInput1->yy,cnp->LInput1->xx,cnp->LInput1->zz,
						cnp->CInput1->yy,cnp->CInput1->xx,cnp->CInput1->rr,&yy1,&yy2);
					xx1 = xx2 = CComplex(-1.0,0.0)* cnp->LInput1->zz / cnp->LInput1->xx;	
				}
				else {
					Meet_CL(cnp->LInput1->xx,cnp->LInput1->yy,cnp->LInput1->zz,
						cnp->CInput1->xx,cnp->CInput1->yy,cnp->CInput1->rr,&xx1,&xx2);
					yy1 = CComplex(-1.0,0.0)* (cnp->LInput1->xx * xx1 + cnp->LInput1->zz ) / cnp->LInput1->yy;
					yy2 = CComplex(-1.0,0.0)* (cnp->LInput1->xx * xx2 + cnp->LInput1->zz ) / cnp->LInput1->yy;	
				}
				double n1=norm(xx1-cnp->para1)+norm(yy1-cnp->para2);
				double n2=norm(xx2-cnp->para1)+norm(yy2-cnp->para2);
				if(n1+0.01<n2){
					cnp->POutput = NewPoint(xx1,yy1,CComplex(1.0,0.0));
				}	
				else {
					cnp->POutput = NewPoint(xx2,yy2,CComplex(1.0,0.0));
				}
				cnp->POutput->_name=name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				AssignPoint(cnp->POutput);
				AssignIncident(cnp->LInput1,cnp->POutput);
				ResetLineIcPara(cnp->LInput1);
				AssignIncident(cn1->COutput,cnp->POutput,atan2( - cnp->POutput->yz().real() + cn1->COutput->yy.real(),
					cnp->POutput->xz().real()-cn1->COutput->xx.real()));
				if(NOVar>=7){
					for(i=6;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(var[i].Left(3)==wxT("not")){
							wxString notname=var[i].Mid(3,wxSTRING_MAXLEN);
							FindNameFromCns(cns,notname,&cn3);
							cnp->PInput1=cn3->POutput;
						}
						else if(var[i].Left(8)==wxT("fontsize")){
							var[i].Mid(8).ToLong((long *)&fs);
							if(fs<7 || fs>100){
								fs=14;
							}
							cnp->POutput->_fontsize=fs;
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(ntheta<-6.28 || ntheta>6.28){
								ntheta=0.0;
							}
							cnp->POutput->_name_theta=ntheta;
						}
					}
				}
				if(!CheckCoincidency(cnp->POutput)) {
					CheckIncidency(cnp->POutput,false);
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"Meet2Circles")){
			if(NOVar>=6 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				p=(char*)var[2].c_str();dd1=atof(p);
				p=(char*)var[3].c_str();dd2=atof(p);
				p=(char*)var[4].c_str();dd3=atof(p);
				p=(char*)var[5].c_str();dd4=atof(p);
				if(cn1->COutput!=NULL && cn2->COutput!=NULL){
					error=false;
				}
			}
			if(!error){
				cnp = NewConst(CONST_MEET_CC);
				cnp->CInput1=cn1->COutput;
				cnp->CInput2=cn2->COutput;
				cnp->PInput1=NULL;
				cnp->para1=CComplex(dd1,dd2);
				cnp->para2=CComplex(dd3,dd4);
				cnp->para3=CComplex(999.0,999.0);
				cnp->para4=CComplex(999.0,999.0);
				c1x=cnp->CInput1->xx;c1y=cnp->CInput1->yy;c1r=cnp->CInput1->rr;
				c2x=cnp->CInput2->xx;c2y=cnp->CInput2->yy;c2r=cnp->CInput2->rr;
				lx=CComplex(2.0,0.0)*(c1x-c2x);
				ly=CComplex(2.0,0.0)*(c1y-c2y);
				lz=c1r-c2r-c1x*c1x-c1y*c1y+c2x*c2x+c2y*c2y;
				if(lx.zerop() && ly.zerop()){
					cnp->POutput = NewPoint(CComplex(1.0,0.0),CComplex(1.0,0.0),CComplex(0.0,0.0));
					return true;
				}
				if(ly.zerop()){
					Meet_CL(ly,lx,lz,c1y,c1x,c1r,&yy1,&yy2);
					xx1 = xx2 = CComplex(-1.0,0.0)* lz / lx;	
				}
				else {
					Meet_CL(lx,ly,lz,c1x,c1y,c1r,&xx1,&xx2);
					yy1 = CComplex(-1.0,0.0)* (lx * xx1 + lz ) / ly;
					yy2 = CComplex(-1.0,0.0)* (lx * xx2 + lz ) / ly;	
				}
				double n1=norm(xx1-cnp->para1)+norm(yy1-cnp->para2);
				double n2=norm(xx2-cnp->para1)+norm(yy2-cnp->para2);
				if(n1+0.01<n2){
					cnp->POutput = NewPoint(xx1,yy1,CComplex(1.0,0.0));
				}	
				else {
					cnp->POutput = NewPoint(xx2,yy2,CComplex(1.0,0.0));
				}
				cnp->POutput->_name=name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				AssignPoint(cnp->POutput);
				AssignIncident(cn1->COutput,cnp->POutput,atan2( - cnp->POutput->yz().real() + cn1->COutput->yy.real(),
					cnp->POutput->xz().real()-cn1->COutput->xx.real()));
				AssignIncident(cn2->COutput,cnp->POutput,atan2( - cnp->POutput->yz().real() + cn2->COutput->yy.real(),
					cnp->POutput->xz().real()-cn2->COutput->xx.real()));
				if(NOVar>=7){
					for(i=6;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(var[i].Left(3)==wxT("not")){
							wxString notname=mMid(var[i],3);
							FindNameFromCns(cns,notname,&cn3);
							cnp->PInput1=cn3->POutput;
						}
						else if(mStrcmp(mLeft(var[i],8),"fontsize")){
							fontsize=mMid(var[i],8);
							p=(char*)fontsize.c_str();
							fs=atoi(p);
							if(7<=fs && fs<=100){
								cnp->POutput->_fontsize=fs;
							}
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(-6.28<=ntheta && ntheta<=6.28){
								cnp->POutput->_name_theta=ntheta;
							}
						}
					}
				}
				if(!CheckCoincidency(cnp->POutput)) {
					CheckIncidency(cnp->POutput,false);
				}
			}
			else {
				message.Printf(wxT("line %d : Meet_CC syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"Bisector")){
			if(NOVar>=3 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2) ){
				p=(char*)var[2].c_str();dd1=atof(p);
				if(cn1->LOutput!=NULL && cn2->LOutput!=NULL){
					error=false;
					if(dd1>0){
						dd1=1.0;
					}
					else {
						dd1=-1.0;
					}
				}
			}
			if(!error){
				cnp = NewConst(CONST_BISECTOR);
				cnp->LInput1=cn1->LOutput;
				cnp->LInput2=cn2->LOutput;
				cnp->para1=CComplex(dd1,0.0);
				cnp->LOutput = NewLine(0.0,0.0,1.0,0.0);
				cnp->LOutput->_name=name;
				cnp->LOutput->invisible=false;
				cnp->LOutput->lndsn=0;
				AssignLine(cnp->LOutput);
				EvaluateConst(cns);
				cnp->LOutput->ics=NULL;
				cnp->LOutput->last_ic=&(cnp->LOutput->ics);
				cnp->LOutput->NOics=0;
				if(NOVar>=4){
					for(i=3;i<NOVar;i++){
						if(mStrcmp(var[i],"clipping")){
							cnp->LOutput->clipping=true;
						}
						if(mStrcmp(var[i],"invisible")){
							cnp->LOutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->LOutput->lndsn=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->LOutput->lndsn=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->LOutput->lndsn=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->LOutput->lndsn=4;
						}
					}
				}
				if(!CheckCoincidency(cnp->LOutput)) {
					CheckIncidency(cnp->LOutput,false);
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"3PBisector")){
			if(NOVar>=3 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2) && FindNameFromCns(cns,var[2],&cn3)){
				if(cn1->POutput!=NULL && cn2->POutput!=NULL && cn3->POutput!=NULL){
					error=false;
				}
			}
			if(!error){
				cnp = NewConst(CONST_3P_BISECTOR);
				cnp->PInput1=cn1->POutput;
				cnp->PInput2=cn2->POutput;
				cnp->PInput3=cn3->POutput;
				cnp->LOutput = NewLine(0.0,0.0,1.0,0.0);
				cnp->LOutput->_name=name;
				cnp->LOutput->invisible=false;
				cnp->LOutput->lndsn=0;
				AssignLine(cnp->LOutput);
				EvaluateConst(cns);
				if(NOVar>=4){
					for(i=3;i<NOVar;i++){
						if(mStrcmp(var[i],"clipping")){
							cnp->LOutput->clipping=true;
						}
						if(mStrcmp(var[i],"invisible")){
							cnp->LOutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->LOutput->lndsn=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->LOutput->lndsn=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->LOutput->lndsn=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->LOutput->lndsn=4;
						}
					}
				}
				if(!CheckCoincidency(cnp->LOutput)) {
					CheckIncidency(cnp->LOutput,false);
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"Graph")){
			if(NOVar>=3){
				p=(char*)var[1].c_str();dd1=atof(p);
				p=(char*)var[2].c_str();dd2=atof(p);
				cnp = NewConst(CONST_GRAPH);
				cnp->CurveOutput = NewGraphCurve(var[0]);
				cnp->CurveOutput->para_min=dd1;
				cnp->CurveOutput->para_max=dd2;
				wxString tgt;
				EvaluateText(cns,cnp->CurveOutput->str_y,tgt,true);
				DeleteGCalc(cnp->CurveOutput->gcal_y);
				int err=MakeCalcPolynomial(tgt,&(cnp->CurveOutput->gcal_y));
				if(err){
					message.Printf(wxT("line %d : Graph syntax error %d"),linecount,err);
					wxMessageBox(message,wxT("syntax error"),wxOK | wxICON_INFORMATION, this);
					return false;
				}
				cnp->CurveOutput->_name=name;
				cnp->CurveOutput->invisible=false;
				cnp->CurveOutput->lndsn=0;
				AssignCurve(cnp->CurveOutput);
				EvaluateConst(cns);
				if(NOVar>=2){
					for(i=1;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->CurveOutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->CurveOutput->lndsn=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->CurveOutput->lndsn=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->CurveOutput->lndsn=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->CurveOutput->lndsn=4;
						}
					}
				}
			}
			else {
				message.Printf(wxT("line %d : Graph syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"PtOnCurve")){
			if(NOVar>=2 && FindNameFromCns(cns,var[0],&cn1)){
				p=(char*)var[1].c_str();dd0=atof(p);
				if(cn1->CurveOutput!=NULL){
					error=false;
				}
			}
			if(!error){
				cnp = NewConst(CONST_PT_ON_CURVE);
				cnp->CurveInput1 = cn1->CurveOutput;
				int floordd=(int)floor(dd0);
				dd0 = dd0 - 1.0*floordd;
				if(floordd<0 || floordd>=cn1->CurveOutput->orbit_len - 1){
					floordd=0;
				}
				dd1=cn1->CurveOutput->orbitx[floordd];
				dd2=cn1->CurveOutput->orbity[floordd+1];
				dd3=cn1->CurveOutput->orbitx[floordd];
				dd4=cn1->CurveOutput->orbity[floordd+1];
				cnp->POutput=NewPoint(CComplex((1-dd0)*dd1+dd0*dd3,0.0),CComplex((1-dd0)*dd2+dd0*dd4,0.0));
				cnp->POutput->_name=name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				var[1].ToDouble(&dd0);
				cnp->para1=CComplex(dd0,0.0);
				AssignPoint(cnp->POutput);
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(mStrcmp(mLeft(var[i],8),"fontsize")){
							fontsize=mMid(var[i],8);
							p=(char*)fontsize.c_str();
							fs=atoi(p);
							if(7<=fs && fs<=100){
								cnp->POutput->_fontsize=fs;
							}
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(-6.28<=ntheta && ntheta<=6.28){
								cnp->POutput->_name_theta=ntheta;
							}
						}
					}
				}
			}
			else {
				message.Printf(wxT("line %d : PtOnGraph syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"CurveTangent")){
			if(NOVar>=2 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				if(cn1->CurveOutput!=NULL &&cn2->POutput!=NULL){
					error=false;
				}
			}
			if(!error){
				cnp = NewConst(CONST_CURVE_TANGENT);
				cnp->CurveInput1=cn1->CurveOutput;
				cnp->PInput1=cn2->POutput;
				cnp->LOutput=NewLine(0.0,0.0,1.0,0.0);
				cnp->LOutput->_name=name;
				cnp->LOutput->invisible=false;
				cnp->LOutput->lndsn=0;
				AssignLine(cnp->LOutput);
				EvaluateConst(cns);
				AssignIncident(cnp->LOutput,cnp->PInput1);
				ResetLineIcPara(cnp->LOutput);
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"clipping")){
							cnp->LOutput->clipping=true;
						}
						if(mStrcmp(var[i],"invisible")){
							cnp->LOutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->LOutput->lndsn=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->LOutput->lndsn=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->LOutput->lndsn=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->LOutput->lndsn=4;
						}
					}
				}
				if(!CheckCoincidency(cnp->LOutput)) {
					//CheckIncidency(cnp->LOutput,false);
				}
			}
			else {
				message.Printf(wxT("line %d : TangentGraph syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"Tangent")){
			if(NOVar>=2 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				if(cn1->COutput!=NULL && cn2->POutput!=NULL){
					error=false;
				}
			}
			if(!error){
				cnp = NewConst(CONST_TANGENT);
				cnp->CInput1=cn1->COutput;
				cnp->PInput1=cn2->POutput;
				cnp->LOutput=NewLine(0.0,0.0,1.0,0.0);
				cnp->LOutput->_name=name;
				cnp->LOutput->invisible=false;
				cnp->LOutput->lndsn=0;
				AssignLine(cnp->LOutput);
				EvaluateConst(cns);
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"clipping")){
							cnp->LOutput->clipping=true;
						}
						if(mStrcmp(var[i],"invisible")){
							cnp->LOutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->LOutput->lndsn=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->LOutput->lndsn=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->LOutput->lndsn=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->LOutput->lndsn=4;
						}
					}
				}
				if(!CheckCoincidency(cnp->LOutput)) {
					CheckIncidency(cnp->LOutput,false);
				}
			}
			else {
				message.Printf(wxT("line %d : Tangent syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"Text")){
			if(texton){
				if(NOVar>=4){
					p=(char*)var[1].c_str();dd0=atof(p);
					p=(char*)var[2].c_str();dd1=atof(p);
					p=(char*)var[3].c_str();dd2=atof(p);
					cnp = NewConst(CONST_TEXT);
					cnp->TextOutput=NewText(ConvertTextFromScript(var[0]));
					cnp->TextOutput->tx=(int)floor(dd0);
					cnp->TextOutput->ty=(int)floor(dd1);
					cnp->TextOutput->fontsize=(int)floor(dd2);
					cnp->TextOutput->_name=name;
					cnp->TextOutput->invisible=false;
					AssignText(cnp->TextOutput);
					if(NOVar>=5){
						for(i=4;i<NOVar;i++){
							if(mStrcmp(var[i],"invisible")){
								cnp->TextOutput->invisible=true;
							}
						}
					}
				}
				else {
					message.Printf(wxT("line %d :Text syntax error"),linecount);
					wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
					loopend=true;
					return false;
				}
			}
		}
		else if(mStrcmp(function,"Compass")){
			if(NOVar>=3 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2) && FindNameFromCns(cns,var[2],&cn3)){
				cnp = NewConst(CONST_COMPASS);
				cnp->PInput1=cn1->POutput;
				cnp->PInput2=cn2->POutput;
				cnp->PInput3=cn3->POutput;
				cnp->COutput=NewCircle(0.0,0.0,1.0);
				cnp->COutput->_name=name;
				cnp->COutput->invisible=false;
				cnp->COutput->lndsn=0;
				AssignCircle(cnp->COutput);
				if(NOVar>=4){
					for(i=3;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->COutput->invisible=true;
						}
						if(mStrcmp(var[i],"clipping")){
							cnp->COutput->clipping=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->COutput->lndsn=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->COutput->lndsn=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->COutput->lndsn=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->COutput->lndsn=4;
						}
					}
				}
				if(!CheckCoincidency(cnp->COutput)) {
					CheckIncidency(cnp->COutput,false);
				}
			}
			else {
				message.Printf(wxT("line %d :Compass syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"OrbitOnCircle")){
			if(NOVar>=2 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				cnp = NewConst(CONST_ORBIT1);
				cnp->PInput1=cn1->POutput;
				cnp->PInput2=cn2->POutput;
				cnp->CurveOutput=NewCurve();
				cnp->CurveOutput->_name=name;
				cnp->CurveOutput->invisible=false;
				cnp->CurveOutput->lndsn=0;
				AssignCurve(cnp->CurveOutput);
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->CurveOutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->CurveOutput->lndsn=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->CurveOutput->lndsn=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->CurveOutput->lndsn=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->CurveOutput->lndsn=4;
						}
					}
				}
			}
			else {
				message.Printf(wxT("line %d :OrbitOnCircle syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"OrbitOnLine")){
			if(NOVar>=2 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				cnp = NewConst(CONST_ORBIT2);
				cnp->PInput1=cn1->POutput;
				cnp->PInput2=cn2->POutput;
				cnp->CurveOutput=NewCurve();
				cnp->CurveOutput->_name=name;
				cnp->CurveOutput->invisible=false;
				cnp->CurveOutput->lndsn=0;
				AssignCurve(cnp->CurveOutput);
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->CurveOutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->CurveOutput->lndsn=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->CurveOutput->lndsn=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->CurveOutput->lndsn=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->CurveOutput->lndsn=4;
						}
					}
				}
			}
			else {
				message.Printf(wxT("line %d :OrbitOnLine syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"Orthocenter")){
			if(NOVar>=3 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)  && FindNameFromCns(cns,var[2],&cn3)){
				cnp = NewConst(CONST_ORTHOCENTER);
				cnp->PInput1=cn1->POutput;
				cnp->PInput2=cn2->POutput;
				cnp->PInput3=cn3->POutput;
				px1=cnp->PInput1->xz();
				py1=cnp->PInput1->yz();
				px2=cnp->PInput2->xz();
				py2=cnp->PInput2->yz();
				px3=cnp->PInput3->xz();
				py3=cnp->PInput3->yz();
				cnp->POutput=NewPoint(
					(px2*px2-px1*px1+py2*py2-py1*py1)*(py3-py1)-(px3*px3-px1*px1+py3*py3-py1*py1)*(py2-py1) ,
					(px3*px3-px1*px1+py3*py3-py1*py1)*(px2-px1)-(px2*px2-px1*px1+py2*py2-py1*py1)*(px3-px1) ,
					CComplex(2.0,0.0)*((px2-px1)*(py3-py1)-(px3-px1)*(py2-py1)) );
				cnp->POutput->_name=name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				AssignPoint(cnp->POutput);
				if(NOVar>=3){
					for(i=2;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(mStrcmp(mLeft(var[i],8),"fontsize")){
							fontsize=mMid(var[i],8);
							p=(char*)fontsize.c_str();
							fs=atoi(p);
							if(7<=fs && fs<=100){
								cnp->POutput->_fontsize=fs;
							}
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(-6.28<=ntheta && ntheta<=6.28){
								cnp->POutput->_name_theta=ntheta;
							}
						}
					}
				}
				if(!CheckCoincidency(cnp->POutput)) {
					CheckIncidency(cnp->POutput,false);
				}
			}
		}
		else if(mStrcmp(function,"PtOn3PBisector")){
			if(NOVar>=4 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2) && FindNameFromCns(cns,var[2],&cn3)){
				p=(char*)var[3].c_str();dd1=atof(p);
				cnp = NewConst(CONST_PT_ON_3P_BISECTOR);
				cnp->PInput1=cn1->POutput;
				cnp->PInput2=cn2->POutput;
				cnp->PInput3=cn3->POutput;
				cnp->para1=CComplex(dd1,0.0);
				cnp->POutput = NewPoint(CComplex(0.0,0.0),CComplex(1.0,0.0));
				cnp->POutput->_name=name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				EvaluateConst(cns);
				AssignPoint(cnp->POutput);
				Find3PBisectorFromCns(cns,cnp->PInput1,cnp->PInput2,cnp->PInput3,&cn4);
				AssignIncident(cn4->LOutput,cnp->POutput);
				ResetLineIcPara(cn4->LOutput);
				if(NOVar>=5){
					for(i=4;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(mStrcmp(mLeft(var[i],8),"fontsize")){
							fontsize=mMid(var[i],8);
							p=(char*)fontsize.c_str();
							fs=atoi(p);
							if(7<=fs && fs<=100){
								cnp->POutput->_fontsize=fs;
							}
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(-6.28<=ntheta && ntheta<=6.28){
								cnp->POutput->_name_theta=ntheta;
							}
						}
					}
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"PtOnBisector")){
			if(NOVar>=4 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				p=(char*)var[2].c_str();dd1=atof(p);
				p=(char*)var[3].c_str();dd2=atof(p);
				cnp = NewConst(CONST_PT_ON_BISECTOR);
				cnp->LInput1=cn1->LOutput;
				cnp->LInput2=cn2->LOutput;
				cnp->para1=CComplex(dd1,0.0);
				cnp->para2=CComplex(dd2,0.0);
				cnp->POutput = NewPoint(CComplex(0.0,0.0),CComplex(1.0,0.0));
				cnp->POutput->_name=name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				EvaluateConst(cns);
				AssignPoint(cnp->POutput);
				FindBisectorFromCns(cns,cnp->LInput1,cnp->LInput2,dd1,&cn4);
				AssignIncident(cn4->LOutput,cnp->POutput);
				ResetLineIcPara(cn4->LOutput);
				if(NOVar>=5){
					for(i=4;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(mStrcmp(mLeft(var[i],8),"fontsize")){
							fontsize=mMid(var[i],8);
							p=(char*)fontsize.c_str();
							fs=atoi(p);
							if(7<=fs && fs<=100){
								cnp->POutput->_fontsize=fs;
							}
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(-6.28<=ntheta && ntheta<=6.28){
								cnp->POutput->_name_theta=ntheta;
							}
						}
					}
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"PtOnTangent")){
			if(NOVar>=3 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2) ){
				p=(char*)var[2].c_str();dd1=atof(p);
				cnp = NewConst(CONST_PT_ON_TANGENT);
				cnp->CInput1=cn1->COutput;
				cnp->PInput1=cn2->POutput;
				cnp->para1=CComplex(dd1,0.0);
				cnp->POutput = NewPoint(CComplex(0.0,0.0),CComplex(1.0,0.0));
				cnp->POutput->_name=name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				EvaluateConst(cns);
				AssignPoint(cnp->POutput);
				FindTangentFromCns(cns,cnp->CInput1,cnp->PInput1,&cn4);
				AssignIncident(cn4->LOutput,cnp->POutput);
				ResetLineIcPara(cn4->LOutput);
				if(NOVar>=4){
					for(i=3;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(mStrcmp(mLeft(var[i],8),"fontsize")){
							fontsize=mMid(var[i],8);
							p=(char*)fontsize.c_str();
							fs=atoi(p);
							if(7<=fs && fs<=100){
								cnp->POutput->_fontsize=fs;
							}
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(-6.28<=ntheta && ntheta<=6.28){
								cnp->POutput->_name_theta=ntheta;
							}
						}
					}
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"PtOnCurveTangent")){
			if(NOVar>=3 && FindNameFromCns(cns,var[0],&cn1) && FindNameFromCns(cns,var[1],&cn2)){
				p=(char*)var[2].c_str();dd1=atof(p);
				cnp = NewConst(CONST_PT_ON_CURVE_TANGENT);
				cnp->CurveInput1=cn1->CurveOutput;
				cnp->PInput1=cn2->POutput;
				cnp->para1=CComplex(dd1,0.0);
				cnp->POutput = NewPoint(CComplex(0.0,0.0),CComplex(1.0,0.0));
				cnp->POutput->_name=name;
				cnp->POutput->invisible=false;
				cnp->POutput->ptbmp=0;
				cnp->POutput->_fontsize=18;
				cnp->POutput->_name_theta=0.0;
				EvaluateConst(cns);
				AssignPoint(cnp->POutput);
				FindCurveTangentFromCns(cns,cnp->CurveInput1,cnp->PInput1,&cn4);
				AssignIncident(cn4->LOutput,cnp->POutput);
				ResetLineIcPara(cn4->LOutput);
				if(NOVar>=4){
					for(i=3;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->POutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->POutput->ptbmp=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->POutput->ptbmp=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->POutput->ptbmp=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->POutput->ptbmp=4;
						}
						else if(mStrcmp(mLeft(var[i],8),"fontsize")){
							fontsize=mMid(var[i],8);
							p=(char*)fontsize.c_str();
							fs=atoi(p);
							if(7<=fs && fs<=100){
								cnp->POutput->_fontsize=fs;
							}
						}
						else if(mStrcmp(mLeft(var[i],9),"nametheta")){
							nametheta=mMid(var[i],9);
							p=(char*)nametheta.c_str();
							ntheta=atof(p);
							if(-6.28<=ntheta && ntheta<=6.28){
								cnp->POutput->_name_theta=ntheta;
							}
						}
					}
				}
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"ParaCurve")){
			if(NOVar>=4){
				p=(char*)var[2].c_str();dd1=atof(p);
				p=(char*)var[3].c_str();dd2=atof(p);
				cnp = NewConst(CONST_PARA_CURVE);
				cnp->CurveOutput = NewParaCurve(var[0],var[1]);
				cnp->CurveOutput->para_min=dd1;
				cnp->CurveOutput->para_max=dd2;
				wxString tgt;
				EvaluateText(cns,cnp->CurveOutput->str_x,tgt,true);
				DeleteGCalc(cnp->CurveOutput->gcal_x);
				int err=MakeCalcPolynomial(tgt,&(cnp->CurveOutput->gcal_x));
				EvaluateText(cns,cnp->CurveOutput->str_y,tgt,true);
				DeleteGCalc(cnp->CurveOutput->gcal_y);
				err|=MakeCalcPolynomial(tgt,&(cnp->CurveOutput->gcal_y));
				if(err){
					message.Printf(wxT("line %d : Graph syntax error %d"),linecount,err);
					wxMessageBox(message,wxT("syntax error"),wxOK | wxICON_INFORMATION, this);
				}
				cnp->CurveOutput->_name=name;
				cnp->CurveOutput->invisible=false;
				cnp->CurveOutput->lndsn=0;
				AssignCurve(cnp->CurveOutput);
				EvaluateConst(cns);
				if(NOVar>=2){
					for(i=1;i<NOVar;i++){
						if(mStrcmp(var[i],"invisible")){
							cnp->CurveOutput->invisible=true;
						}
						else if(mStrcmp(var[i],"color2")){
							cnp->CurveOutput->lndsn=1;
						}
						else if(mStrcmp(var[i],"color3")){
							cnp->CurveOutput->lndsn=2;
						}
						else if(mStrcmp(var[i],"color4")){
							cnp->CurveOutput->lndsn=3;
						}
						else if(mStrcmp(var[i],"color5")){
							cnp->CurveOutput->lndsn=4;
						}
					}
				}
			}
			else {
				message.Printf(wxT("line %d : Graph syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"EffectPoint")){
			NOMinInput=1;
			if(NOVar>=NOMinInput && FindNameFromCns(cns,var[0],&cn1)){
				cnp = NewConst(CONST_EFFECT_POINT);
				cnp->anim_entry=cn1;
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"EffectLine")){
			NOMinInput=1;
			if(NOVar>=NOMinInput && FindNameFromCns(cns,var[0],&cn1)){
				cnp = NewConst(CONST_EFFECT_LINE);
				cnp->anim_entry=cn1;
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"EffectCircle")){
			NOMinInput=1;
			if(NOVar>=NOMinInput && FindNameFromCns(cns,var[0],&cn1)){
				cnp = NewConst(CONST_EFFECT_CIRCLE);
				cnp->anim_entry=cn1;
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"EffectCurve")){
			NOMinInput=1;
			if(NOVar>=NOMinInput && FindNameFromCns(cns,var[0],&cn1)){
				cnp = NewConst(CONST_EFFECT_CURVE);
				cnp->anim_entry=cn1;
			}
			else {
				message.Printf(wxT("line %d : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		else if(mStrcmp(function,"EffectText")){
			NOMinInput=1;
			if(NOVar>=NOMinInput && FindNameFromCns(cns,var[0],&cn1)){
				cnp = NewConst(CONST_EFFECT_TEXT);
				cnp->anim_entry=cn1;
			}
			else {
				message.Printf(wxT("line %d : EffectText : syntax error"),linecount);
				wxMessageBox(message,wxT("Syntax error"),wxOK | wxICON_INFORMATION, this);
				loopend=true;
				return false;
			}
		}
		if(cnp!=NULL){
			switch(cnp->Output_Type()){
			case OUTPUT_EFFECT:
				cnp->anim_click=0; //  1 : when clicked, 0 : immediately
				cnp->anim_direction=0; // 0 : fade , 1 : right , 2 : left , 3 : top , 4 : bottom
				cnp->anim_inout=0; //  0 : in , 1 : out
				cnp->anim_effect=0; // 0 :nothing , 1 : do effect after(before) animation 
				//EvaluateConst(cns);
				if(NOVar>NOMinInput){
					for(i=NOMinInput;i<NOVar;i++){
						if(mStrcmp(var[i],"withClick")){
							cnp->anim_click=1;
						}
						else if(mStrcmp(var[i],"immediately")){
							cnp->anim_click=0;
						}
						if(mStrcmp(var[i],"fade")){
							cnp->anim_direction=0;
						}
						else if(mStrcmp(var[i],"right")){
							cnp->anim_direction=1;
						}
						else if(mStrcmp(var[i],"left")){
							cnp->anim_direction=2;
						}
						else if(mStrcmp(var[i],"top")){
							cnp->anim_direction=3;
						}
						else if(mStrcmp(var[i],"bottom")){
							cnp->anim_direction=4;
						}
						if(mStrcmp(var[i],"in")){
							cnp->anim_inout=0;
						}
						else if(mStrcmp(var[i],"out")){
							cnp->anim_inout=1;
						}
						if(mStrcmp(var[i],"noEffect")){
							cnp->anim_effect=0;
						}
						else if(mStrcmp(var[i],"withEffect")){
							cnp->anim_effect=1;
						}
					}
				}
			}
		}
		linecount++;
	} while(!loopend);
	if(clean) {
		currentSheet=0;
		cns= sheetbuffer[currentSheet].MyConst;	
		lastcn= sheetbuffer[currentSheet].MyLastConst;
		pts= sheetbuffer[currentSheet].MyPoint;	
		lastpt= sheetbuffer[currentSheet].MyLastPoint;
		lns = sheetbuffer[currentSheet].MyLine;
		lastln = sheetbuffer[currentSheet].MyLastLine;
		cis = sheetbuffer[currentSheet].MyCircle;
		lastci = sheetbuffer[currentSheet].MyLastCircle ;
		texts = sheetbuffer[currentSheet].MyText;
		lasttext = sheetbuffer[currentSheet].MyLastText;
		curves = sheetbuffer[currentSheet].MyParaCurve;
		lastcurve = sheetbuffer[currentSheet].MyLastParaCurve;
		EvaluateConst(cns);
	}
	ResetAllName();
	Refresh(false);
	return true;
}

bool MyCanvas::GetALine(wxString& aline,wxString src,int* offset)
{
//	wxString ch;
	int i;
	char *p=(char *)src.c_str();
	int l=strlen(p);
	for(i=*offset;i<l;i++){
		if(p[i]==';'){
			aline = mMid(src,*offset,i-*offset+1);
			*offset = i+1;
			return false;
		}
	}
	aline=wxT("");
	return true;
}

bool MyCanvas::Check_Prefix(wxString& tgt,wxString& src)
{
	char ch;
	int i;
	char* p=(char*)src.c_str();
	int l=strlen(p);
	for(i=0;i<l;i++){
		ch=p[i];
		if(ch==' '){
			tgt= mLeft(src,i);
			RemoveSpace(tgt);
			src= mMid(src,i+1);
			if(mStrcmp(tgt,"line") || mStrcmp(tgt,"point") || mStrcmp(tgt,"circle") || mStrcmp(tgt,"void")
				 || mStrcmp(tgt,"graph") || mStrcmp(tgt,"text") || mStrcmp(tgt,"curve")){ 
				return false;
			}
			else {
				return true;
			}
		}
	}
	return true;
}
void MyCanvas::RemoveSpace(wxString& tgt)
{
	char* p=(char*)tgt.c_str();
	int len=strlen(p);
	int i,j=0;
	char * ret=new char[len+1];
	for(i=0;i<len;i++){
		if(p[i]==' ' || p[i]=='\r' || p[i]=='\n'){
			;
		}
		else {
			ret[j]=p[i];
			j++;
		}
	}
	ret[j]=0x00;
	tgt=wxString::Format((wxChar*)ret);
}

bool MyCanvas::Get_ElementName(wxString& tgt,wxString& src)
{
	char* p=(char*)src.c_str();
	int l=strlen(p);
	int i;
	GConst *cn1;
	wxString tmp;
	for(i=0;i<l;i++){
		if(p[i]=='='){
			tgt= mLeft(src,i);
			RemoveSpace(tgt);
			src= mMid(src,i+1);
			if(FindNameFromCns(cns,tgt,&cn1)){
				return true;
			}
			else {
				return false;
			}
		}
	}
	return true;
}
bool MyCanvas::Get_FunctionName(wxString& tgt,wxString& src)
{
	char* p=(char*)src.c_str();
	int l=strlen(p);
	int i;
	for(i=0;i<l;i++){
		if(p[i]=='('){
			tgt= mLeft(src,i);
			RemoveSpace(tgt);
			src= mMid(src,i+1);
			if(mStrcmp(tgt,"Pt") || mStrcmp(tgt,"Join") || mStrcmp(tgt,"PtOnLine") || 
				mStrcmp(tgt,"Meet") || mStrcmp(tgt,"Parallel") || mStrcmp(tgt,"Perp") || 
				mStrcmp(tgt,"Mid") || mStrcmp(tgt,"PtOnParallel") || mStrcmp(tgt,"PtOnPerp") || 
				mStrcmp(tgt,"Circle") || mStrcmp(tgt,"PtOnCircle") || mStrcmp(tgt,"MeetCircleAndLine") ||
				 mStrcmp(tgt,"Bisector") || mStrcmp(tgt,"3PBisector") || mStrcmp(tgt,"Clipping")
				  || mStrcmp(tgt,"Graph") || mStrcmp(tgt,"PtOnCurve") || mStrcmp(tgt,"Tangent") ||
				 mStrcmp(tgt,"Text")  || mStrcmp(tgt,"Compass") || mStrcmp(tgt,"Meet2Circles") ||
				 mStrcmp(tgt,"OrbitOnCircle") || mStrcmp(tgt,"OrbitOnLine") || mStrcmp(tgt,"Orthocenter") ||
				 mStrcmp(tgt,"PtOn3PBisector") || mStrcmp(tgt,"PtOnBisector") || mStrcmp(tgt,"PtOnTangent") ||
				 mStrcmp(tgt,"CurveTangent") || mStrcmp(tgt,"ParaCurve") || mStrcmp(tgt,"EffectPoint")  || mStrcmp(tgt,"EffectLine")
				  || mStrcmp(tgt,"EffectCircle")  || mStrcmp(tgt,"EffectCurve")  || mStrcmp(tgt,"EffectText")
				  || mStrcmp(tgt,"PtOnCurveTangent")){ 
				return false;
			}
			else {
				return true;
			}
		}
	}
	return true;
}
bool MyCanvas::Get_Variables(wxString *tgt,wxString& src,int *j)
{
	wxString tmp;
	char ch,ch2;
	int k=0;
	char* p=(char*)src.c_str();
	int l=strlen(p);
	int i;

	*j=0;
	for(i=0;i<l;i++){
		ch = p[i];
		ch2 = p[i+1];
		if(i>1 && p[i-1]=='\\' && p[i]==','){
			;
		}
		else if(p[i]==',' || (p[i]==')' && p[i+1]==';')){
			tgt[*j]=mMid(src,k,i-k);
			k=i+1;
			(*j) ++;
		}
	}
	
	return false;
}


