//
//  GGraph.cpp
//

#include "wx/wx.h"
#include "KidsCindyCanvas.h"
#include "resource.h"
#include "GGraph.h"
#ifdef __WXMSW__
	#include "word.h"
#else
	#include "word_e.h"
#endif

GParaCurve* MyCanvas::NewGraphCurve(wxString s)
{
	int i;
	for(i=0;i<NUM_OF_POINTS;i++){
		if(curvebuffer[i].used==false){
			curvebuffer[i].str_y=s;
			curvebuffer[i].gcal_y=NULL;
			curvebuffer[i].str_x=s;
			curvebuffer[i].gcal_x=NULL;
			curvebuffer[i].next=NULL;
			curvebuffer[i].used=true;
			curvebuffer[i].vanishing=0;
			curvebuffer[i].invisible=false;
			curvebuffer[i].lndsn=LineMode-LN_1;
			curvebuffer[i].my_cn=cns;
			return &(curvebuffer[i]);
		}
	}
	return NULL;
}

GParaCurve* MyCanvas::NewParaCurve(wxString s,wxString t)
{
	int i;
	for(i=0;i<NUM_OF_POINTS;i++){
		if(curvebuffer[i].used==false){
			curvebuffer[i].str_y=t;
			curvebuffer[i].gcal_y=NULL;
			curvebuffer[i].str_x=s;
			curvebuffer[i].gcal_x=NULL;
			curvebuffer[i].next=NULL;
			curvebuffer[i].used=true;
			curvebuffer[i].vanishing=0;
			curvebuffer[i].invisible=false;
			curvebuffer[i].lndsn=LineMode-LN_1;
			curvebuffer[i].my_cn=cns;
			return &(curvebuffer[i]);
		}
	}
	return NULL;
}

BEGIN_EVENT_TABLE(GraphDialog, wxDialog)
END_EVENT_TABLE()

#ifdef __WXMSW__
GraphDialog::GraphDialog(MyFrame *parent)
 :wxDialog((wxWindow*)parent,wxID_ANY,wxT("Input graph"),wxPoint(50,50),wxSize(400,240),wxDEFAULT_DIALOG_STYLE,wxT(""))
{
	new wxStaticText(this, wxID_ANY,GraphDlogInput,wxPoint(10,10),wxSize(330,25),wxALIGN_CENTRE);
	txt1 = new wxTextCtrl(this,GRAPH_TXT1,wxT("x"),wxPoint(10,45),wxSize(350,25));
	new wxStaticText(this, wxID_ANY,GraphDlogHelp1,wxPoint(10,80),wxSize(190,25));
	new wxStaticText(this, wxID_ANY,GraphDlogHelp2,wxPoint(10,110),wxSize(200,25));
	new wxStaticText(this, wxID_ANY,GraphDlogHelp3,wxPoint(10,140),wxSize(390,25));
	new wxButton(this,wxID_OK,wxT("OK"),wxPoint(10,170),wxSize(65,25));
	new wxButton(this,wxID_CANCEL,wxT("Cancel"),wxPoint(90,170),wxSize(65,25));
	txtmin = new wxTextCtrl(this,GRAPH_TXTMIN,wxT("-10"),wxPoint(210,80),wxSize(50,25));
	txtmax = new wxTextCtrl(this,GRAPH_TXTMAX,wxT("10"),wxPoint(300,80),wxSize(50,25));
	new wxStaticText(this, wxID_ANY,wxT("~"),wxPoint(278,80),wxSize(25,25),wxALIGN_CENTRE);
}
#else
GraphDialog::GraphDialog(MyFrame *parent)
 :wxDialog((wxWindow*)parent,wxID_ANY,wxT("Input graph"),wxPoint(50,50),wxSize(400,220),wxDEFAULT_DIALOG_STYLE,wxT(""))
{
	new wxStaticText(this, wxID_ANY,GraphDlogInput,wxPoint(10,10),wxSize(330,25),wxALIGN_CENTRE);
	txt1 = new wxTextCtrl(this,GRAPH_TXT1,wxT(""),wxPoint(10,45),wxSize(350,25));
	new wxStaticText(this, wxID_ANY,GraphDlogHelp1,wxPoint(10,80),wxSize(220,25));
	new wxStaticText(this, wxID_ANY,GraphDlogHelp2,wxPoint(10,110),wxSize(390,25));
	new wxStaticText(this, wxID_ANY,GraphDlogHelp3,wxPoint(10,140),wxSize(390,25));
	new wxButton(this,wxID_OK,wxT("OK"),wxPoint(10,170),wxSize(65,25));
	new wxButton(this,wxID_CANCEL,wxT("Cancel"),wxPoint(110,170),wxSize(65,25));
	txtmin = new wxTextCtrl(this,GRAPH_TXTMIN,wxT("-10"),wxPoint(240,80),wxSize(50,25));
	txtmax = new wxTextCtrl(this,GRAPH_TXTMAX,wxT("10"),wxPoint(320,80),wxSize(50,25));
	new wxStaticText(this, wxID_ANY,wxT("~"),wxPoint(295,80),wxSize(25,25),wxALIGN_CENTRE);
}
#endif
