#ifndef __GPOINT__
#define __GPOINT__

#include "GObject.h"
#include "Complex.h"

#include "PtBmp.h"

class GPoint :
	public GObject
{
public:
	CComplex xx,yy,zz;
	GPoint(void);
	GPoint(CComplex x,CComplex y,CComplex z);
	GPoint(CComplex a,CComplex b);
	GPoint(double xx, double yy, int rr, int gg, int bb, int radius);
	GPoint(const GPoint& p);
	~GPoint(void);
	GPoint& operator = (const GPoint& p);
	friend bool operator == (GPoint p,GPoint q);
	bool used;
	GPoint* next;
	int ptbmp;
	int phase_max;
	double _name_theta;

	CComplex xz(void);
	CComplex yz(void);

	void ClearHilight(void){
		hilighted=false;
		if(next!=NULL){
			next->ClearHilight();
		}
	};
	int NumbOfPt(void);
};

#endif
