//
//	KidsCindyCanvas.h
//

#include "GPoint.h"
#include "GLine.h"
#include "GCircle.h"
#include "GConst.h"
#include "GLnRgn.h"
#include "GCalculation.h"
#include "GText.h"
#include "incident.h"
#include "wx/timer.h"
#include "wx/string.h"
#include "wx/dcmemory.h"
#include "wx/icon.h"
class MyFrame;

#define NUM_OF_POINTS 1000

class MyCanvas: public wxWindow
{
public:
	MyCanvas( MyFrame *parent );

	void OnSize(wxSizeEvent& event);
	void OnEraseBG(wxEraseEvent& WXUNUSED(event));
	void OnMouseEvent(wxMouseEvent &event);
	void OnTimer(wxTimerEvent& event);
	void WritePrefFile();
	void ReadPrefFile();
	void SetTheme(int thm);
	void OnSave();
	void OnSaveCsv();
	MyFrame *m_owner;

	wxIcon	   m_std_icon;
	int centerx, centery;	// display coordinate of the center of the window
	wxRect relRect;	// rectangle of drawing area
	double geomcx,geomcy;	// geometric coordinate of the center of the window
	double geomperdot; 	// geometric distance per one dot
	double snapradius,snapradius2;	// distance of snap;
	double boxleft,boxright,boxtop,boxbottom;
	int windowwidth,windowheight;
	wxMemoryDC g_memdc;
	wxMemoryDC g_memBGdc;

	int DocMode,PtMode,LnMode,BgMode,ThemeMode;
	int GMode;
	bool SMode; 	// slideshow mode
	bool CloneOnOff;
	unsigned char BgR[3],BgG[3],BgB[3];
	int HilColR,HilColG,HilColB;
	int OutColR,OutColG,OutColB;
	int InColR[5],InColG[5],InColB[5];
	int HilRad,OutRad,InRad;
	int TextColR,TextColG,TextColB,TextHilColR,TextHilColG,TextHilColB;

	wxPoint currentpoint;
	bool m_lbuttondown;
	bool m_rbuttondown;
	bool m_move_dragging;
	bool m_point_dragging;
	bool m_text_dragging;
	bool m_ptname_dragging;
	bool snapped2pt;
	bool snapped2ln;
	bool snapped2ci;
	bool snapped2ccl;
	bool snapped2curve;
	bool BitMapInit;
	bool redraw;
	double startgeomx;
	double startgeomy;
	GPoint* moved_point;
	bool ShiftLButton;

	int DefaultFontSize;
	int PointMode,LineMode,BackgroundMode;
	bool Click4NewSheet;

public:
	GPoint pointbuffer[NUM_OF_POINTS];
	GLine linebuffer[NUM_OF_POINTS];
	GCircle circlebuffer[NUM_OF_POINTS];
	GConst constbuffer[NUM_OF_POINTS];
	GText textbuffer[NUM_OF_POINTS];
	GParaCurve curvebuffer[50];
	GSheet sheetbuffer[NUM_OF_POINTS];
	GIncident incidentbuffer[NUM_OF_POINTS];
	GPoint* pts;
	GPoint *pts1, *pts2, *pts3, *ptsx;
	GPoint** lastpt;
	GPoint* cursorpt;
	GPoint* cursorpt2;
	GPoint* startpt;
	GPoint* endpt;
	GLine* lns;
	GLine *lns1,*lns2,*lns3;
	GLine** lastln;
	GLine* cursorln;
	GCircle *cis;
	GCircle **lastci;
	GCircle *cursorci;
	GCircle *cis1,*cis2,*cis3;
	GConst* cns;
	GConst** lastcn;
	GConst* cursorcn;
	GText *texts;
	GText *texts1,*texts2,*texts3;
	GText **lasttext;
	GText *cursortext;
	GParaCurve *curves,*curve1,*curve2,*curve3,**lastcurve,*cursorcurve;
	int NOMySheet,currentSheet;
	bool KSEGtexton;

	wxString const_src;
	wxString last_pt_name;
	wxString last_ln_name;
	wxString last_ci_name;
	wxString last_curve_name;
	wxString last_text_name;
	wxFont font;

	wxTimer m_timer,m_timer_clone;
	GLnRgn LnDesign[5];
	int bgdsn;

	GPoint* hilightedPoints[10];
	int NOhilightedPoints;
	GLine* hilightedLines[10];
	int NOhilightedLines;
	GCircle* hilightedCircles[10];
	int NOhilightedCircles;
	GText* hilightedTexts[10];
	int NOhilightedTexts;
	GParaCurve* hilightedCurves[10];
	int NOhilightedCurves;
	bool LineClipping;
	bool AxisOn;
	wxPen AxisPen;
	wxPen AxisMeshPen;
	bool BGbmp;

	int compasscursorx,compasscursory;
	int compasscenterx,compasscentery;
	int compassradius;

	double mspointx,mspointy;
	int NOConstStock;
	GConst* PushConstStock[256];
	wxBitmap PanelButton,PanelShiftOn,PanelShiftOff,PanelAddOn,PanelAddOff,PanelMoveOn,PanelMoveOff;
	bool PanelShift,PanelAdd,PanelMove,PanelDragPoint,PanelDragText,PanelDragPointName;

public:

	////  LButton.cpp   ////

	// Universal Line-Input for definition mode;
	double geomx1,geomy1;
	GLine* ULInput1,*ULInput2;	 
	int UInputCount;

	bool next_name(wxString& tgt);
	bool next_name_sub(wxString& tgt);
	void ResetAllName();
	void SetPointName(GPoint* ptp);
	void LButtonDown(wxPoint &point);
	void LButtonDrag(wxPoint &point);
	void LButtonUp(wxPoint &point);
	void LeaveWindow(wxMouseEvent &event);
	void LDown_Move(wxPoint &point);
	void LDown_SPoint(wxPoint &point);
	void LDown_MLine(wxPoint &point);
	void LDown_Para(wxPoint &point);
	void LDown_Perp(wxPoint &point);
	void LDown_Mid(wxPoint &point);
	void LDown_MCircle(wxPoint &point);
	void LDown_Bisector(wxPoint &point);

	void LDrag_Move(wxPoint &point);
	void LDrag_SPoint(wxPoint &point);
	void LDrag_MLine(wxPoint &point);
	void LDrag_Para(wxPoint &point);
	void LDrag_Perp(wxPoint &point);
	void LDrag_Mid(wxPoint &point);
	void LDrag_MCircle(wxPoint &point);
	void LDrag_Bisector(wxPoint &point);

	void LUp_Move(wxPoint &point);
	void LUp_SPoint(wxPoint &point);
	void LUp_MLine(wxPoint &point);
	void LUp_Para(wxPoint &point);
	void LUp_Perp(wxPoint &point);
	void LUp_Mid(wxPoint &point);
	void LUp_MCircle(wxPoint &point);
	void LUp_Bisector(wxPoint &point);
	void LUp_Select(wxPoint &point);
	void LUp_Tangent(wxPoint &point);
	void LUp_Text(wxPoint &point);
	void LUp_Compass(wxPoint &point);
	void LUp_Orbit(wxPoint &point);
	void LUp_CircleBy3(wxPoint &point);

	void Sethilighted(GPoint *p);
	void Sethilighted(GLine *p);
	void Sethilighted(GCircle *p);
	void Sethilighted(GParaCurve *p);
	void Deletehilighted(GPoint *p);
	void Deletehilighted(GLine *p);
	void Deletehilighted(GCircle *p);
	void Deletehilighted(GParaCurve *p);

	void DeleteIcs(GIncident*);
	void DeleteIcs(GLine*);
	void ResetIcs(GConst* cn,GLine* ln);
	void DeleteIcs(GCircle*);
	void ResetIcs(GConst* cn,GCircle* ci);
	void DeletePtFromIcs(GPoint* pt);

	////  RButton.cpp   ////
	void RButtonDown(wxPoint &point);
	void RButtonDrag(wxPoint &point);
	void RButtonUp(wxPoint &point);

	//// Snapping.cpp  ////
	bool Snapping(GPoint* p, double* gx,double* gy,GPoint** pt);
	bool NearPoint(GPoint* p, double* gx,double* gy,GPoint** pt);
	bool Snap2Line(GLine* lines, double* gx, double* gy);
	int Snap2LineEx(GLine* lines, double* gx,double* gy, GLine** ln1, GLine** ln2);
	bool Snap2Circle(GCircle* circles, double* gx, double* gy);
	int Snap2CircleEx(GCircle* circles, double* gx,double* gy, GCircle** ci1, GCircle** ci2);
	void SelectHilight(GPoint* pt, double gx,double gy);
	void SelectHilight(GLine* ln, double gx,double gy);
	void SelectHilight(GCircle* ci, double gx,double gy);
	void SelectHilight(GParaCurve* curve, double gx,double gy);
	void PtDragHilight(GPoint* pt, double gx,double gy);
	void PtDragHilight(GLine* ln, double gx,double gy);
	void PtDragHilight(GCircle* ci, double gx,double gy);
	void PtDragHilight(GParaCurve* cu, double gx,double gy);
	bool Snap2Text(GText* texts, int px,int py);
	bool Snap2Curve(GParaCurve* curve, double* gx,double *gy);
	int Snap2CurveEx(GParaCurve* cu, double* gx,double* gy, GParaCurve** cu1, GParaCurve** cu2);
	bool Snap2PtName(GPoint* texts, int px,int py);

	//// GConst.cpp  ////
	GConst* NewConst(int consttype);
	bool ConstFree(double gx,double gy,bool hilight);
	bool ConstOnLine(GLine* ln1);
	bool ConstOnCircle(GCircle* ci1);
	bool ConstOnCurve(GParaCurve* cu);
	bool ConstMeet(GLine* ln1, GLine* ln2);
	bool ConstMeet(GCircle* ci1, GLine* ln1,double gx,double gy);
	bool ConstMeet(GCircle* ci1, GCircle* ci2,double gx,double gy);	
	bool DeletePtFromCn(GConst** cn,GPoint* pt);
	bool DeleteLnFromCn(GConst** cn,GLine* pt);
	bool DeleteCiFromCn(GConst** cn,GCircle* pt);
	bool DeleteAllConstFromSheet(GConst *cn);
	bool EvaluateConst(GConst* cns);
	bool SetConstSrc(GConst* cn);
	void ClearConst();
	bool const_src2cns(bool clean=false,bool texton=true);
	bool GetALine(wxString& aline,wxString src,int* offset);
	void RemoveSpace(wxString& tgt);
	bool Check_Prefix(wxString& tgt,wxString& src);
	bool Get_ElementName(wxString& tgt,wxString& src);
	bool Get_FunctionName(wxString& tgt,wxString& src);
	bool Get_Variables(wxString *tgt,wxString& src,int *j);

	void ClearAllHilights();
	void InsertNewSheet();
	void InsertCopyFigure(bool texton);
	void DeleteSheet();
	void ClearSheet();
	bool NextSheet(void);
	void PrevSheet(void);
	//wxString ConvertText4Script(wxString& st);
	wxString ConvertTextFromScript(wxString& st);
	bool duplicate_line(GLine* lnp, GLine* ln);
	void OnBenchMark(void);

	/// ConstDef.cpp ////
	void ConstDefLine();
	void ConstDefClippingLine();
	void LineClippingon();
	void ConstDefMeet();
	void ConstDefPara();
	void ConstDefPerp();
	void ConstDefMid();
	GCircle* ConstDefCircle();
	void ConstDefBisector();
	void ConstDefTangent();
	void ConstDefCircleBy3();
	void ConstDefOrbit();
	GCircle* ConstDefCompass();
	void ConstDefCurveTangent();

	//// Find.cpp ////
	bool FindAnotherMeet(GCircle* ci1, GLine *ln1,GPoint ** ptH);
	bool FindAnotherMeet(GCircle* ci1, GCircle *ci2,GPoint ** ptH);
	GPoint* FindPtFromPts(GPoint* ptp,GPoint* pt);
	bool FindJoinFromCns(GConst* cn,GPoint* pt1,GPoint*p2,GConst** cn1);
	bool FindParaFromCns(GConst* cn,GLine* ln1,GPoint* pt1,GConst** cn1);
	bool FindPerpFromCns(GConst* cn,GLine* ln1,GPoint* pt1,GConst** cn1);
	bool FindMeetFromCn(GConst* cn,GLine* ln1,GLine* ln2,GConst **cn1);
	bool Find3PBisectorFromCns(GConst* cn,GPoint* pt1,GPoint* pt2,GPoint* pt3,GConst** cn1);
	bool FindBisectorFromCns(GConst* cn,GLine* ln1,GLine* ln2,double dd1,GConst** cn1);
	bool FindTangentFromCns(GConst* cn,GCircle* ci,GPoint* pt,GConst** cn1);
	bool FindNextEffectFromCns();

	//// GPoint.cpp  ////
	GPoint* NewPoint(CComplex a,CComplex b);
	GPoint* NewPoint(CComplex a,CComplex b,CComplex c);
	void AssignPoint(GPoint* pt);
//	bool DeletePoint(GPoint* p);
	bool DeleteAllPoints(GPoint* p);
	GPoint* makePClone(GPoint* p);
	bool copyToPClone(GPoint* tgt,GPoint*src);
	bool deletePClone(GPoint* l);

	////  GLine.cpp  ////
	GLine* NewLine(double x1, double y1, double x2, double y2/*, int rr, int gg, int bb, int radius*/);
	GLine* NewLine(CComplex xxx, CComplex yyy, CComplex zzz/*,int rr, int gg, int bb, int radius*/);
	void AssignLine(GLine* ln);
	//bool DeleteLine(GLine* l);
	bool DeleteAllLines(GLine* l);
	GLine* makeLClone(GLine* l);
	bool copyToLClone(GLine* tgt,GLine*src);
	bool deleteLClone(GLine* l);

	//// GGraph.cpp ////
	GParaCurve* NewGraphCurve(wxString s);
	GParaCurve* NewParaCurve(wxString s,wxString t);

	////  GCircle.cpp  ////
	GCircle* NewCircle(double cx,double cy,double cr);
	void AssignCircle(GCircle* pt);
	bool DeleteAllCircles(GCircle* l);
	GCircle* makeCClone(GCircle* l);
	bool copyToCClone(GCircle* tgt,GCircle* src);
	bool deleteCClone(GCircle* l) ;

	//// GText.cpp  ////
	GText* NewText(wxString s);
	void AssignText(GText* pt);
	bool DeleteAllTexts(GText* p);

	//// GParaCurve.cpp ///
	GParaCurve* NewCurve(void);
	void AssignCurve(GParaCurve* pt);

	////  Meet.cpp  ////
	bool incident(GLine* ln, GPoint* pt);
	bool incident(GCircle* ci, GPoint* pt);

	/// Draw.cpp  ////
	void OnPaint(wxPaintEvent &event);
	void OnDraw(wxMemoryDC *pDC);
	void DrawBackGround(wxMemoryDC* pDC);
	void DrawAxis(wxMemoryDC* pDC);
	bool DrawOnePoint(GPoint* p,wxMemoryDC* pDC);
	bool DrawPoints(GConst* cnp,wxMemoryDC* pDC);
	bool DrawPoints(GPoint* p,wxMemoryDC* pDC);
	bool GetGeomXY(GLine* p, double* dispx0, double* dispy0, double* dispx1, double* dispy1);
	bool DrawOneLine(GLine* p, wxMemoryDC* pDC);
	bool DrawLines(GLine* p, wxMemoryDC* pDC);
	bool DrawOneCircle(GCircle* p, wxMemoryDC* pDC);
	bool DrawCircles(GCircle* p, wxMemoryDC* pDC);
	bool DrawOneCurve(GParaCurve* p, wxMemoryDC* pDC);
	bool DrawCurves(GParaCurve* p, wxMemoryDC* pDC);
	bool DrawOneText(GText* p,wxMemoryDC* pDC);
	bool DrawTexts(GText* p,wxMemoryDC* pDC);
	bool DrawMultiText(GText* p,wxString &st,wxMemoryDC* pDC,int px,int py);
	bool GetMultiTextSize(wxString st,wxMemoryDC* pDC,int *px,int *py);
	bool DrawPanelButton(wxMemoryDC* pDC);

	bool DrawCompassCircle(wxMemoryDC* pDC);

	////  Menu.cpp  ////
	void OnPt(int id);
	void OnLn(int id);
	void OnCloneOn(void);
	void OnCloneOff(void);
	void DeleteConst(GConst* cn);
	void PushConst(GConst* cn);
	GConst*  PopConst();
	void DeletePoint(GPoint* pt);
	void DeleteLine(GLine* ln);
	void DeleteCircle(GCircle* ci);
	void DeleteText(GText* text);
	void DeleteCurve(GParaCurve* curve);
	void OnUndo();
	void OnRedo();
	void OnModeInvisible();
	void OnModeZoomIn();
	void OnModeZoomOut();
	void AnimationProperty();

	// Incident.cpp
	bool point_coincide_local(GPoint* pt1,GPoint* pt2);
	bool point_coincide_global(GConst* cnp,GPoint* pt1,GPoint* pt2);
	bool line_coincide_local(GLine* ln1,GLine* ln2);
	bool line_coincide_global(GConst* cnp,GLine* ln1,GLine* ln2);
	bool circle_coincide_local(GCircle* ci1,GCircle* ci2);
	bool circle_coincide_global(GConst* cnp,GCircle* ci1,GCircle* ci2);
	bool incident_LP_local(GLine* ln, GPoint* pt);
	bool incident_LP_global(GConst* cnp,GLine* ln, GPoint* pt);
	bool incident_CP_local(GCircle* ci, GPoint* pt);
	bool incident_CP_global(GConst* cnp,GCircle* ci, GPoint* pt);
	bool tangent_CL_local(GCircle* ci, GLine* ln);
	bool tangent_CL_global(GConst* cnp,GCircle* ci, GLine* ln);
	bool tangent_CC_local(GCircle* ci1, GCircle* ci2);
	bool tangent_CC_global(GConst* cnp,GCircle* ci1, GCircle* ci2);

	void AssignIncident(GLine*ln,GPoint*pt,double icpara=0.0);
	void AssignIncident(GCircle*ln,GPoint*pt,double icpara=0.0);
	void CheckIncidency(GPoint*pt,bool msg=true);
	void CheckIncidency(GLine*ln,bool msg=true);
	void CheckIncidency(GCircle*ci,bool msg=true);
	
	bool CheckCoincidency(GPoint*pt);
	bool CheckCoincidency(GLine*ln);
	bool CheckCoincidency(GCircle*ci);
	void ResetLineIcPara(GLine* ln);
	void ResetCircleIcPara(GCircle* ci);

	// Animation.cpp
	void AddConstEffect(GConst*, int, int, int, int);
	void ClearConstEffect();
	void SlideShowStart(GConst* cnp);
	void Animnext();

	bool anim_wait;
	GConst* anim_cn;

private:
	DECLARE_EVENT_TABLE()
};

	 void Meet(GCircle* ca, GCircle* cb,double *gx,double *gy);
	 bool FindPtFromCn(GConst* cn,GPoint* pt,GConst **cn1);
	 bool FindLnFromCn(GConst* cn,GLine* ln,GConst **cn1);
	 bool FindCiFromCn(GConst* cn,GCircle* ci,GConst **cn1);
	 bool FindCurveFromCns(GConst* cn,GParaCurve* cu,GConst **cn1);
	 bool FindNameFromCns(GConst* cn,wxString& name,GConst** cn1);
	 bool FindCnFromPt(GConst* cn,GPoint* pt,GConst** cn1);
	 bool FindCurveTangentFromCns(GConst* cn,GParaCurve* cu,GPoint* pt,GConst** cn1);
	 bool EvaluateText(GConst* cn,wxString& src, wxString& tgt,bool paren=false);
	 void AddYenCommaOnText(wxString& src);
	 void RemoveYenCommaOnText(wxString& src);

// ConstSrc.cpp
	wxString mMid(wxString &src,int i);
	wxString mMid(wxString &src,int i,int j);
	wxString mLeft(wxString &src,int i);
	bool mStrcmp(wxString src,wxString tgt);
	bool mStrcmp(wxString src,char* tgt);
	bool mAppend(wxString& src,wxString& tgt);
