//
//	lbutton.cpp
//
//

#include <math.h>
#include "wx/wx.h"
#include "wx/string.h"
#include "wx/timer.h"
#include "KidsCindyCanvas.h"
#include "KidsCindyFrame.h"
#include "resource.h"
#include "Meet.h"
#include "GConst.h"
#include "incident.h"
#ifdef __WXMSW__
	#include "word.h"
#else
	#include "word_e.h"
#endif


double abs(double a);

bool MyCanvas::next_name(wxString& tgt)
{
	GConst* cnp;
	do{
		if(next_name_sub(tgt)) return true;
	} while (FindNameFromCns(cns,tgt,&cnp));
	return false;
}

bool MyCanvas::next_name_sub(wxString& tgt)
{
	char c,d;
	char* p=(char*)tgt.c_str();
	int tgtlen=strlen(p);
	if(mStrcmp(tgt,"ZZZ")){
		tgt=wxString((wxChar*)"A");return false;
	}
	else if(mStrcmp(tgt,"zzz")){
		tgt=wxString((wxChar*)"a");return false;
	}
	else if(mStrcmp(tgt,"SZZ")){
		tgt=wxString((wxChar*)"TA");return false;
	}
	else if(tgtlen<=1){
		c=p[0];
		if((c>='A' && c<'Z') || (c>='a' && c<'z')){
			p[0]++;p[1]=0;
			tgt=wxString((wxChar*)p);
		}
		else if(c=='Z'){
			tgt=wxString((wxChar*)"AA");return false;
		}
		else if(c=='z'){
			tgt=wxString((wxChar*)"aa");return false;
		}
		return false;
	}
	else {
		c=p[tgtlen-1];
		d=p[tgtlen-2];
		if((c>='0' && c<'9') || (c>='A' && c<'Z') || (c>='a' && c<'z')){
			p[tgtlen-1]++;p[tgtlen]=0;
			tgt=wxString((wxChar*)p);
		}
		else if(c=='9'){
			p[tgtlen-2]++;p[tgtlen-1]='0';p[tgtlen]=0x00;
			tgt=wxString((wxChar*)p);
		}
		else if(c=='Z'){
			p[tgtlen-2]++;p[tgtlen-1]='A';p[tgtlen]=0x00;
			tgt=wxString((wxChar*)p);
		}
		else if(c=='z'){
			p[tgtlen-2]++;p[tgtlen-1]='a';p[tgtlen]=0x00;
			tgt=wxString((wxChar*)p);
		}
		else {
			//tgt=tgt.Left(tgtlen-2)+wxString::SetChar(1,tgt.GetChar(1)+1);
			return true;
		}
	}
	return false;
}

void MyCanvas::ResetAllName()
{
	last_pt_name=wxString((wxChar*)"ZZZ");
	next_name(last_pt_name);
	last_ln_name=wxString((wxChar*)"zzz");
	next_name(last_ln_name);
	last_ci_name=wxString((wxChar*)"C0");
	next_name(last_ci_name);
	last_curve_name=wxString((wxChar*)"x0");
	next_name(last_curve_name);
	last_text_name=wxString((wxChar*)"SZZ");
	next_name(last_text_name);
}

void MyCanvas::SetPointName(GPoint* ptp)
{
	ptp->_name=wxString((wxChar*)last_pt_name.c_str());
	next_name(last_pt_name);
	ptp->_fontsize=DefaultFontSize;
	ptp->_name_theta=0.0;
}

void MyCanvas::LButtonDown(wxPoint &point)
{
	m_lbuttondown=true;
	if(SMode){
		if(anim_wait==true){
			anim_wait=false;
			if(Click4NewSheet){
				if(NextSheet()){
					SlideShowStart(cns);
					Click4NewSheet=false;
				}
				else {
					SMode=false;
					anim_cn=NULL;
					wxMessageBox(EndSlideShow,wxT(""),wxOK | wxICON_INFORMATION, this);
				}
			}
		}
	}
	else if(GMode==MODE_CINDY){
		switch(DocMode){
		case MODE_MOVE:
			LDown_Move(point);break;
		case MODE_SINGLE_ADD:
			LDown_SPoint(point);break;
		case MODE_MULTI_LINE:
			LDown_MLine(point);break;
		case MODE_PARALLEL:
			LDown_Para(point);break;
		case MODE_PERP:
			LDown_Perp(point);break;
		case MODE_MID:
			LDown_Mid(point);break;
		case MODE_MULTI_CIRCLE:
			LDown_MCircle(point);break;
		case MODE_BISECTOR:
			LDown_Bisector(point);break;
		}
	}
	else if(GMode==MODE_KSEG){
		LDown_Move(point);
	}
}

void MyCanvas::LButtonDrag(wxPoint &point)
{
	if(GMode==MODE_CINDY){
		switch(DocMode){
		case MODE_MOVE:
			LDrag_Move(point);break;
		case MODE_SINGLE_ADD:
			LDrag_SPoint(point);break;
		case MODE_MULTI_LINE:
			LDrag_MLine(point);break;
		case MODE_PARALLEL:
			LDrag_Para(point);break;
		case MODE_PERP:
			LDrag_Perp(point);break;
		case MODE_MID:
			LDrag_Mid(point);break;
		case MODE_MULTI_CIRCLE:
			LDrag_MCircle(point);break;
		case MODE_BISECTOR:
			LDrag_Bisector(point);break;
		}
	}
	else if(GMode==MODE_KSEG){
		LDrag_Move(point);
	}
}

void MyCanvas::LButtonUp(wxPoint &point)
{
	m_lbuttondown=false;
	if(GMode==MODE_CINDY){
		switch(DocMode){
		case MODE_MOVE:
			LUp_Move(point);break;
		case MODE_SINGLE_ADD:
			LUp_SPoint(point);break;
		case MODE_MULTI_LINE:
			LUp_MLine(point);break;
		case MODE_PARALLEL:
			LUp_Para(point);break;
		case MODE_PERP:
			LUp_Perp(point);break;
		case MODE_MID:
			LUp_Mid(point);break;
		case MODE_MULTI_CIRCLE:
			LUp_MCircle(point);break;
		case MODE_BISECTOR:
			LUp_Bisector(point);break;
		case MODE_SELECT:
			LUp_Select(point);break;
		case MODE_TANGENT:
			LUp_Tangent(point);break;
		case MODE_TEXT:
			LUp_Text(point);break;
		case MODE_COMPASS:
			LUp_Compass(point);break;
		case MODE_ORBIT:
			LUp_Orbit(point);break;
		case MODE_CIRCLE_BY_3:
			LUp_CircleBy3(point);break;
		}
	}
	else if(GMode==MODE_KSEG){
		LUp_Move(point);
		LUp_Select(point);
		m_owner->enableToolbar();
	}
	else if(GMode==MODE_PANEL){
		wxRect PShift=wxRect(0,relRect.GetHeight()-32,64,32);
		wxRect PAdd=wxRect(64,relRect.GetHeight()-32,64,32);
		wxRect PMove=wxRect(128,relRect.GetHeight()-32,64,32);
		if(PShift.Inside(point)){
			PanelShift = !PanelShift;
		}
		else if(PAdd.Inside(point)){
			PanelAdd = !PanelAdd;
		}
		else if(PMove.Inside(point)){
			PanelMove = !PanelMove;
			PanelDragPoint=PanelDragText=PanelDragPointName=false;
		}
		else {
			if(PanelMove){
				if(!PanelDragPoint && !PanelDragText && !PanelDragPointName){
					ShiftLButton=PanelShift;
					LDown_Move(point);
				}
				else {
					m_move_dragging=PanelDragPoint;
					m_text_dragging=PanelDragText;
					m_ptname_dragging=PanelDragPointName;
					ShiftLButton=PanelShift;
					LDrag_Move(point);
					LUp_Move(point);
					PanelDragPoint=PanelDragText=PanelDragPointName=false;
				}
			}
			else if(PanelAdd){
				if(!KSEGtexton){
					ShiftLButton=PanelShift;
					LDown_SPoint(point);
					LDrag_SPoint(point);
					LUp_SPoint(point);
					m_owner->enableToolbar();
				}
				else {
					LUp_Text(point);
				}
			}
			else{
				ShiftLButton=PanelShift;
				LUp_Select(point);
				m_owner->enableToolbar();
			}

		}
	}
	Refresh(false);
}

void MyCanvas::LeaveWindow(wxMouseEvent &event)
{
	if(m_lbuttondown){
		LButtonUp(currentpoint);
	}
	if(m_rbuttondown){
		RButtonUp(currentpoint);
	}
}

void MyCanvas::LDown_Move(wxPoint& point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	if(m_move_dragging = NearPoint(pts,&geomx,&geomy,&moved_point)){
		mspointx=moved_point->xz().real()-geomx;
		mspointy=moved_point->yz().real()-geomy;
		wxStartTimer();
		if(CloneOnOff){
			OnCloneOn();
		}
		PanelDragPoint=true;
	}
	if(!ShiftLButton && pts!=NULL){
		pts->ClearHilight();
		NOhilightedPoints=0;
	}
	if(!ShiftLButton && lns!=NULL){
		lns->ClearHilight();
		NOhilightedLines=0;
	}
	if(!ShiftLButton && cis!=NULL){
		cis->ClearHilight();
		NOhilightedCircles=0;
	}
	if(!ShiftLButton && curves!=NULL){
		curves->ClearHilight();
		NOhilightedCurves=0;
	}
	if(!ShiftLButton && texts!=NULL){
		texts->ClearHilight();
	}
	if(moved_point!=NULL){
		Sethilighted(moved_point);
	}
	if(!m_move_dragging && Snap2Text(texts,point.x,point.y)){
		PanelDragText=m_text_dragging=true;
		cursortext->hilighted=true;
	}
	else if(!m_move_dragging && ShiftLButton && Snap2PtName(pts,point.x,point.y)){
		PanelDragPointName=m_ptname_dragging=true;
	}
}

void MyCanvas::LDrag_Move(wxPoint &point)
{
	if(m_move_dragging){
		GConst *cnp,*cnq;
		double geomx=geomcx+(point.x-centerx)*geomperdot+mspointx;
		double geomy=geomcy-(point.y-centery)*geomperdot+mspointy;
		if(wxGetElapsedTime(false)>200){
			if(CloneOnOff){
				copyToPClone(pts3,pts2);
				copyToPClone(pts2,pts1);
				copyToPClone(pts1,pts);
				copyToLClone(lns3,lns2);
				copyToLClone(lns2,lns1);
				copyToLClone(lns1,lns);
				copyToCClone(cis3,cis2);
				copyToCClone(cis2,cis1);
				copyToCClone(cis1,cis);
				Refresh(false);
			}
			else if((PtMode==PT_STANDARD || PtMode==PT_CAT || PtMode==PT_STAR || PtMode==PT_SKELETON) && NOhilightedPoints>0){
				Refresh(false);
			}
			wxStartTimer();
		}
		if(FindPtFromCn(cns,moved_point,&cnp)){
			if(cnp->Const_Type==CONST_FREE){
				moved_point->xx = CComplex(geomx,0.0);
				moved_point->yy = CComplex(geomy,0.0);
				moved_point->zz = CComplex(1.0,0.0);
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_ON_LINE){
				CComplex ax=cnp->PInput1->xz() - CComplex(geomx,0.0);
				CComplex ay=cnp->PInput1->yz() - CComplex(geomy,0.0);
				CComplex bx=cnp->PInput2->xz() - CComplex(geomx,0.0);
				CComplex by=cnp->PInput2->yz() - CComplex(geomy,0.0);
				CComplex ss=(ax*(ax-bx)+ay*(ay-by))/((ax-bx)*(ax-bx)+(ay-by)*(ay-by));
				cnp->para1=ss;
				cnp->para2=CComplex(1.0,0.0) - ss;
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_PARA){
				CComplex ax=cnp->PInput1->xz() - CComplex(geomx,0.0);
				CComplex ay=cnp->PInput1->yz() - CComplex(geomy,0.0);
				CComplex bx=cnp->LInput1->yy;
				CComplex by=cnp->LInput1->xx * CComplex(-1.0,0.0);
				CComplex ss=(ax*bx+ay*by)/(bx*bx+by*by);
				cnp->para1=ss;
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_PERP){
				CComplex ax=cnp->PInput1->xz() - CComplex(geomx,0.0);
				CComplex ay=cnp->PInput1->yz() - CComplex(geomy,0.0);
				CComplex bx=cnp->LInput1->xx * CComplex(-1.0,0.0);
				CComplex by=cnp->LInput1->yy * CComplex(-1.0,0.0);
				CComplex ss=(ax*bx+ay*by)/(bx*bx+by*by);
				cnp->para1=ss;
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_CIRCLE){
				double vx=geomx - cnp->CInput1->xx.real();	
				double vy=geomy - cnp->CInput1->yy.real();
				double theta = atan2(-vy,vx);
				double theta0 = cnp->para1.real();
				double thetastep=0.3;
				if(theta0>theta){
					for(double thp=theta0-thetastep;thp>=theta+thetastep;thp-=thetastep){
						cnp->para1=CComplex(thp,0.0);
						EvaluateConst(cns);
					}
				}
				else {
					for(double thp=theta0+thetastep;thp<=theta-thetastep;thp+=thetastep){
						cnp->para1=CComplex(thp,0.0);
						EvaluateConst(cns);
					}
				}
				cnp->para1=CComplex(theta,0.0);
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_CURVE){
				double g1x,g1y,g2x,g2y;
				double x0,y0,t=0.0;
				bool snap=false;
				int i;
				g1x=cnp->CurveInput1->orbitx[0];
				g1y=cnp->CurveInput1->orbity[0];
				for(i=1;i<cnp->CurveInput1->orbit_len && !snap;i++){
					g2x=cnp->CurveInput1->orbitx[i];
					g2y=cnp->CurveInput1->orbity[i];
					if(g1x!=g2x || g1y!=g2y){
						t = ((geomx-g1x)*(g2x-g1x)+(geomy-g1y)*(g2y-g1y)) / ((g2x-g1x)*(g2x-g1x)+(g2y-g1y)*(g2y-g1y));
						x0 = g1x*(1-t)+g2x*t;
						y0 = g1y*(1-t)+g2y*t;
						if(t>=0.0 && t<1.0 && (x0- geomx)*(x0 - geomx)+(y0 - geomy)*(y0 - geomy) < snapradius2*10  && cnp->CurveInput1->invisible==false){
							snap=true;
						}
					}
					g1x=g2x;g1y=g2y;
				}
				if(snap){
					cnp->para1=CComplex(1.0*(i-2)+t,0.0);
				}
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_3P_BISECTOR){
				double g1x=cnp->PInput1->xz().real();
				double g1y=cnp->PInput1->yz().real();
				double g2x=cnp->PInput2->xz().real();
				double g2y=cnp->PInput2->yz().real();
				double g3x=cnp->PInput3->xz().real();
				double g3y=cnp->PInput3->yz().real();
				double norm12 = sqrt((g1x-g2x)*(g1x-g2x)+(g1y-g2y)*(g1y-g2y));
				double norm32 = sqrt((g3x-g2x)*(g3x-g2x)+(g3y-g2y)*(g3y-g2y));
				if(norm12<0.0001){
					norm12=1.0;
					g1x=g2x+1.0;
					g1y=g2y;
				}
				if(norm32<0.0001){
					norm32=1.0;
					g3x=g2x;
					g3y=g2y+1.0;
				}
				g1x=g2x + (g1x-g2x)/norm12;
				g1y=g2y + (g1y-g2y)/norm12;
				g3x=g2x + (g3x-g2x)/norm32;
				g3y=g2y + (g3y-g2y)/norm32;
				double g4x = (g1x+g3x)*0.5 - g2x;
				double g4y = (g1y+g3y)*0.5 - g2y;
				double norm4 = sqrt(g4x*g4x+g4y*g4y);
				if(norm4!=0){
					g4x/=norm4;
					g4y/=norm4;
				}
				else {
					g4x = g1y-g3y;
					g4y = - g1x+g3x;
					norm4 = sqrt(g4x*g4x+g4y*g4y);
					g4x/=norm4;
					g4y/=norm4;
				}
				double para;
				if(g4y==0.0){
					para = (geomx - g2x) / g4x;
				}
				else {
					para = (geomy - g2y) / g4y;
				}
				cnp->para1=CComplex(para,0.0);
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_BISECTOR){
				GLine* ln1=cnp->LInput1;
				GLine* ln2=cnp->LInput2;
				CComplex g1x = ln1->yy * ln2->zz -  ln1->zz * ln2->yy;
				CComplex g1y = ln1->zz * ln2->xx -  ln1->xx * ln2->zz;
				CComplex g1z = ln1->xx * ln2->yy -  ln1->yy * ln2->xx;
				CComplex g2x = sqrtC(ln2->xx * ln2->xx + ln2->yy * ln2->yy) * ln1->xx + cnp->para1 * sqrtC(ln1->xx * ln1->xx + ln1->yy * ln1->yy) * ln2->xx;
				CComplex g2y = sqrtC(ln2->xx * ln2->xx + ln2->yy * ln2->yy) * ln1->yy + cnp->para1 * sqrtC(ln1->xx * ln1->xx + ln1->yy * ln1->yy) * ln2->yy;
				if(g1z==CComplex(0.0,0.0)){
					cnp->para2=CComplex(0.0,0.0);
				}
				else {
					CComplex ax= CComplex(geomx,0.0) - g1x / g1z;
					CComplex ay= CComplex(geomy,0.0) - g1y / g1z;
					CComplex by= g2x;
					CComplex bx= g2y;
					CComplex nn = sqrtC(g2x * g2x + g2y * g2y);
					bx /= nn;
					by /= nn;
					CComplex ss=(ax*bx+ay*by);
					cnp->para2=ss;
				}
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_TANGENT){
				CComplex ax=cnp->PInput1->xz() - CComplex(geomx,0.0);
				CComplex ay=cnp->PInput1->yz() - CComplex(geomy,0.0);
				CComplex bx=(cnp->CInput1->yy - cnp->PInput1->yz()) * CComplex(-1.0,0.0) ;
				CComplex by=(cnp->CInput1->xx - cnp->PInput1->xz());
				CComplex ss=(ax*bx+ay*by)/(bx*bx+by*by);
				cnp->para1=ss;
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_CURVE_TANGENT){
				FindCurveTangentFromCns(cns,cnp->CurveInput1,cnp->PInput1,&cnq);
				CComplex ax=cnp->PInput1->xz() - CComplex(geomx,0.0);
				CComplex ay=cnp->PInput1->yz() - CComplex(geomy,0.0);
				CComplex bx= cnq->LOutput->yy * CComplex(-1.0,0.0) ;
				CComplex by= cnq->LOutput->xx ;
				CComplex ss=(ax*bx+ay*by)/(bx*bx+by*by);
				cnp->para1=ss;
				EvaluateConst(cns);
				redraw=true;
			}
		}
	}
	else if(m_text_dragging){
		cursortext->tx=point.x-cursortext->m_text_dragging_h_length;
		cursortext->ty=point.y-cursortext->m_text_dragging_h_height;
		redraw=true;
	}
	else if(m_ptname_dragging){
		int dispx= centerx + (int)floor((cursorpt->xz().real()-geomcx)/geomperdot);
		int dispy= centery - (int)floor((cursorpt->yz().real()-geomcy)/geomperdot);
		cursorpt->_name_theta = atan2(-point.y+dispy,point.x-dispx);
		redraw=true;
	}
}

void MyCanvas::LUp_Move(wxPoint &point)
{
	if(m_move_dragging){
		m_move_dragging= false;
		if(CloneOnOff){
			OnCloneOff();
		}
	}
	if(!ShiftLButton && pts!=NULL){
		pts->ClearHilight();
	}
	if(moved_point!=NULL){
		Sethilighted(moved_point);
	}
	moved_point=NULL;
	m_text_dragging=false;
	m_ptname_dragging=false;
	cursortext=NULL;
}

void MyCanvas::LDown_SPoint(wxPoint &point)
{
	if(!ShiftLButton){
		ClearAllHilights();
	}
	double startgeomx=geomcx+(point.x-centerx)*geomperdot;
	double startgeomy=geomcy-(point.y-centery)*geomperdot;
	ConstFree(startgeomx,startgeomy,true);
	m_point_dragging = true;
	snapped2pt=snapped2ln=snapped2ci=false;
	Refresh(false);
}

void MyCanvas::LDrag_SPoint(wxPoint &point)
{
	//if(lbuttondown && point_dragging){
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint *pt1;
	snapped2pt=Snapping(pts,&geomx,&geomy,&pt1);
	snapped2ln=Snap2Line(lns,&geomx,&geomy);
	PtDragHilight(lns,geomx,geomy);
	snapped2ci=Snap2Circle(cis,&geomx,&geomy);
	PtDragHilight(cis,geomx,geomy);
	snapped2curve=Snap2Curve(curves,&geomx,&geomy);
	PtDragHilight(curves,geomx,geomy);
	PtDragHilight(pts,geomx,geomy);
	cursorpt->xx.SetComplex(geomx,0.0);
	cursorpt->yy.SetComplex(geomy,0.0);
	redraw=true;
}

void MyCanvas::LUp_SPoint(wxPoint &point)
{
	double geomx,geomy;
	int lncount,cicount,cucount;
	GLine *ln1,*ln2;
	GCircle *ci1,*ci2;
	GParaCurve *cu1,*cu2;
	if(!snapped2pt && !snapped2ln && !snapped2ci && !snapped2curve){//?_??????????????_????????
		SetPointName(cursorpt);
		AssignPoint(cursorpt);
	}
	else if(snapped2pt){//
		DeletePtFromCn(&(cns),cursorpt);
		DeletePoint(cursorpt);
		*(lastpt)=NULL;
	}		
	else if(snapped2ln){ // on a line
		geomx=geomcx+(point.x-centerx)*geomperdot;
		geomy=geomcy-(point.y-centery)*geomperdot;
		lncount= Snap2LineEx(lns,&geomx,&geomy,&ln1,&ln2);
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		if(snapped2ci && lncount==1){ //case 3
			Snap2CircleEx(cis,&geomx,&geomy,&ci1,&ci2);
			if(ci1==NULL){return;}
			ConstMeet(ci1,ln1,geomx,geomy);
		}
		else if(lncount==1){ // case 1
			ConstOnLine(ln1);
		}
		else if(lncount==2){ // case 2
			ConstMeet(ln1,ln2);
		}
		else { //
			DeletePoint(cursorpt);
			*(lastpt)=NULL;
		}
	}
	else if(snapped2ci){
		geomx=geomcx+(point.x-centerx)*geomperdot;
		geomy=geomcy-(point.y-centery)*geomperdot;
		cicount= Snap2CircleEx(cis,&geomx,&geomy,&ci1,&ci2);
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		if(cicount==1){ // 
			ConstOnCircle(ci1);
		}
		else if(cicount==2){
			ConstMeet(ci1,ci2,geomx,geomy);
		}
	}
	else if(snapped2curve){
		geomx=geomcx+(point.x-centerx)*geomperdot;
		geomy=geomcy-(point.y-centery)*geomperdot;
		cucount= Snap2CurveEx(curves,&geomx,&geomy,&cu1,&cu2);
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		if(cucount>=1){ // 
			ConstOnCurve(cu1);
		}
	}
	m_point_dragging = false;
}

void MyCanvas::LDown_MLine(wxPoint &point)
{
	ClearAllHilights();
	double gx=geomcx+(point.x-centerx)*geomperdot;
	double gy=geomcy-(point.y-centery)*geomperdot;
	if(Snapping(pts,&gx,&gy,&startpt)){
		snapped2pt=true;
	}
	else {
		ConstFree(gx,gy,true);
		AssignPoint(cursorpt);
		startpt=cursorpt;
		SetPointName(cursorpt);
		snapped2pt=false;
	}
	ConstFree(gx+0.01,gy+0.01,true);
	cursorln=NewLine(gx,gy,gx+0.01,gy+0.01);
	Sethilighted(cursorln);
	cursorln->clipping=LineClipping;
	cursorln->hilightphase=3;
	cursorln->_name=wxString((wxChar*)last_ln_name.c_str());
	next_name(last_ln_name);
	GConst* cnp = NewConst(CONST_JOIN);
	cnp->LOutput=cursorln;
	cnp->PInput1=startpt;
	cnp->PInput2=cursorpt;
	AssignIncident(cursorln,startpt,0.0);
	AssignIncident(cursorln,cursorpt,1.0);
	m_point_dragging = true;
}
void MyCanvas::LDrag_MLine(wxPoint &point)
{
	//if(lbuttondown && m_point_dragging){
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint* pt1;
	snapped2pt=Snapping(pts,&geomx,&geomy,&pt1);
	snapped2ln=Snap2Line(lns,&geomx,&geomy);
	PtDragHilight(lns,geomx,geomy);
	snapped2ci=Snap2Circle(cis,&geomx,&geomy);
	PtDragHilight(cis,geomx,geomy);
	PtDragHilight(pts,geomx,geomy);
	PtDragHilight(curves,geomx,geomy);
	cursorpt->xx.SetComplex(geomx,0.0);
	cursorpt->yy.SetComplex(geomy,0.0);
	EvaluateConst(cns);
	redraw=true;
}
void MyCanvas::LUp_MLine(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint *pt1;
	GLine *ln1,*ln2;
	GCircle *ci1,*ci2;
	GConst *cnp;
	int lncount,cicount;
	if(snapped2pt){
		Snapping(pts,&geomx,&geomy,&pt1);
		if(pt1!=startpt){
			FindLnFromCn(cns,cursorln,&cnp);
			cnp->PInput2 = pt1;  //??_??o?^?????
			cursorln->ics->_icnext->_icpt= pt1; //??_??o?^?????
			//?s?v?????ursorpt????A??
			DeletePtFromCn(&(cns),cursorpt);
			DeletePoint(cursorpt);
			*(lastpt)=NULL;
			AssignLine(cursorln);
			if(!CheckCoincidency(cursorln)) {
				CheckIncidency(cursorln);
			}
		}
		else {
			//?s?v?????ursorpt????A??
			DeletePtFromCn(&(cns),cursorpt);
			DeletePoint(cursorpt);
			*(lastpt)=NULL;
			DeleteLnFromCn(&(cns),cursorln);
			DeleteLine(cursorln);
			*(lastln)=NULL;
		}
	}
	else if(snapped2ln){
		lncount= Snap2LineEx(lns,&geomx,&geomy,&ln1,&ln2);
		AssignPoint(cursorpt);
		//?_???O?????
		SetPointName(cursorpt);
		AssignLine(cursorln);
		if(snapped2ci && lncount==1){ //???R
			GCircle *ci1,*ci2;
			Snap2CircleEx(cis,&geomx,&geomy,&ci1,&ci2);
			if(ci1==NULL){return;}
			ConstMeet(ci1,ln1,geomx,geomy);
		}
		else if(lncount==1){ // ???P
			ConstOnLine(ln1);
		}
		else if(lncount==2){ //???Q
			ConstMeet(ln1,ln2);
		}
		else { //???????l????B
			DeletePoint(cursorpt);
			*(lastpt)=NULL;
		}
		if(!CheckCoincidency(cursorln)) {
			CheckIncidency(cursorln);
		}
	}
	else if(snapped2ci){
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		cicount= Snap2CircleEx(cis,&geomx,&geomy,&ci1,&ci2);
		AssignLine(cursorln);
		if(cicount==1){ 
			ConstOnCircle(ci1);
		}
	}
	else {
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		AssignLine(cursorln);
		cursorln=NULL;
	}
	m_point_dragging = false;
}

void MyCanvas::LDown_Para(wxPoint &point)
{
	ClearAllHilights();
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GLine *ln1,*ln2;
	if(Snap2LineEx(lns,&geomx,&geomy,&ln1,&ln2)){
		snapped2ln=true;
		ConstFree(geomx+0.01,geomy+0.01,true);

		cursorln=NewLine(geomx,geomy,geomx+0.01,geomy+0.01/*,80,80,255,10*/);
		Sethilighted(cursorln);
		cursorln->hilightphase=3;
		cursorln->_name=wxString((wxChar*)last_ln_name.c_str());
		next_name(last_ln_name);
		cursorln->clipping=LineClipping;
		GConst* cnp = NewConst(CONST_PARALLEL);
		cnp->LOutput=cursorln;
		cnp->PInput1=cursorpt;
		cnp->LInput1=ln1;
		EvaluateConst(cns);
		AssignIncident(cursorln,cursorpt);
		m_point_dragging = true;
		snapped2ln=false;
	}
	else {
		m_point_dragging = false;
		snapped2ln=false;
	}
}
void MyCanvas::LDrag_Para(wxPoint &point)
{
	if(m_point_dragging){
		double geomx=geomcx+(point.x-centerx)*geomperdot;
		double geomy=geomcy-(point.y-centery)*geomperdot;
		GPoint* pt1;
		snapped2pt=Snapping(pts,&geomx,&geomy,&pt1);
		snapped2ln=Snap2Line(lns,&geomx,&geomy);
		PtDragHilight(lns,geomx,geomy);
		snapped2ci=Snap2Circle(cis,&geomx,&geomy);
		PtDragHilight(cis,geomx,geomy);
		PtDragHilight(pts,geomx,geomy);
		PtDragHilight(curves,geomx,geomy);
		cursorpt->xx.SetComplex(geomx,0.0);
		cursorpt->yy.SetComplex(geomy,0.0);
		EvaluateConst(cns);
		redraw=true;
	}
}
void MyCanvas::LUp_Para(wxPoint &point)
{
	if(m_point_dragging){
		double geomx=geomcx+(point.x-centerx)*geomperdot;
		double geomy=geomcy-(point.y-centery)*geomperdot;
		GPoint* pt1;
		GConst *cnp;
		GLine *ln1,*ln2;
		GCircle *ci1,*ci2;
		int lncount,cicount;
		if(!snapped2pt && !snapped2ln && !snapped2ci){
			//?_??????????????_????????
			AssignPoint(cursorpt);
			//?_???O?????
			SetPointName(cursorpt);
			AssignLine(cursorln);
			cursorln=NULL;
		}
		else if(snapped2pt){
			Snapping(pts,&geomx,&geomy,&pt1);
			FindLnFromCn(cns,cursorln,&cnp);
			cnp->PInput1 = pt1;  //??_??o?^?????
			cursorln->ics->_icpt=pt1; //??_??o?^?????
			//?s?v?????ursorpt????A??
			DeletePtFromCn(&(cns),cursorpt);
			DeletePoint(cursorpt);
			*(lastpt)=NULL;
			AssignLine(cursorln);
			if(!CheckCoincidency(cursorln)) {
				CheckIncidency(cursorln);
			}
		}
		else if(snapped2ln){ 
			lncount= Snap2LineEx(lns,&geomx,&geomy,&ln1,&ln2);
			AssignPoint(cursorpt);
			//?_???O?????
			SetPointName(cursorpt);
			AssignLine(cursorln);
			if(snapped2ci && lncount==1){ //???R
				GCircle *ci1,*ci2;
				Snap2CircleEx(cis,&geomx,&geomy,&ci1,&ci2);
				if(ci1==NULL){return;}
				ConstMeet(ci1,ln1,geomx,geomy);
			}
			else if(lncount==1){ // ???P
				ConstOnLine(ln1);
			}
			else if(lncount==2){ 
				ConstMeet(ln1,ln2);
				if(!CheckCoincidency(cursorln)){
					CheckIncidency(cursorln);
				}
			}
			else { 
				DeletePoint(cursorpt);
				*(lastpt)=NULL;
			}
		}
		else if(snapped2ci){
			AssignPoint(cursorpt);
			SetPointName(cursorpt);
			cicount= Snap2CircleEx(cis,&geomx,&geomy,&ci1,&ci2);
			AssignLine(cursorln);
			if(cicount==1){ 
				ConstOnCircle(ci1);
			}
		}
		m_point_dragging = false;
	}
}

void MyCanvas::LDown_Perp(wxPoint &point)
{
	ClearAllHilights();
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GLine *ln1,*ln2;
	if(Snap2LineEx(lns,&geomx,&geomy,&ln1,&ln2)){
		snapped2ln=true;
		ConstFree(geomx+0.01,geomy+0.01,true);

		cursorln=NewLine(geomx,geomy,geomx+0.01,geomy+0.01/*,80,80,255,10*/);
		Sethilighted(cursorln);
		cursorln->hilightphase=3;
		cursorln->_name=wxString((wxChar*)last_ln_name.c_str());
		next_name(last_ln_name);
		cursorln->clipping=LineClipping;
		GConst* cnp = NewConst(CONST_PERP);
		cnp->LOutput=cursorln;
		cnp->PInput1=cursorpt;
		cnp->LInput1=ln1;
		EvaluateConst(cns);
		AssignIncident(cursorln,cursorpt);
		m_point_dragging = true;
		snapped2ln=false;
	}
	else {
		m_point_dragging = false;
		snapped2ln=false;
	}
}
void MyCanvas::LDrag_Perp(wxPoint &point)
{
	LDrag_Para(point);
}
void MyCanvas::LUp_Perp(wxPoint &point)
{
	LUp_Para(point);
}

void MyCanvas::LDown_Mid(wxPoint &point)
{
	ClearAllHilights();
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	if(Snapping(pts,&geomx,&geomy,&startpt)){
		snapped2pt=true;
	}
	else {
		ConstFree(geomx,geomy,false);
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		startpt=cursorpt;
		snapped2pt=false;
	}
	ConstFree(startgeomx+0.1,startgeomy+0.1,true);
	cursorpt2=NewPoint(CComplex(startgeomx+0.05,0),CComplex(startgeomy+0.05,0));
	Sethilighted(cursorpt2);
	GConst* cnp=NewConst(CONST_MID);
	cnp->POutput=cursorpt2;
	cnp->PInput1=startpt;
	cnp->PInput2=cursorpt;
	m_point_dragging = true;
}

void MyCanvas::LDrag_Mid(wxPoint &point)
{
//	if(lbuttondown && point_dragging){
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint* pt1;
	snapped2pt=Snapping(pts,&geomx,&geomy,&pt1);
	snapped2ln=Snap2Line(lns,&geomx,&geomy);
	PtDragHilight(lns,geomx,geomy);
	snapped2ci=Snap2Circle(cis,&geomx,&geomy);
	PtDragHilight(cis,geomx,geomy);
	PtDragHilight(pts,geomx,geomy);
	PtDragHilight(curves,geomx,geomy);
	cursorpt->xx.SetComplex(geomx,0.0);
	cursorpt->yy.SetComplex(geomy,0.0);
	EvaluateConst(cns);
	redraw=true;
}

void MyCanvas::LUp_Mid(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint* pt1;
	GConst *cnp;
	GLine *ln1,*ln2;
	GCircle *ci1,*ci2;
	int lncount,cicount;
	if(!snapped2pt && !snapped2ln && !snapped2ci){
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		AssignPoint(cursorpt2);

		SetPointName(cursorpt2);
	}
	else if(snapped2pt){
		Snapping(pts,&geomx,&geomy,&pt1);
		FindPtFromCn(cns,cursorpt2,&cnp);
		cnp->PInput2 = pt1;  
		DeletePtFromCn(&(cns),cursorpt);
		DeletePoint(cursorpt);
		AssignPoint(cursorpt2);
		//?_???O?????
		SetPointName(cursorpt2);
		if(!CheckCoincidency(cursorpt2)){
			CheckIncidency(cursorpt2);
		}
	}
	else if(snapped2ln){
		lncount= Snap2LineEx(lns,&geomx,&geomy,&ln1,&ln2);
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		AssignPoint(cursorpt2);
		SetPointName(cursorpt2);
		if(snapped2ci && lncount==1){ 
			Snap2CircleEx(cis,&geomx,&geomy,&ci1,&ci2);
			if(ci1==NULL){return;}
			ConstMeet(ci1,ln1,geomx,geomy);
		}
		else if(lncount==1){ 
			ConstOnLine(ln1);
		}
		else if(lncount==2){
			ConstMeet(ln1,ln2);
			if(!CheckCoincidency(cursorpt2)){
				CheckIncidency(cursorpt2);
			}
		}
		else { 
			DeletePoint(cursorpt);
			*(lastpt)=NULL;
		}
	}
	else if(snapped2ci){
		AssignPoint(cursorpt);
		//?_???O?????
		SetPointName(cursorpt);
		cicount= Snap2CircleEx(cis,&geomx,&geomy,&ci1,&ci2);
		AssignPoint(cursorpt2);
		//?_???O?????
		SetPointName(cursorpt2);
		//???P?F?~??????
		if(cicount==1){ // ???P
			ConstOnCircle(ci1);
		}
		//???Q?F?~??~???_??????
	}
	m_point_dragging = false;
}

void MyCanvas::LDown_MCircle(wxPoint &point)
{
	GConst* cnp;
	ClearAllHilights();
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	if(Snapping(pts,&geomx,&geomy,&startpt)){
		snapped2pt=true;
	}
	else {
		ConstFree(geomx,geomy,false);
		AssignPoint(cursorpt);
		//?_???O?????
		SetPointName(cursorpt);
		startpt=cursorpt;
		snapped2pt=false;
	}
	ConstFree(geomx+0.1,geomy,true);
	cursorci=NewCircle(geomx,geomy,0.1);
	Sethilighted(cursorci);
	cursorci->hilightphase=3;
	cnp=NewConst(CONST_MULTI_CIRCLE);
	cnp->COutput=cursorci;
	cnp->PInput1=startpt;
	cnp->PInput2=cursorpt;
	AssignIncident(cursorci,cursorpt,1.0);// incident start
	m_point_dragging = true;
}
void MyCanvas::LDrag_MCircle(wxPoint &point)
{
//	if(lbuttondown && point_dragging){
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint* pt1;
	snapped2pt=Snapping(pts,&geomx,&geomy,&pt1);
	snapped2ln=Snap2Line(lns,&geomx,&geomy);
	PtDragHilight(lns,geomx,geomy);
	snapped2ci=Snap2Circle(cis,&geomx,&geomy);
	PtDragHilight(cis,geomx,geomy);
	PtDragHilight(pts,geomx,geomy);
	PtDragHilight(curves,geomx,geomy);
	cursorpt->xx.SetComplex(geomx,0.0);
	cursorpt->yy.SetComplex(geomy,0.0);
	EvaluateConst(cns);
	redraw=true;
}
void MyCanvas::LUp_MCircle(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint* pt1;
	GConst *cnp;
	GLine *ln1,*ln2;
	GCircle *ci1,*ci2;
	int lncount,cicount;
	if(!snapped2pt && !snapped2ln && !snapped2ci){
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		cursorci->_name=wxString((wxChar*)last_ci_name.c_str());
		next_name(last_ci_name);
		AssignCircle(cursorci);
		cursorci=NULL;
	}
	else if(snapped2pt){//
		Snapping(pts,&geomx,&geomy,&pt1);
		if(pt1!=startpt){
			FindCiFromCn(cns,cursorci,&cnp);
			cnp->PInput2 = pt1;  
			cursorci->ics->_icpt= pt1; 
			DeletePtFromCn(&(cns),cursorpt);
			DeletePoint(cursorpt);
			*(lastpt)=NULL;
			cursorci->_name=wxString((wxChar*)last_ci_name.c_str());
			next_name(last_ci_name);
			AssignCircle(cursorci);
			if(!CheckCoincidency(cursorci)){
				CheckIncidency(cursorci);
			}
			cursorci=NULL;
		}
		else {
			DeletePtFromCn(&(cns),cursorpt);
			DeletePoint(cursorpt);
			*(lastpt)=NULL;
			DeleteCiFromCn(&(cns),cursorci);
			DeleteCircle(cursorci);
			*(lastci)=NULL;
		}
	}
	else if(snapped2ln){ 
		lncount= Snap2LineEx(lns,&geomx,&geomy,&ln1,&ln2);
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		cursorci->_name=wxString((wxChar*)last_ci_name.c_str());
		next_name(last_ci_name);
		AssignCircle(cursorci);
		cursorci=NULL;
		if(snapped2ci && lncount==1){ 
			Snap2CircleEx(cis,&geomx,&geomy,&ci1,&ci2);
			if(ci1==NULL){return;}
			ConstMeet(ci1,ln1,geomx,geomy);
		}
		else if(lncount==1){ 
			ConstOnLine(ln1);
		}
		else if(lncount==2){ 
			ConstMeet(ln1,ln2);
			if(!CheckCoincidency(cursorci)){
				CheckIncidency(cursorci);
			}
		}
		else { 
			DeletePoint(cursorpt);
			*(lastpt)=NULL;
		}
	}
	else if(snapped2ci){
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		cicount= Snap2CircleEx(cis,&geomx,&geomy,&ci1,&ci2);
		cursorci->_name=wxString((wxChar*)last_ci_name.c_str());
		next_name(last_ci_name);
		AssignCircle(cursorci);
		cursorci=NULL;
		if(cicount==1){ 
			ConstOnCircle(ci1);
		}
	}
	m_point_dragging = false;
}

void MyCanvas::LDown_Bisector(wxPoint &point){}
void MyCanvas::LDrag_Bisector(wxPoint &point){}

void MyCanvas::LUp_Bisector(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	double geomx2,geomy2;
	double geomx3,geomy3;
	double bufx,bufy;
	int lncount;
	GLine *ln1,*ln2;
	cursorpt = NewPoint(CComplex(geomx,0.0),CComplex(geomy,0.0));
	cursorpt->next=NULL;
	lncount= Snap2LineEx(lns,&geomx,&geomy,&ln1,&ln2);
	if(lncount>0){ 
		if(UInputCount==0){ 
			ULInput1 = ln1;
			geomx1=geomx;
			geomy1=geomy;
			UInputCount=1;
			Sethilighted(ln1);
		}
		else if(UInputCount==1 && ULInput1!=ln1){ 
			ULInput2 = ln1;
			geomx2=geomx;
			geomy2=geomy;
			GPoint ispt = Meet(ULInput1,ULInput2);
			geomx3=ispt.xz().real();
			geomy3=ispt.yz().real();
			bufx = geomx3 + (geomx1-geomx3)/sqrt((geomx1-geomx3)*(geomx1-geomx3)+(geomy1-geomy3)*(geomy1-geomy3));
			bufy = geomy3 + (geomy1-geomy3)/sqrt((geomx1-geomx3)*(geomx1-geomx3)+(geomy1-geomy3)*(geomy1-geomy3));
			geomx1 = bufx; geomy1 = bufy;
			bufx = geomx3 + (geomx2-geomx3)/sqrt((geomx2-geomx3)*(geomx2-geomx3)+(geomy2-geomy3)*(geomy2-geomy3));
			bufy = geomy3 + (geomy2-geomy3)/sqrt((geomx2-geomx3)*(geomx2-geomx3)+(geomy2-geomy3)*(geomy2-geomy3));
			geomx2 = bufx; geomy2 = bufy;
			geomx1 = geomx1+geomx2-2*geomx3;
			geomy1 = geomy1+geomy2-2*geomy3;
			cursorln=NewLine(1.0,0.0,0.0,1.0);
			ClearAllHilights();
			Sethilighted(cursorln);
			cursorln->hilightphase=3;
			cursorln->_name=wxString((wxChar*)last_ln_name.c_str());
			cursorln->clipping=LineClipping;
			next_name(last_ln_name);
			GConst* cnp=NewConst(CONST_BISECTOR);
			cnp->LOutput=cursorln;
			cnp->LInput1=ULInput1;
			cnp->LInput2=ULInput2;
			cnp->para1=CComplex(1.0,0.0);
			EvaluateConst(cns);
			geomx2= cursorln->xx.real();
			geomy2= cursorln->yy.real();
			if(abs(geomx1*geomx2+geomy1*geomy2)>0.1*sqrt(geomx1*geomx1+geomy1*geomy1)*sqrt(geomx2*geomx2+geomy2*geomy2)){
				cnp->para1=CComplex(-1.0,0.0);
			}
			EvaluateConst(cns);
			AssignLine(cursorln);
			if(!CheckCoincidency(cursorln)) {
				 CheckIncidency(cursorln);
			}
			cursorln=NULL;
			UInputCount=0;
		}
	}
	DeletePoint(cursorpt);
	m_point_dragging = false; 
	redraw=true;
}

void MyCanvas::LUp_Select(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint* pt1;
	if(!ShiftLButton){
		if(pts!=NULL) pts->ClearHilight();	
		if(lns!=NULL) lns->ClearHilight();	
		if(cis!=NULL) cis->ClearHilight();	
		if(curves!=NULL) curves->ClearHilight();	
		if(texts!=NULL)	texts->ClearHilight();
		NOhilightedPoints=NOhilightedLines=NOhilightedCircles=0;
		NOhilightedCurves=0;
	}
	if(snapped2pt=Snapping(pts,&geomx,&geomy,&pt1)){
		SelectHilight(pts,geomx,geomy);
	}
	else if(snapped2ln=Snap2Line(lns,&geomx,&geomy)){
		SelectHilight(lns,geomx,geomy);
	}
	else if(snapped2ci=Snap2Circle(cis,&geomx,&geomy)){
		SelectHilight(cis,geomx,geomy);
	}
	else if(snapped2curve=Snap2Curve(curves,&geomx,&geomy)){
		SelectHilight(curves,geomx,geomy);
	}
	else if(Snap2Text(texts,point.x,point.y)){
		cursortext->hilighted=true;
	}
	else {
		if(pts!=NULL) pts->ClearHilight();	
		if(lns!=NULL) lns->ClearHilight();	
		if(cis!=NULL) cis->ClearHilight();	
		if(curves!=NULL) curves->ClearHilight();	
		if(texts!=NULL)	texts->ClearHilight();
		NOhilightedPoints=NOhilightedLines=NOhilightedCircles=0;
		NOhilightedCurves=0;
	}
	redraw=true;
}

void MyCanvas::LUp_Tangent(wxPoint &point)
{
	LUp_Select(point);
	if(NOhilightedCircles>0 && NOhilightedPoints>0){
		ConstDefTangent();
	}

}

void MyCanvas::LUp_Compass(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint* pt1;
	if(lns!=NULL) lns->ClearHilight();	
	if(cis!=NULL) cis->ClearHilight();	
	if(curves!=NULL) curves->ClearHilight();	
	NOhilightedLines=NOhilightedCircles=NOhilightedCurves=0;
	if(snapped2pt=Snapping(pts,&geomx,&geomy,&pt1)){
		if(NOhilightedPoints==1 && pt1==hilightedPoints[0]){
			;
		}
		else {
			Sethilighted(pt1);
		}
	}
	if(NOhilightedPoints==1){
		compasscenterx=compasscursorx;
		compasscentery=compasscursory;
	}
	else if(NOhilightedPoints==2){
		compassradius=(int)floor(sqrt(
			1.0*(compasscenterx-compasscursorx)*(compasscenterx-compasscursorx)+
			1.0*(compasscentery-compasscursory)*(compasscentery-compasscursory)));
	}
	if(NOhilightedPoints>=3){
		ConstDefCompass();
	}
}

void MyCanvas::LUp_Orbit(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint* pt1;
	GConst* cnp;
	if(NOhilightedPoints==0){
		if(cis!=NULL) cis->ClearHilight();	
		NOhilightedCircles=0;
	}
	if(snapped2pt=Snapping(pts,&geomx,&geomy,&pt1)){
		if(NOhilightedPoints!=1 || pt1!=hilightedPoints[0]){
			Sethilighted(pt1);
		}
	}
	if(NOhilightedPoints==1){
		FindCnFromPt(cns,hilightedPoints[0],&cnp);
		if(cnp->Const_Type==CONST_PT_ON_CIRCLE){
			Sethilighted(cnp->CInput1);
		}
		else if(cnp->Const_Type==CONST_ON_LINE || cnp->Const_Type==CONST_PT_ON_PARA || 
			cnp->Const_Type==CONST_PT_ON_PERP || cnp->Const_Type==CONST_PT_ON_3P_BISECTOR || 
			cnp->Const_Type==CONST_PT_ON_BISECTOR || cnp->Const_Type==CONST_PT_ON_TANGENT  || 
			cnp->Const_Type==CONST_PT_ON_CURVE_TANGENT){
//			Sethilighted(cnp->CInput1);
		}
		else {
			pts->ClearHilight();
			NOhilightedPoints=0;
		}
	}
	else if(NOhilightedPoints==2){
		ConstDefOrbit();
	}
}

#include "wx/textctrl.h"

class MyEditTextDialog : public wxDialog
{
public:
	MyEditTextDialog(wxWindow *parent,wxString s,int fs);
	void OnButton(wxCommandEvent& event);

	wxButton *m_btnOk;
	wxTextCtrl *m_tcText,*m_tcSize;
	wxStaticText *m_stText1,*m_stText2;
};

#ifdef __WXMSW__
MyEditTextDialog::MyEditTextDialog(wxWindow *parent,wxString s,int fs)
			 : wxDialog(parent, wxID_ANY,EditTextDlogTitle,wxPoint(15,15), wxSize(160,250))
{
	m_stText1 = new wxStaticText(this, wxID_ANY,EditTextDlogText1,wxPoint(15,10));
	m_tcText = new wxTextCtrl(this, wxID_ANY,s,wxPoint(15,30), wxSize(120,120),wxTE_MULTILINE);
	m_stText2 = new wxStaticText(this, wxID_ANY,EditTextDlogText2 ,wxPoint(30,156), wxSize(50,20));
	m_tcSize = new wxTextCtrl(this, wxID_ANY,wxString::Format("%d",fs),wxPoint(85,155), wxSize(40,20));
	m_btnOk = new wxButton(this, wxID_OK, wxT("Ok"),wxPoint(40,180), wxSize(80,20));
}
#else
MyEditTextDialog::MyEditTextDialog(wxWindow *parent,wxString s,int fs)
	: wxDialog(parent, wxID_ANY,EditTextDlogTitle,wxPoint(15,15), wxSize(320,230))
{
	m_stText1 = new wxStaticText(this, wxID_ANY,EditTextDlogText1,wxPoint(15,10));
	m_tcText = new wxTextCtrl(this, wxID_ANY,s,wxPoint(15,30), wxSize(280,120),wxTE_MULTILINE);
	m_stText2 = new wxStaticText(this, wxID_ANY,EditTextDlogText2 ,wxPoint(15,158), wxSize(85,20));
	m_tcSize = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),fs),wxPoint(95,155), wxSize(40,24));
	m_btnOk = new wxButton(this, wxID_OK, wxT("Ok"),wxPoint(30,190), wxSize(90,20));
}
#endif

void MyCanvas::LUp_Text(wxPoint &point)
{
	double gx=geomcx+(point.x-centerx)*geomperdot;
	double gy=geomcy-(point.y-centery)*geomperdot;
	GPoint* ptp;
	MyEditTextDialog *dialog;
	int pointx=point.x;
	int pointy=point.y;
	char buff[1024];
	wxString str0,str1;
	if(Snapping(pts,&gx,&gy,&ptp)){
		str1= wxString((char*)ptp->_name.c_str(),*wxConvCurrent);
		dialog=new MyEditTextDialog(this,str1,ptp->_fontsize);
		if(dialog->ShowModal() == wxID_OK){
			str0=dialog->m_tcText->GetValue();
			sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
			ptp->_name =wxString((wxChar*)buff);
			wxString st;
			long fs;
			st=dialog->m_tcSize->GetValue();
			st.ToLong(&fs);
			if(fs>100 || fs<5){
				ptp->_fontsize=14;
			}
			else {
				ptp->_fontsize=fs;
				DefaultFontSize=fs;
			}
		}
	}
	else if(Snap2Text(texts,point.x,point.y)){
		str1= wxString((char*)cursortext->str.c_str(),*wxConvCurrent);
		dialog=new MyEditTextDialog(this,str1,cursortext->fontsize);
		if(dialog->ShowModal() == wxID_OK){
			str0 = dialog->m_tcText->GetValue();
			sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
			cursortext->str=wxString((wxChar*)buff);
			AddYenCommaOnText(cursortext->str);
			wxString st;
			long fs;
			st=dialog->m_tcSize->GetValue();
			st.ToLong(&fs);
			if(fs>100 || fs<5){
				cursortext->fontsize=18;
			}
			else {
				cursortext->fontsize=fs;
			}
		}
	}
	else {
		dialog=new MyEditTextDialog(this,wxT("X"),18);
		if(dialog->ShowModal() == wxID_OK){
			str0 = dialog->m_tcText->GetValue();
			sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
			str1 =wxString((wxChar*)buff);
			cursortext=NewText(str1);
			cursortext->str=wxString((wxChar*)buff);
			AddYenCommaOnText(cursortext->str);
			wxString st;
			long fs;
			st=dialog->m_tcSize->GetValue();
			st.ToLong(&fs);
			if(fs>100 || fs<5){
				cursortext->fontsize=18;
			}
			else {
				cursortext->fontsize=fs;
			}
			cursortext->tx=pointx;
			cursortext->ty=pointy;
			cursortext->_name=wxString((wxChar*)last_text_name.c_str());
			next_name(last_text_name);
			AssignText(cursortext);
			cursorcn=NewConst(CONST_TEXT);
			cursorcn->TextOutput=cursortext;
		}
	}
}

void MyCanvas::LUp_CircleBy3(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint* pt1;
	if(snapped2pt=Snapping(pts,&geomx,&geomy,&pt1)){
		if(NOhilightedPoints==0){
			Sethilighted(pt1);
		}
		else if(NOhilightedPoints==1 && pt1!=hilightedPoints[0]){
			Sethilighted(pt1);
		}
		else if(NOhilightedPoints==2 && pt1!=hilightedPoints[0] && pt1!=hilightedPoints[1]){
			Sethilighted(pt1);
		}
	}
	if(NOhilightedPoints==3){
		ConstDefCircleBy3();
	}
}

void MyCanvas::Sethilighted(GPoint *p)
{
	int i;
	p->hilighted=true;
	p->hilightphase=3;
	for(i=0;i<NOhilightedPoints;i++){
		if(hilightedPoints[i]==p){
			return;
		}
	}
	if(NOhilightedPoints<9){
		hilightedPoints[NOhilightedPoints++]=p;
	}
}
void MyCanvas::Deletehilighted(GPoint *p)
{
	int i;
	p->hilighted=false;
	for(i=0;i<NOhilightedPoints;i++){
		if(hilightedPoints[i]==p){
			for(i++;i<NOhilightedPoints;i++){
				hilightedPoints[i-1]=hilightedPoints[i];
			}
			NOhilightedPoints--;
			return;
		}
	}
}

void MyCanvas::Sethilighted(GLine *p)
{
	int i;
	p->hilighted=true;
	for(i=0;i<NOhilightedLines;i++){
		if(hilightedLines[i]==p){
			return;
		}
	}
	if(NOhilightedLines<9){
		hilightedLines[NOhilightedLines++]=p;
	}
}
void MyCanvas::Deletehilighted(GLine *p)
{
	int i;
	p->hilighted=false;
	for(i=0;i<NOhilightedLines;i++){
		if(hilightedLines[i]==p){
			for(i++;i<NOhilightedLines;i++){
				hilightedLines[i-1]=hilightedLines[i];
			}
			NOhilightedLines--;
			return;
		}
	}
}

void MyCanvas::Sethilighted(GCircle *p)
{
	int i;
	p->hilighted=true;
	for(i=0;i<NOhilightedCircles;i++){
		if(hilightedCircles[i]==p){
			return;
		}
	}
	if(NOhilightedCircles<9){
		hilightedCircles[NOhilightedCircles++]=p;
	}
}
void MyCanvas::Deletehilighted(GCircle *p)
{
	int i;
	p->hilighted=false;
	for(i=0;i<NOhilightedCircles;i++){
		if(hilightedCircles[i]==p){
			for(i++;i<NOhilightedCircles;i++){
				hilightedCircles[i-1]=hilightedCircles[i];
			}
			NOhilightedCircles--;
			return;
		}
	}
}


void MyCanvas::Sethilighted(GParaCurve *p)
{
	int i;
	p->hilighted=true;
	for(i=0;i<NOhilightedCurves;i++){
		if(hilightedCurves[i]==p){
			return;
		}
	}
	if(NOhilightedCurves<9){
		hilightedCurves[NOhilightedCurves++]=p;
	}
}

void MyCanvas::Deletehilighted(GParaCurve *p)
{
	int i;
	p->hilighted=false;
	for(i=0;i<NOhilightedCurves;i++){
		if(hilightedCurves[i]==p){
			for(i++;i<NOhilightedCurves;i++){
				hilightedCurves[i-1]=hilightedCurves[i];
			}
			NOhilightedCurves--;
			return;
		}
	}
}

void MyCanvas::DeleteIcs(GIncident* ic)
{
	if(ic==NULL){
		return ;
	}
	if(ic->_icnext==NULL){
		return ;
	}
	DeleteIcs(ic->_icnext);
	ic->_icnext->_used=false;
}

void MyCanvas::DeleteIcs(GLine* ln)
{
	DeleteIcs(ln->ics);
	if(ln->ics!=NULL){
		ln->ics->_used=false;
	}
	ln->last_ic=&(ln->ics);
	ln->NOics=0;
}

void MyCanvas::DeletePtFromIcs(GPoint* pt)
{
	GLine* lnp;
	GIncident *icp,**ich;
	for(lnp=lns;lnp!=NULL;lnp=lnp->next){
		ich=&(lnp->ics);
		for(icp=lnp->ics;icp!=NULL;icp=icp->_icnext){
			if(icp->_icpt==pt){
				*ich = icp->_icnext;
				if(icp->_icnext==NULL){
					lnp->last_ic=ich;
				}
				icp->_used=false;
				icp=NULL;
				break;
			}
			else {
				ich=&(icp->_icnext);
			}
		}
	}
	for(GCircle* cip=cis;cip!=NULL;cip=cip->next){
		ich=&(cip->ics);
		for(icp=cip->ics;icp!=NULL;icp=icp->_icnext){
			if(icp->_icpt==pt){
				*ich = icp->_icnext;
				if(icp->_icnext==NULL){
					cip->last_ic=ich;
				}
				icp->_used=false;
				icp=NULL;
				break;
			}
			else {
				ich=&(icp->_icnext);
			}
		}
	}
	
}
void MyCanvas::ResetIcs(GConst* cn,GLine* ln)
{
	GLine *lnP;
	GConst *cnP=NULL,*cnQ=NULL;
	for(lnP=ln;lnP!=NULL;lnP=lnP->next){
		DeleteIcs(lnP);
	}
	for(cnP=cn;cnP!=NULL;cnP=cnP->next){
		switch(cnP->Const_Type){
		case CONST_ON_LINE :
			AssignIncident(cnP->LInput1,cnP->POutput,(cnP->para1 / (cnP->para1+cnP->para2)).real());
			ResetLineIcPara(cnP->LInput1);
			break;
		case CONST_JOIN :
			AssignIncident(cnP->LOutput,cnP->PInput1,0.0);
			AssignIncident(cnP->LOutput,cnP->PInput2,1.0);
			break;
		case CONST_MEET : 
			AssignIncident(cnP->LInput1,cnP->POutput,0.0);
			ResetLineIcPara(cnP->LInput1);
			AssignIncident(cnP->LInput2,cnP->POutput,0.0);
			ResetLineIcPara(cnP->LInput2);
			break;
		case CONST_PARALLEL: 
			AssignIncident(cnP->LOutput,cnP->PInput1,0.0);
			break;
		case CONST_PERP:
			AssignIncident(cnP->LOutput,cnP->PInput1,0.0);
			break;
		case CONST_PT_ON_PARA:
			FindParaFromCns(cn,cnP->LInput1,cnP->PInput1,&cnQ);
			AssignIncident(cnQ->LOutput,cnP->POutput,cnP->para1.real());
			break;
		case CONST_PT_ON_PERP:
			FindPerpFromCns(cn,cnP->LInput1,cnP->PInput1,&cnQ);
			AssignIncident(cnQ->LOutput,cnP->POutput,cnP->para1.real());
			break;
		case CONST_MEET_CL:
			AssignIncident(cnP->LInput1,cnP->POutput,0.0);
			ResetLineIcPara(cnP->LInput1);
			break;
		case CONST_PT_ON_3P_BISECTOR:
			Find3PBisectorFromCns(cn,cnP->PInput1,cnP->PInput2,cnP->PInput3,&cnQ);
			AssignIncident(cnQ->LOutput,cnP->POutput,cnP->para1.real());
			break;
		case CONST_PT_ON_BISECTOR:
			FindBisectorFromCns(cn,cnP->LInput1,cnP->LInput2,cnP->para1.real(),&cnQ);
			AssignIncident(cnQ->LOutput,cnP->POutput,cnP->para2.real());
			break;
		case CONST_PT_ON_TANGENT:
			FindTangentFromCns(cn,cnP->CInput1,cnP->PInput1,&cnQ);
			AssignIncident(cnQ->LOutput,cnP->POutput,cnP->para1.real());
			break;
		case CONST_PT_ON_CURVE_TANGENT:
			FindCurveTangentFromCns(cn,cnP->CurveInput1,cnP->PInput1,&cnQ);
			AssignIncident(cnQ->LOutput,cnP->POutput,cnP->para1.real());
			break;
		}
	}
}

void MyCanvas::DeleteIcs(GCircle* ci)
{
	DeleteIcs(ci->ics);
	if(ci->ics!=NULL){
		ci->ics->_used=false;
	}
	ci->last_ic=&(ci->ics);
	ci->NOics=0;
}


void MyCanvas::ResetIcs(GConst* cn,GCircle* ci)
{
	GCircle *ciP;
	GConst *cnP=NULL;
	for(ciP=ci;ciP!=NULL;ciP=ciP->next){
		DeleteIcs(ciP);
	}
	for(cnP=cn;cnP!=NULL;cn=cn->next){
		switch(cnP->Const_Type){
		case CONST_MULTI_CIRCLE :
			AssignIncident(cnP->COutput,cnP->PInput2,atan2(- cnP->PInput2->yz().real() + cnP->COutput->yy.real(),
				cnP->PInput2->xz().real() - cnP->COutput->xx.real()));
			//ResetCircleIcPara(cnP->COutput);
			break;
		case CONST_PT_ON_CIRCLE :
			AssignIncident(cnP->CInput1,cnP->POutput,cnP->para1.real());
			//ResetCircleIcPara(cnP->CInput1);
			break;
		case CONST_MEET_CL : 
			AssignIncident(cnP->CInput1,cnP->POutput,atan2(- cnP->POutput->yz().real() + cnP->CInput1->yy.real(),
				cnP->POutput->xz().real() - cnP->CInput1->xx.real()));
			//ResetCircleIcPara(cnP->CInput1);
			break;
		case CONST_MEET_CC: 
			AssignIncident(cnP->CInput1,cnP->POutput,atan2(- cnP->POutput->yz().real() + cnP->CInput1->yy.real(),
				cnP->POutput->xz().real() - cnP->CInput1->xx.real()));
			//ResetCircleIcPara(cnP->CInput1);
			AssignIncident(cnP->CInput2,cnP->POutput,atan2(- cnP->POutput->yz().real() + cnP->CInput2->yy.real(),
				cnP->POutput->xz().real() - cnP->CInput2->xx.real()));
			//ResetCircleIcPara(cnP->CInput2);
			break;
		}
	}
}
