//
//   Menu.cpp
//
//
#include "wx/wx.h"
#include "wx/toolbar.h"
#include "wx/button.h"
#include "wx/textctrl.h"
#include "resource.h"
#include "KidsCindyFrame.h"
#include "KidsCindyCanvas.h"
#include "incident.h"
#include "GGraph.h"
#ifdef __WXMSW__
	#include "word.h"
#else
	#include "word_e.h"
#endif

void MyCanvas::SetTheme(int thm)
{
	int j;
	switch(thm){
	case THM_STANDARD:
		ThemeMode=THM_STANDARD;
		PtMode=PT_STANDARD;
		LnMode=LN_STANDARD;
		BgMode=BG_STANDARD;
		HilColR=255;HilColG=200;HilColB=200;
		OutColR=255;OutColG=100;OutColB=100;
		for(j=0;j<5;j++){
			InColR[j]=255;InColG[j]=0;InColB[j]=0;
		}
		HilRad=8;OutRad=6;InRad=4;
		TextColR=0;TextColG=0;TextColB=0;
		TextHilColR=155;TextHilColG=100;TextHilColB=100;
		BgR[0]=240;BgG[0]=189;BgB[0]=255;
		BgR[1]=187;BgG[1]=240;BgB[1]=240;
		BgR[2]=240;BgG[2]=240;BgB[2]=190;
		for(int i=0;i<5;i++){
			LnDesign[i].SetLnRgn(LN_STANDARD,i);
		}
		AxisPen.SetColour(128,128,128);
		AxisMeshPen.SetColour(128,128,128);
		BGbmp=false;
		m_owner->menuTheme->Check(THM_STANDARD,true);
		break;
	case THM_CAT:
		ThemeMode=THM_CAT;
		PtMode=PT_CAT;
		LnMode=LN_CAT;
		BgMode=BG_CAT;
		HilColR=255;HilColG=200;HilColB=200;
		OutColR=255;OutColG=100;OutColB=100;
		for(j=0;j<5;j++){
			InColR[j]=255;InColG[j]=0;InColB[j]=0;
		}
		TextColR=0;TextColG=0;TextColB=0;
		TextHilColR=150;TextHilColG=50;TextHilColB=50;
		HilRad=8;OutRad=6;InRad=4;
		BgR[0]=255;BgG[0]=187;BgB[0]=206;
		BgR[1]=255;BgG[1]=187;BgB[1]=206;
		BgR[2]=255;BgG[2]=187;BgB[2]=206;
		for(int i=0;i<5;i++){
			LnDesign[i].SetLnRgn(LN_CAT,i);
		}
		AxisPen.SetColour(200,128,128);
		AxisMeshPen.SetColour(200,128,128);
		BGbmp=false;
		m_owner->menuTheme->Check(THM_CAT,true);
		break;
	case THM_STAR:
		ThemeMode=THM_STAR;
		PtMode=PT_STAR;
		LnMode=LN_STAR;
		BgMode=BG_STAR;
		HilColR=255;HilColG=200;HilColB=200;
		OutColR=255;OutColG=100;OutColB=100;
		for(j=0;j<5;j++){
			InColR[j]=255;InColG[j]=0;InColB[j]=0;
		}
		HilRad=8;OutRad=6;InRad=4;
		TextColR=255;TextColG=200;TextColB=255;
		TextHilColR=255;TextHilColG=200;TextHilColB=200;
		BgR[0]=0;BgG[0]=0;BgB[0]=96;
		BgR[1]=0;BgG[1]=0;BgB[1]=96;
		BgR[2]=0;BgG[2]=0;BgB[2]=96;
		for(int i=0;i<5;i++){
			LnDesign[i].SetLnRgn(LN_STAR,i);
		}
		AxisPen.SetColour(128,128,128);
		AxisMeshPen.SetColour(128,128,128);
		BGbmp=false;
		m_owner->menuTheme->Check(THM_STAR,true);
		break;
	case THM_RAILROAD:
		ThemeMode=THM_RAILROAD;
		PtMode=PT_RAILROAD;
		LnMode=LN_RAILROAD;
		BgMode=BG_RAILROAD;
		HilColR=255;HilColG=200;HilColB=200;
		OutColR=255;OutColG=100;OutColB=100;
		for(j=0;j<5;j++){
			InColR[j]=255;InColG[j]=0;InColB[j]=0;
		}
		HilRad=8;OutRad=6;InRad=4;
		TextColR=0;TextColG=0;TextColB=0;
		TextHilColR=255;TextHilColG=200;TextHilColB=200;
		BgR[0]=184;BgG[0]=255;BgB[0]=184;
		BgR[1]=184;BgG[1]=255;BgB[1]=184;
		BgR[2]=184;BgG[2]=255;BgB[2]=184;
		for(int i=0;i<5;i++){
			LnDesign[i].SetLnRgn(LN_RAILROAD,i);
		}
		AxisPen.SetColour(128,128,128);
		AxisMeshPen.SetColour(128,128,128);
		BGbmp=false;
		m_owner->menuTheme->Check(THM_RAILROAD,true);
		break;
	case THM_KSEG:
		ThemeMode=THM_KSEG;
		PtMode=PT_KSEG;
		LnMode=LN_KSEG;
		BgMode=BG_KSEG;
		HilColR=255;HilColG=000;HilColB=000;
		OutColR=000;OutColG=000;OutColB=000;
		InColR[0]=000;InColG[0]=000;InColB[0]=000;
		InColR[1]=000;InColG[1]=255;InColB[1]=000;
		InColR[2]=000;InColG[2]=000;InColB[2]=255;
		InColR[3]=255;InColG[3]=000;InColB[3]=000;
		InColR[4]=000;InColG[4]=128;InColB[4]=128;
		HilRad=8;OutRad=6;InRad=4;
		TextColR=0;TextColG=0;TextColB=0;
		TextHilColR=255;TextHilColG=0;TextHilColB=0;
		BgR[0]=239;BgG[0]=239;BgB[0]=239;
		BgR[1]=239;BgG[1]=239;BgB[1]=239;
		BgR[2]=239;BgG[2]=239;BgB[2]=239;
		for(int i=0;i<5;i++){
			LnDesign[i].SetLnRgn(LN_KSEG,i);
		}
		AxisPen.SetColour(128,128,128);
		AxisMeshPen.SetColour(128,128,128);
		BGbmp=false;
		m_owner->menuTheme->Check(THM_KSEG,true);
		break;
	case THM_CINDY:
		ThemeMode=THM_CINDY;
		PtMode=PT_CINDY;
		LnMode=LN_CINDY;
		BgMode=BG_CINDY;
		HilColR=255;HilColG=255;HilColB=255;
		OutColR=000;OutColG=000;OutColB=000;
		InColR[0]=255;InColG[0]=000;InColB[0]=000;
		InColR[1]=130;InColG[1]=255;InColB[1]=000;
		InColR[2]=000;InColG[2]=130;InColB[2]=255;
		InColR[3]=130;InColG[3]=000;InColB[3]=255;
		InColR[4]=255;InColG[4]=130;InColB[4]=000;
		HilRad=9;OutRad=7;InRad=6;
		TextColR=0;TextColG=0;TextColB=0;
		TextHilColR=255;TextHilColG=255;TextHilColB=255;
		BgR[0]=177;BgG[0]=178;BgB[0]=198;
		BgR[1]=177;BgG[1]=178;BgB[1]=198;
		BgR[2]=177;BgG[2]=178;BgB[2]=198;
		for(int i=0;i<5;i++){
			LnDesign[i].SetLnRgn(LN_CINDY,i);
		}
		AxisPen.SetColour(128,128,128);
		AxisMeshPen.SetColour(128,128,128);
		BGbmp=false;
		m_owner->menuTheme->Check(THM_CINDY,true);
		break;
	case THM_PASTEL:
		ThemeMode=THM_PASTEL;
		PtMode=PT_PASTEL;
		LnMode=LN_PASTEL;
		BgMode=BG_PASTEL;
		HilColR=200;HilColG=255;HilColB=200;
		OutColR=120;OutColG=255;OutColB=120;
		InColR[0]=255;InColG[0]=255;InColB[0]=000;
		InColR[1]=000;InColG[1]=255;InColB[1]=255;
		InColR[2]=255;InColG[2]=130;InColB[2]=180;
		InColR[3]=130;InColG[3]=180;InColB[3]=255;
		InColR[4]=130;InColG[4]=250;InColB[4]=180;
		HilRad=9;OutRad=7;InRad=5;
		TextColR=0;TextColG=150;TextColB=150;
		TextHilColR=50;TextHilColG=200;TextHilColB=200;
		BgR[0]=184;BgG[0]=189;BgB[0]=255;
		BgR[1]=184;BgG[1]=189;BgB[1]=255;
		BgR[2]=184;BgG[2]=189;BgB[2]=255;
		for(int i=0;i<5;i++){
			LnDesign[i].SetLnRgn(LN_PASTEL,i);
		}
		AxisPen.SetColour(128,128,128);
		AxisMeshPen.SetColour(128,128,128);
		BGbmp=false;
		m_owner->menuTheme->Check(THM_PASTEL,true);
		break;
	case THM_SKELETON:
		ThemeMode=THM_SKELETON;
		PtMode=PT_SKELETON;
		LnMode=LN_SKELETON;
		BgMode=BG_SKELETON;
		HilColR=255;HilColG=200;HilColB=200;
		OutColR=255;OutColG=100;OutColB=100;
		for(j=0;j<5;j++){
			InColR[j]=255;InColG[j]=0;InColB[j]=0;
		}
		HilRad=8;OutRad=6;InRad=4;
		TextColR=255;TextColG=255;TextColB=255;
		TextHilColR=255;TextHilColG=200;TextHilColB=200;
		BgR[0]=0;BgG[0]=0;BgB[0]=0;
		BgR[1]=0;BgG[1]=0;BgB[1]=0;
		BgR[2]=0;BgG[2]=0;BgB[2]=0;
		for(int i=0;i<5;i++){
			LnDesign[i].SetLnRgn(LN_SKELETON,i);
		}
		AxisPen.SetColour(200,200,200);
		AxisMeshPen.SetColour(200,200,200);
		BGbmp=false;
		m_owner->menuTheme->Check(THM_SKELETON,true);
		break;
	}
}

void MyFrame::OnThemeStandard(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_STANDARD);
	Refresh(false);
}
void MyFrame::OnThemeCat(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_CAT);
	Refresh(false);
}
void MyFrame::OnThemeStar(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_STAR);
	Refresh(false);
}
void MyFrame::OnThemeRailroad(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_RAILROAD);
	Refresh(false);
}
void MyFrame::OnThemeKseg(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_KSEG);
	Refresh(false);
}
void MyFrame::OnThemeCindy(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_CINDY);
	Refresh(false);
}
void MyFrame::OnThemePastel(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_PASTEL);
	Refresh(false);
}
void MyFrame::OnThemeSkeleton(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_SKELETON);
	Refresh(false);
}

void MyCanvas::OnPt(int id)
{
	GPoint* ptp;
	PointMode=PT_1+id;
	for(ptp=pts;ptp!=NULL;ptp=ptp->next){
		if(ptp->hilighted){
			ptp->ptbmp=id;
			ptp->hilightphase=0;
		}
	}
}
void MyFrame::OnPt0(wxCommandEvent& event)
{
	m_canvas->OnPt(0);
	Refresh(false);
}
void MyFrame::OnPt1(wxCommandEvent& event)
{
	m_canvas->OnPt(1);
	Refresh(false);
}
void MyFrame::OnPt2(wxCommandEvent& event)
{
	m_canvas->OnPt(2);
	Refresh(false);
}
void MyFrame::OnPt3(wxCommandEvent& event)
{
	m_canvas->OnPt(3);
	Refresh(false);
}
void MyFrame::OnPt4(wxCommandEvent& event)
{
	m_canvas->OnPt(4);
	Refresh(false);
}
void MyCanvas::OnLn(int id)
{
	GLine* lnp;
	GCircle* cip;
	GParaCurve* cup;
	LineMode=LN_1+id;
	for(lnp=lns;lnp!=NULL;lnp=lnp->next){
		if(lnp->hilighted){
			lnp->lndsn=id;
		}
	}
	for(cip=cis;cip!=NULL;cip=cip->next){
		if(cip->hilighted){
			cip->lndsn=id;
		}
	}
	for(cup=curves;cup!=NULL;cup=cup->next){
		if(cup->hilighted){
			cup->lndsn=id;
		}
	}
}
void MyFrame::OnLn0(wxCommandEvent& event)
{
	m_canvas->OnLn(0);
	Refresh(false);
}
void MyFrame::OnLn1(wxCommandEvent& event)
{
	m_canvas->OnLn(1);
	Refresh(false);
}
void MyFrame::OnLn2(wxCommandEvent& event)
{
	m_canvas->OnLn(2);
	Refresh(false);
}

void MyFrame::OnLn3(wxCommandEvent& event)
{
	m_canvas->OnLn(3);
	Refresh(false);
}
void MyFrame::OnLn4(wxCommandEvent& event)
{
	m_canvas->OnLn(4);
	Refresh(false);
}
void MyFrame::OnBg0(wxCommandEvent& event)
{
	m_canvas->BackgroundMode=BG_1;
	switch(m_canvas->ThemeMode){
	case THM_STANDARD:
		m_canvas->bgdsn=0;
		for(int i=0;i<5;i++){
			m_canvas->LnDesign[i].SetLnRgn(m_canvas->LnMode,i);
		}
		m_canvas->AxisPen.SetColour(128,128,128);
		m_canvas->AxisMeshPen.SetColour(128,128,128);
		m_canvas->BGbmp=false;
		Refresh(false);
	}
}
void MyFrame::OnBg1(wxCommandEvent& event)
{
	m_canvas->BackgroundMode=BG_2;
	switch(m_canvas->ThemeMode){
	case THM_STANDARD:
		m_canvas->bgdsn=1;
		for(int i=0;i<5;i++){
			m_canvas->LnDesign[i].SetLnRgn(m_canvas->LnMode,i);
		}
		m_canvas->AxisPen.SetColour(200,128,128);
		m_canvas->AxisMeshPen.SetColour(200,128,128);
		m_canvas->BGbmp=false;
		Refresh(false);
	}
}
void MyFrame::OnBg2(wxCommandEvent& event)
{
	m_canvas->BackgroundMode=BG_3;
	switch(m_canvas->ThemeMode){
	case THM_STANDARD:
		m_canvas->bgdsn=2;
		for(int i=0;i<5;i++){
			m_canvas->LnDesign[i].SetLnRgn(m_canvas->LnMode,i);
		}
		m_canvas->AxisPen.SetColour(128,128,128);
		m_canvas->AxisMeshPen.SetColour(128,128,128);
		m_canvas->BGbmp=false;
		Refresh(false);
	}
}

void MyFrame::OnModeUndo(wxCommandEvent& event)
{
	m_canvas->OnUndo();
	if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		enableToolbar();
	}
	Refresh(false);
}

void MyFrame::OnModeRedo(wxCommandEvent& event)
{
	m_canvas->OnRedo();
	if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		enableToolbar();
	}
	Refresh(false);
}

void MyCanvas::DeleteConst(GConst* cn)
{
	if(cns==NULL){
		return ; 
	}
	GConst *cnp;
	GConst **cnh;
	cnh=&cns;
	for(cnp=cns;cnp!=NULL;cnp=cnp->next){
		if(cnp==cn){
			cnp->used=false;
			*cnh=cnp->next;
			if(cnp->next==NULL){
				lastcn=cnh;
			}
			return ;
		}
		cnh=&(cnp->next);
	}
}

void MyCanvas::PushConst(GConst* cn)
{
	if(cns==NULL){
		return ; 
	}
	if(NOConstStock<255){
		PushConstStock[NOConstStock]=cn;
		NOConstStock++;
	}
	cn->used=false;
}

GConst*  MyCanvas::PopConst()
{
	if(NOConstStock==0){
		return NULL;
	}
	else {
		NOConstStock--;
		PushConstStock[NOConstStock]->used=true;
		return PushConstStock[NOConstStock];
	}
}


void MyCanvas::DeletePoint(GPoint* pt)
{
	if(pts==NULL){
		return;
	}
	GPoint *ptp;
	GPoint **pth;
	GConst *cnp;
	int i;
	DeletePtFromIcs(pt);
	pth=&pts;
	for(ptp=pts;ptp!=NULL;ptp=ptp->next){
		if(ptp==pt){
			ptp->used=false;
			*pth=ptp->next;
			if(ptp->next==NULL){
				lastpt=pth;
			}
			if(ptp->hilighted){
				for(i=0; hilightedPoints[i]!=ptp&&i<NOhilightedPoints; i++){
				}
				NOhilightedPoints--;
				for(; i<NOhilightedPoints; i++){
					hilightedPoints[i]=hilightedPoints[i+1];
				}
			}
			last_pt_name=wxString((wxChar*)"A");
			if(FindNameFromCns(cns,last_pt_name,&cnp)){
				next_name(last_pt_name);
			}
			return;
		}
		pth=&(ptp->next);
	}
}


void MyCanvas::DeleteLine(GLine* ln)
{
	if(lns==NULL){
		return;
	}
	GLine *lnp;
	GLine **lnh;
	GConst *cnp;
	int i;
	lnh=&lns;
	for(lnp=lns;lnp!=NULL;lnp=lnp->next){
		if(lnp==ln){
			lnp->used=false;
			*lnh=lnp->next;
			if(lnp->next==NULL){
				lastln=lnh;
			}
			if(lnp->hilighted){
				for(i=0; hilightedLines[i]!=lnp&&i<NOhilightedLines; i++){
				}
				NOhilightedLines--;
				for(; i<NOhilightedLines; i++){
					hilightedLines[i]=hilightedLines[i+1];
				}
			}
			last_ln_name=wxString((wxChar*)"a");
			if(FindNameFromCns(cns,last_ln_name,&cnp)){
				next_name(last_ln_name);
			}
			return ;
		}
		lnh=&(lnp->next);
	}
}

void MyCanvas::DeleteCircle(GCircle* ci)
{
	if(cis==NULL){
		return;
	}
	GCircle *cip;
	GCircle **cih;
	GConst *cnp;
	int i;
	cih=&cis;
	for(cip=cis;cip!=NULL;cip=cip->next){
		if(cip==ci){
			cip->used=false;
			*cih=cip->next;
			if(cip->next==NULL){
				lastci=cih;
			}
			if(cip->hilighted){
				for(i=0; hilightedCircles[i]!=cip&&i<NOhilightedCircles; i++){
				}
				NOhilightedCircles--;
				for(; i<NOhilightedCircles; i++){
					hilightedCircles[i]=hilightedCircles[i+1];
				}
			}
			last_ci_name=wxString((wxChar*)"C1");
			if(FindNameFromCns(cns,last_ci_name,&cnp)){
				next_name(last_ci_name);
			}
			return ;
		}
		cih=&(cip->next);
	}
}

void MyCanvas::DeleteText(GText* text)
{
	if(texts==NULL){
		return;
	}
	GText *textp;
	GText **texth;
	texth=&texts;
	for(textp=texts;textp!=NULL;textp=textp->next){
		if(textp==text){
			textp->used=false;
			*texth=textp->next;
			if(textp->next==NULL){
				lasttext=texth;
			}
			return ;
		}
		texth=&(textp->next);
	}
}

void MyCanvas::DeleteCurve(GParaCurve* curve)
{
	if(curves==NULL){
		return;
	}
	GParaCurve *cvp;
	GParaCurve **cvh;
	GConst *cnp;
	int i;
	cvh=&curves;
	for(cvp=curves;cvp!=NULL;cvp=cvp->next){
		if(cvp==curve){
			cvp->used=false;
			*cvh=cvp->next;
			if(cvp->next==NULL){
				lastcurve=cvh;
			}
			if(cvp->hilighted){
				for(i=0; hilightedCurves[i]!=cvp&&i<NOhilightedCurves; i++){
				}
				NOhilightedCurves--;
				for(; i<NOhilightedCurves; i++){
					hilightedCurves[i]=hilightedCurves[i+1];
				}
			}
			last_curve_name=wxString((wxChar*)"x1");
			if(FindNameFromCns(cns,last_curve_name,&cnp)){
				next_name(last_curve_name);
			}
			return;
		}
		cvh=&(cvp->next);
	}
}

void MyCanvas::OnUndo()
{
	GConst *cnp, **cnh;
	cnh=&cns;
	for(cnp=cns;cnp!=NULL;cnp=cnp->next){
		if(cnp->next==NULL){
			switch(cnp->Output_Type()){
			case OUTPUT_POINT:
				DeletePtFromIcs(cnp->POutput);
				cnp->POutput->invisible=true;
				if(cnp->POutput->hilighted){
					NOhilightedPoints--;
					cnp->POutput->hilighted=false;
				}
				break;
			case OUTPUT_LINE:
				cnp->LOutput->invisible=true;
				if(cnp->LOutput->hilighted){
					NOhilightedLines--;
					cnp->LOutput->hilighted=false;
				}
				break;
			case OUTPUT_CIRCLE:
				cnp->COutput->invisible=true;
				if(cnp->COutput->hilighted){
					NOhilightedCircles--;
					cnp->COutput->hilighted=false;
				}
				break;
			case OUTPUT_TEXT:
				cnp->TextOutput->invisible=true;
				if(cnp->TextOutput->hilighted){
					NOhilightedTexts--;
					cnp->TextOutput->hilighted=false;
				}
				break;
			case OUTPUT_CURVE:
				cnp->CurveOutput->invisible=true;
				if(cnp->CurveOutput->hilighted){
					NOhilightedCurves--;
					cnp->CurveOutput->hilighted=false;
				}
				break;
			case CONST_INVISIBLE:
				if(cnp->LInput1!=NULL){
					cnp->LInput1->invisible=false;
				}
				if(cnp->PInput1!=NULL){
					cnp->PInput1->invisible=false;
				}
				if(cnp->CInput1!=NULL){
					cnp->CInput1->invisible=false;
				}
				break;
			case CONST_ZOOMIN:
				OnModeZoomOut();
				break;
			case CONST_ZOOMOUT:
				OnModeZoomIn();
				break;
			}
			PushConst(cnp);
			lastcn=cnh;
			*lastcn=NULL;
			EvaluateConst(cns);
			Refresh(false);
			ResetAllName();
			return;
		}
		cnh=&(cnp->next);
	}
}

void MyCanvas::OnRedo()
{
	GConst *cnp=PopConst();
	if(cnp!=NULL){
		*lastcn=cnp;
		lastcn=&(cnp->next);
		switch(cnp->Output_Type()){
		case OUTPUT_POINT:
			cnp->POutput->invisible=false;
			CheckIncidency(cnp->POutput,false);
			break;
		case OUTPUT_LINE:
			cnp->LOutput->invisible=false;break;
		case OUTPUT_CIRCLE:
			cnp->COutput->invisible=false;break;
		case OUTPUT_TEXT:
			cnp->TextOutput->invisible=false;break;
		case OUTPUT_CURVE:
			cnp->CurveOutput->invisible=false;break;
		case CONST_INVISIBLE:
			if(cnp->LInput1!=NULL){
				cnp->LInput1->invisible=true;
			}
			if(cnp->PInput1!=NULL){
				cnp->PInput1->invisible=true;
			}
			if(cnp->CInput1!=NULL){
				cnp->CInput1->invisible=true;
			}
			break;
		case CONST_ZOOMIN:
			OnModeZoomIn();
			break;
		case CONST_ZOOMOUT:
			OnModeZoomOut();
			break;
		}
		EvaluateConst(cns);
		Refresh(false);
		ResetAllName();
	}
}

void MyFrame::OnModeMove(wxCommandEvent& event)
{
	m_canvas->DocMode=MODE_MOVE;
	enableToolbar();
	wxToolBarBase *toolBar = GetToolBar();	
	toolBar->ToggleTool(MODE_MOVE,true);
}
void MyFrame::OnModeSPoint(wxCommandEvent& event)
{
	m_canvas->DocMode=MODE_SINGLE_ADD;
	enableToolbar();
	wxToolBarBase *toolBar = GetToolBar();	
	toolBar->ToggleTool(MODE_SINGLE_ADD,true);
}
void MyFrame::OnModeMLine(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_MULTI_LINE;
		enableToolbar();
		wxToolBarBase *toolBar = GetToolBar();	
		toolBar->ToggleTool(MODE_MULTI_LINE,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefLine();
	}
}
void MyFrame::OnModePara(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_PARALLEL;
		enableToolbar();
		wxToolBarBase *toolBar = GetToolBar();	
		toolBar->ToggleTool(MODE_PARALLEL,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefPara();
	}
}
void MyFrame::OnModePerp(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_PERP;
		enableToolbar();
		wxToolBarBase *toolBar = GetToolBar();	
		toolBar->ToggleTool(MODE_PERP,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefPerp();
	}
}
void MyFrame::OnModeMid(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_MID;
		enableToolbar();
		wxToolBarBase *toolBar = GetToolBar();	
		toolBar->ToggleTool(MODE_MID,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefMid();
	}
}

void MyFrame::OnModeMCircle(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_MULTI_CIRCLE;
		enableToolbar();
		wxToolBarBase *toolBar = GetToolBar();	
		toolBar->ToggleTool(MODE_MULTI_CIRCLE,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefCircle();
	}
}

void MyFrame::OnModeBisector(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->UInputCount=0;
		m_canvas->ClearAllHilights();
		m_canvas->DocMode=MODE_BISECTOR;
		enableToolbar();
		wxToolBarBase *toolBar = GetToolBar();	
		toolBar->ToggleTool(MODE_BISECTOR,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefBisector();
	}
}

void MyFrame::OnIdModeTangent(wxCommandEvent& event)
{
	ext_toolbar=MODE_TANGENT;
	RecreateToolbar();
}
void MyFrame::OnModeTangent(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_TANGENT;
		enableToolbar();
		wxToolBarBase *toolBar = GetToolBar();	
		toolBar->ToggleTool(MODE_TANGENT,true);
		if(m_canvas->NOhilightedCircles>0 && m_canvas->NOhilightedPoints>0){
			m_canvas->ConstDefTangent();
		}
		if(m_canvas->NOhilightedCurves>0 && m_canvas->NOhilightedPoints>0){
			m_canvas->ConstDefCurveTangent();
		}
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		if(m_canvas->NOhilightedCircles>0 && m_canvas->NOhilightedPoints>0){
			m_canvas->ConstDefTangent();
		}
		if(m_canvas->NOhilightedCurves>0 && m_canvas->NOhilightedPoints>0){
			m_canvas->ConstDefCurveTangent();
		}
	}
}

void MyFrame::OnIdModeCircleBy3(wxCommandEvent& event)
{
	ext_toolbar=MODE_CIRCLE_BY_3;
	RecreateToolbar();
}
void MyFrame::OnModeCircleBy3(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_CIRCLE_BY_3;
		enableToolbar();
		wxToolBarBase *toolBar = GetToolBar();	
		toolBar->ToggleTool(MODE_CIRCLE_BY_3,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefCircleBy3();
	}
}

void MyFrame::OnModeText(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_TEXT;
		enableToolbar();
		wxToolBarBase *toolBar = GetToolBar();	
		toolBar->ToggleTool(MODE_TEXT,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->KSEGtexton=!m_canvas->KSEGtexton;
	}
}

void MyFrame::OnModeSelect(wxCommandEvent& event)
{
	m_canvas->DocMode=MODE_SELECT;
	enableToolbar();
	wxToolBarBase *toolBar = GetToolBar();	
	toolBar->ToggleTool(MODE_SELECT,true);
}
void MyFrame::OnModeMeet(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefMeet();
	}
}
int GetRBInGraphText(wxString& str);
void MyFrame::OnModeGraph(wxCommandEvent& event)
{
	GConst* thiscn;
	GParaCurve *thiscurve;
	GraphDialog* myd=new GraphDialog(this);
	wxString str0,str1,str2;
	wxString tgt;
	int i;
	int err;
	int RB;
	const char*p;
	char buff[256];
	int len;
	if(myd->ShowModal() == wxID_OK){
		str0 = myd->txt1->GetValue();
		sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
		str1 =wxString((wxChar*)buff);
		p=(char*)str1.c_str();
		len=strlen(p);
		if(len==0){
			delete myd;
			return;
		}
		RB=GetRBInGraphText(str1);
		switch(RB){
		case 0:
			thiscurve = m_canvas->NewGraphCurve(str1);
			thiscurve->RB=0;
			myd->txtmin->GetValue().ToDouble(&(thiscurve->para_min));
			myd->txtmax->GetValue().ToDouble(&(thiscurve->para_max));
			DeleteGCalc(thiscurve->gcal_y);
			EvaluateText(m_canvas->cns,thiscurve->str_y,tgt,true);
			err=MakeCalcPolynomial(tgt,&(thiscurve->gcal_y));
			//thiscurve->gcal_y->Print(0);
			if(err>0){
				thiscurve->gcal_y->Print(0);
				wxString message;
				message.Printf(wxT("error %d"),err);
				wxMessageBox(message,InvalidGraphInput,wxOK | wxICON_INFORMATION, this);
			}
			else {
				thiscn = m_canvas->NewConst(CONST_GRAPH);
				thiscn->CurveOutput=thiscurve;
				thiscurve->my_cn=m_canvas->cns;
				thiscn->CurveOutput->_name=wxString((wxChar*)m_canvas->last_curve_name.c_str());
				m_canvas->next_name(m_canvas->last_curve_name);
				m_canvas->AssignCurve(thiscn->CurveOutput);
				m_canvas->EvaluateConst(m_canvas->cns);
				Refresh(false);
			}
			break;
		case 1:
			p=(char*)str1.c_str();
			len=strlen(p);
			for(i=0;i<len;i++){
				if(p[i]==','){
					str2=mMid(str1,i+1);
					str1=mLeft(str1,i);
					thiscurve = m_canvas->NewParaCurve(str1,str2);
					thiscurve->RB=1;
					myd->txtmin->GetValue().ToDouble(&(thiscurve->para_min));
					myd->txtmax->GetValue().ToDouble(&(thiscurve->para_max));
					DeleteGCalc(thiscurve->gcal_x);
					DeleteGCalc(thiscurve->gcal_y);
					EvaluateText(m_canvas->cns,thiscurve->str_x,tgt,true);
					err=MakeCalcPolynomial(tgt,&(thiscurve->gcal_x));
					EvaluateText(m_canvas->cns,thiscurve->str_y,tgt,true);
					err |= MakeCalcPolynomial(tgt,&(thiscurve->gcal_y));
					//thiscurve->gcal_y->Print(0);
					if(err>0){
						thiscurve->gcal_x->Print(0);
						thiscurve->gcal_y->Print(0);
						wxString message;
						message.Printf(wxT("error %d"),err);
						wxMessageBox(message,InvalidGraphInput,wxOK | wxICON_INFORMATION, this);

					}
					else {
						thiscn = m_canvas->NewConst(CONST_PARA_CURVE);
						thiscn->CurveOutput=thiscurve;
						thiscn->CurveOutput->_name=wxString((wxChar*)m_canvas->last_curve_name.c_str());
						m_canvas->next_name(m_canvas->last_curve_name);
						m_canvas->AssignCurve(thiscn->CurveOutput);
						m_canvas->EvaluateConst(m_canvas->cns);
						Refresh(false);
					}
				}
			}
			break;
		}
	}
	delete myd;
 }


void MyFrame::OnModeCompass(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_COMPASS;
		enableToolbar();
		wxToolBarBase *toolBar = GetToolBar();	
		toolBar->ToggleTool(MODE_COMPASS,true);
	}
	if(m_canvas->pts!=NULL){
		m_canvas->pts->ClearHilight();
	}
	m_canvas->NOhilightedPoints=0;
	m_canvas->compasscursorx=m_canvas->compasscursory=0;
	m_canvas->compasscenterx=m_canvas->compasscentery=0;
}

void MyFrame::OnModeOrbit(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_ORBIT;
		enableToolbar();
		wxToolBarBase *toolBar = GetToolBar();	
		toolBar->ToggleTool(MODE_ORBIT,true);
		if(m_canvas->pts!=NULL){
			m_canvas->pts->ClearHilight();
			m_canvas->NOhilightedPoints=0;
		}
		Refresh(false);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefOrbit();
	}
}

void MyFrame::OnModeClipping(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->LineClipping = !m_canvas->LineClipping;
		wxToolBarBase *toolBar = GetToolBar();	
		if(m_canvas->LineClipping){
			toolBar->ToggleTool(MODE_CLIPPING,true);
		}
		else {
			toolBar->ToggleTool(MODE_CLIPPING,false);
		}
		GLine* gln;
		GCircle* gci;
		for(gln=m_canvas->lns;gln!=NULL;gln=gln->next){
			if(gln->hilighted){
				gln->clipping=m_canvas->LineClipping;
			}
		}
		for(gci=m_canvas->cis;gci!=NULL;gci=gci->next){
			if(gci->hilighted){
				gci->clipping=m_canvas->LineClipping;
			}
		}
		Refresh(false);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		if(m_canvas->NOhilightedPoints==2){
			m_canvas->ConstDefClippingLine();
		}
		else if(m_canvas->NOhilightedLines>=1){
			m_canvas->LineClippingon();
		}
	}
}
void MyFrame::OnModeInvisible(wxCommandEvent& event)
{
	m_canvas->OnModeInvisible();
}

void MyCanvas::OnModeInvisible()
{
	if(GMode==MODE_CINDY || GMode==MODE_KSEG || GMode==MODE_PANEL){
		GPoint* ptp;
		GLine* lnp;
		GCircle* cip;
		GConst* cnp; 
		for(lnp=lns;lnp!=NULL;lnp=lnp->next){
			if(lnp->hilighted){
				lnp->invisible=true;
				cnp=NewConst(CONST_INVISIBLE);
				cnp->LInput1=lnp;
				NOhilightedLines--;
				lnp->hilighted=false;
			}
		}
		for(ptp=pts;ptp!=NULL;ptp=ptp->next){
			if(ptp->hilighted){
				ptp->invisible=true;
				cnp=NewConst(CONST_INVISIBLE);
				cnp->PInput1=ptp;
				NOhilightedPoints--;
				ptp->hilighted=false;
			}
		}
		for(cip=cis;cip!=NULL;cip=cip->next){
			if(cip->hilighted){
				cip->invisible=true;
				cnp=NewConst(CONST_INVISIBLE);
				cnp->CInput1=cip;
				NOhilightedCircles--;
				cip->hilighted=false;
			}
		}
		Refresh(false);
	}
}
void MyFrame::OnModeAxis(wxCommandEvent& event)
{
	m_canvas->AxisOn = !m_canvas->AxisOn;
	Refresh(false);
}
void MyFrame::OnCloneOn(wxCommandEvent& event)
{
	m_canvas->CloneOnOff = !m_canvas->CloneOnOff;
}

void MyCanvas::OnCloneOn(void)
{
	pts1=makePClone(pts);
	pts2=makePClone(pts1);
	pts3=makePClone(pts2);
	lns1=makeLClone(lns);
	lns2=makeLClone(lns1);
	lns3=makeLClone(lns2);
	cis1=makeCClone(cis);
	cis2=makeCClone(cis1);
	cis3=makeCClone(cis2);
}

void MyCanvas::OnCloneOff(void)
{
	deletePClone(pts1);
	deletePClone(pts2);
	deletePClone(pts3);
	deleteLClone(lns1);
	deleteLClone(lns2);
	deleteLClone(lns3);
	deleteCClone(cis1);
	deleteCClone(cis2);
	deleteCClone(cis3);
}

void MyFrame::OnGModeCindy(wxCommandEvent& event)
{
	m_canvas->LineClipping=false;
	m_canvas->GMode=MODE_CINDY;
	RecreateToolbar();
}
void MyFrame::OnGModeKseg(wxCommandEvent& event)
{
	m_canvas->LineClipping=false;
	m_canvas->GMode=MODE_KSEG;
	m_canvas->KSEGtexton=false;
	RecreateToolbar();
}
void MyFrame::OnGModePanel(wxCommandEvent& event)
{
	m_canvas->LineClipping=false;
	m_canvas->GMode=MODE_PANEL;
	m_canvas->KSEGtexton=false;
	m_canvas->PanelShift=m_canvas->PanelAdd=m_canvas->PanelMove=false;
	m_canvas->PanelDragPoint=m_canvas->PanelDragText=m_canvas->PanelDragPointName=false;
	RecreateToolbar();
}

void MyFrame::OnSlideShowStart(wxCommandEvent& event)
{
	m_canvas->SMode=true;
	m_canvas->anim_cn=NULL;
	m_canvas->anim_wait=false;
	m_canvas->Click4NewSheet=false;
	m_canvas->SlideShowStart(m_canvas->cns);
	Refresh(false);
}

//class MyTextCtrl : public wxTextCtrl
//{
//public:
//	MyTextCtrl(wxWindow *parent, wxWindowID id, const wxString &value,
//			   const wxPoint &pos, const wxSize &size, int style = 0)
//		: wxTextCtrl(parent, id, value, pos, size, style)
//	{
//		m_hasCapture = false;
//	}
//
//	//void OnKeyDown(wxKeyEvent& event);
//	//void OnKeyUp(wxKeyEvent& event);
//	//void OnChar(wxKeyEvent& event);
//
//	//void OnText(wxCommandEvent& event);
//	//void OnTextURL(wxTextUrlEvent& event);
//	//void OnTextMaxLen(wxCommandEvent& event);
//
//	//void OnMouseEvent(wxMouseEvent& event);
//
//	//void OnSetFocus(wxFocusEvent& event);
//	//void OnKillFocus(wxFocusEvent& event);
//
//	static bool ms_logKey;
//	static bool ms_logChar;
//	static bool ms_logMouse;
//	static bool ms_logText;
//	static bool ms_logFocus;
//
//private:
//	static inline wxChar GetChar(bool on, wxChar c) { return on ? c : _T('-'); }
////	void LogKeyEvent(const wxChar *name, wxKeyEvent& event) const;
//
//	bool m_hasCapture;
//
////	DECLARE_EVENT_TABLE()
//};

class ScriptDialog : public wxDialog
{
public:
	// ctor
	ScriptDialog(MyFrame* parent);

	MyCanvas* granpa;
	wxTextCtrl *m_textrich;
	wxTextCtrl *sheetnumber;
	wxButton *myB1,*myB2,*myB3,*myB4,*myB5;

	void OnScriptPrevSheet(wxCommandEvent& event);
	void OnScriptNextSheet(wxCommandEvent& event);
	void OnScriptNewSheet(wxCommandEvent& event);

private:
	DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(ScriptDialog, wxDialog)
	EVT_BUTTON (ID_FILE_EDIT_PREV, ScriptDialog::OnScriptPrevSheet)
	EVT_BUTTON (ID_FILE_EDIT_NEXT, ScriptDialog::OnScriptNextSheet)
	EVT_BUTTON (ID_FILE_EDIT_NEW,  ScriptDialog::OnScriptNewSheet)
END_EVENT_TABLE()

ScriptDialog::ScriptDialog(MyFrame *parent)
:wxDialog(parent,wxID_ANY,MenuEditSourceTitle,wxPoint(50,50),wxSize(500,600),wxDEFAULT_DIALOG_STYLE,wxT(""))
{
	granpa = parent->m_canvas;
	myB1 = new wxButton(this,wxID_OK,ScriptButtonApply,wxPoint(10,10),wxSize(75,25),0, wxDefaultValidator, wxT("button"));
	myB2 = new wxButton(this,ID_FILE_EDIT_PREV,ScriptButtonPrev,wxPoint(110,10),wxSize(75,25),0, wxDefaultValidator, wxT("button"));
	myB3 = new wxButton(this,ID_FILE_EDIT_NEXT,ScriptButtonNext,wxPoint(210,10),wxSize(75,25),0, wxDefaultValidator, wxT("button"));
	myB4 = new wxButton(this,ID_FILE_EDIT_NEW,ScriptButtonNew,wxPoint(310,10),wxSize(75,25),0, wxDefaultValidator, wxT("button"));
#ifdef __WXMSW__
	myB5 = new wxButton(this,wxID_CANCEL,ScriptButtonCancel,wxPoint(410,10),wxSize(75,25),0, wxDefaultValidator, wxT("button"));
#else
	myB5 = new wxButton(this,wxID_CANCEL,/*ScriptButtonCancel*/ wxT(""),wxPoint(410,10),wxSize(75,25),0, wxDefaultValidator, wxT("button"));
#endif
	m_textrich = new wxTextCtrl(this, wxID_ANY, wxT(""),
				wxPoint(10, 75), wxSize(470, 500),
				wxHSCROLL | wxTE_MULTILINE);
	sheetnumber = new wxTextCtrl(this, wxID_ANY, wxString::Format(wxT("Sheet: %d/%d"), granpa->currentSheet+1,granpa->NOMySheet ),wxPoint(10,45),wxSize(470,25),wxTE_READONLY );
}

void ScriptDialog::OnScriptPrevSheet(wxCommandEvent& event)
{
	if(granpa->currentSheet==0){
		return ;
	}
	granpa->DeleteAllConstFromSheet(granpa->sheetbuffer[granpa->currentSheet].MyConst);
	granpa->cns=granpa->sheetbuffer[granpa->currentSheet].MyConst=NULL;
	granpa->lastcn=granpa->sheetbuffer[granpa->currentSheet].MyLastConst=&(granpa->cns);
	granpa->pts= granpa->sheetbuffer[granpa->currentSheet].MyPoint=NULL;	
	granpa->lastpt= granpa->sheetbuffer[granpa->currentSheet].MyLastPoint=&(granpa->pts);
	granpa->lns = granpa->sheetbuffer[granpa->currentSheet].MyLine=NULL;
	granpa->lastln = granpa->sheetbuffer[granpa->currentSheet].MyLastLine=&(granpa->lns);
	granpa->cis = granpa->sheetbuffer[granpa->currentSheet].MyCircle=NULL;
	granpa->lastci = granpa->sheetbuffer[granpa->currentSheet].MyLastCircle=&(granpa->cis);
	granpa->texts = granpa->sheetbuffer[granpa->currentSheet].MyText=NULL;
	granpa->lasttext = granpa->sheetbuffer[granpa->currentSheet].MyLastText=&(granpa->texts);
	granpa->curves = granpa->sheetbuffer[granpa->currentSheet].MyParaCurve=NULL;
	granpa->lastcurve = granpa->sheetbuffer[granpa->currentSheet].MyLastParaCurve=&(granpa->curves);
	granpa->const_src=m_textrich->GetValue();
	granpa->const_src2cns(false,true);
	if(granpa->currentSheet>0){
		granpa->currentSheet --;
	}
	granpa->cns = granpa->sheetbuffer[granpa->currentSheet].MyConst;
	granpa->lastcn = granpa->sheetbuffer[granpa->currentSheet].MyLastConst;
	granpa->pts= granpa->sheetbuffer[granpa->currentSheet].MyPoint;	
	granpa->lastpt= granpa->sheetbuffer[granpa->currentSheet].MyLastPoint;
	granpa->lns = granpa->sheetbuffer[granpa->currentSheet].MyLine;
	granpa->lastln = granpa->sheetbuffer[granpa->currentSheet].MyLastLine;
	granpa->cis = granpa->sheetbuffer[granpa->currentSheet].MyCircle;
	granpa->lastci = granpa->sheetbuffer[granpa->currentSheet].MyLastCircle;
	granpa->texts = granpa->sheetbuffer[granpa->currentSheet].MyText;
	granpa->lasttext = granpa->sheetbuffer[granpa->currentSheet].MyLastText;
	granpa->curves = granpa->sheetbuffer[granpa->currentSheet].MyParaCurve;
	granpa->lastcurve = granpa->sheetbuffer[granpa->currentSheet].MyLastParaCurve;
	sheetnumber->Clear();
	sheetnumber->WriteText(wxString::Format(wxT("Sheet: %d/%d"), granpa->currentSheet+1,granpa->NOMySheet ));
	m_textrich->Clear();
	granpa->const_src=(wxString)wxT("");
	granpa->SetConstSrc(granpa->cns);
	m_textrich->WriteText(granpa->const_src);
	granpa->ResetAllName();
}

void ScriptDialog::OnScriptNextSheet(wxCommandEvent& event)
{
	if(granpa->currentSheet==granpa->NOMySheet-1){
		return;
	}
	granpa->DeleteAllConstFromSheet(granpa->sheetbuffer[granpa->currentSheet].MyConst);
	granpa->cns=granpa->sheetbuffer[granpa->currentSheet].MyConst=NULL;
	granpa->lastcn=granpa->sheetbuffer[granpa->currentSheet].MyLastConst=&(granpa->cns);
	granpa->pts= granpa->sheetbuffer[granpa->currentSheet].MyPoint=NULL;	
	granpa->lastpt= granpa->sheetbuffer[granpa->currentSheet].MyLastPoint=&(granpa->pts);
	granpa->lns = granpa->sheetbuffer[granpa->currentSheet].MyLine=NULL;
	granpa->lastln = granpa->sheetbuffer[granpa->currentSheet].MyLastLine=&(granpa->lns);
	granpa->cis = granpa->sheetbuffer[granpa->currentSheet].MyCircle=NULL;
	granpa->lastci = granpa->sheetbuffer[granpa->currentSheet].MyLastCircle=&(granpa->cis);
	granpa->texts = granpa->sheetbuffer[granpa->currentSheet].MyText=NULL;
	granpa->lasttext = granpa->sheetbuffer[granpa->currentSheet].MyLastText=&(granpa->texts);
	granpa->curves = granpa->sheetbuffer[granpa->currentSheet].MyParaCurve=NULL;
	granpa->lastcurve = granpa->sheetbuffer[granpa->currentSheet].MyLastParaCurve=&(granpa->curves);
	granpa->const_src=m_textrich->GetValue();
	granpa->const_src2cns(false,true);

	if(granpa->currentSheet<granpa->NOMySheet-1){
		granpa->currentSheet ++;
	}
	granpa->cns = granpa->sheetbuffer[granpa->currentSheet].MyConst;
	granpa->lastcn = granpa->sheetbuffer[granpa->currentSheet].MyLastConst;
	granpa->pts= granpa->sheetbuffer[granpa->currentSheet].MyPoint;	
	granpa->lastpt= granpa->sheetbuffer[granpa->currentSheet].MyLastPoint;
	granpa->lns = granpa->sheetbuffer[granpa->currentSheet].MyLine;
	granpa->lastln = granpa->sheetbuffer[granpa->currentSheet].MyLastLine;
	granpa->cis = granpa->sheetbuffer[granpa->currentSheet].MyCircle;
	granpa->lastci = granpa->sheetbuffer[granpa->currentSheet].MyLastCircle;
	granpa->texts = granpa->sheetbuffer[granpa->currentSheet].MyText;
	granpa->lasttext = granpa->sheetbuffer[granpa->currentSheet].MyLastText;
	granpa->curves = granpa->sheetbuffer[granpa->currentSheet].MyParaCurve;
	granpa->lastcurve = granpa->sheetbuffer[granpa->currentSheet].MyLastParaCurve;
	sheetnumber->Clear();
	sheetnumber->WriteText(wxString::Format(wxT("Sheet: %d/%d"), granpa->currentSheet+1,granpa->NOMySheet ));
	m_textrich->Clear();
	granpa->const_src=(wxString)wxT("");
	granpa->SetConstSrc(granpa->cns);
	m_textrich->WriteText(granpa->const_src);
	granpa->ResetAllName();
}
void ScriptDialog::OnScriptNewSheet(wxCommandEvent& event)
{
	granpa->InsertNewSheet();
	sheetnumber->Clear();
	sheetnumber->WriteText(wxString::Format(wxT("Sheet: %d/%d"), granpa->currentSheet+1,granpa->NOMySheet ));
	m_textrich->Clear();
}
			 
void MyFrame::OnEditText(wxCommandEvent& event)
{
	ScriptDialog myD(this);
	m_canvas->const_src=(wxString)wxT("");
	m_canvas->SetConstSrc(m_canvas->cns);
	char*p=(char*)m_canvas->const_src.c_str();
	int l=strlen(p);
	char * str1= new char[l+1];
	sprintf(str1,"%s",p);
	wxString str2(str1, *wxConvCurrent);
	myD.m_textrich->WriteText(str2);
	bool loop=false;
	do{
		if(myD.ShowModal()==wxID_OK){
			m_canvas->DeleteAllConstFromSheet(m_canvas->sheetbuffer[m_canvas->currentSheet].MyConst);
			m_canvas->cns=m_canvas->sheetbuffer[m_canvas->currentSheet].MyConst=NULL;
			m_canvas->lastcn=m_canvas->sheetbuffer[m_canvas->currentSheet].MyLastConst=&(m_canvas->cns);
			m_canvas->pts= m_canvas->sheetbuffer[m_canvas->currentSheet].MyPoint=NULL;	
			m_canvas->lastpt= m_canvas->sheetbuffer[m_canvas->currentSheet].MyLastPoint=&(m_canvas->pts);
			m_canvas->lns = m_canvas->sheetbuffer[m_canvas->currentSheet].MyLine=NULL;
			m_canvas->lastln = m_canvas->sheetbuffer[m_canvas->currentSheet].MyLastLine=&(m_canvas->lns);
			m_canvas->cis = m_canvas->sheetbuffer[m_canvas->currentSheet].MyCircle=NULL;
			m_canvas->lastci = m_canvas->sheetbuffer[m_canvas->currentSheet].MyLastCircle=&(m_canvas->cis);
			m_canvas->texts = m_canvas->sheetbuffer[m_canvas->currentSheet].MyText=NULL;
			m_canvas->lasttext = m_canvas->sheetbuffer[m_canvas->currentSheet].MyLastText=&(m_canvas->texts);
			m_canvas->curves = m_canvas->sheetbuffer[m_canvas->currentSheet].MyParaCurve=NULL;
			m_canvas->lastcurve = m_canvas->sheetbuffer[m_canvas->currentSheet].MyLastParaCurve=&(m_canvas->curves);
			wxString str=wxT("                \n")+myD.m_textrich->GetValue();
			const char*p=(const char*) str.mb_str(wxConvUTF8);
			char* q;
			for(q=(char*)p;*q!='\n';q++) ;
			m_canvas->const_src=wxString((wxChar*)q);
			m_canvas->const_src2cns(false,true);
		}
		else {
			loop=false;
		}
	} while(loop);
}

void MyFrame::OnSlideShowProperty(wxCommandEvent& event)
{
	m_canvas->AnimationProperty();
}

void MyFrame::OnNextSheet(wxCommandEvent& event)
{
	m_canvas->NextSheet();
	SetStatusText(wxString::Format(wxT("Sheet %d"),m_canvas->currentSheet+1));
	Refresh(false);
}
void MyFrame::OnPrevSheet(wxCommandEvent& event)
{
	m_canvas->PrevSheet();
	SetStatusText(wxString::Format(wxT("Sheet %d"),m_canvas->currentSheet+1));
	Refresh(false);
}
void MyFrame::OnInsertNew(wxCommandEvent& event)
{
	m_canvas->InsertNewSheet();
	SetStatusText(wxString::Format(wxT("Sheet %d"),m_canvas->currentSheet+1));
}
void MyFrame::OnInsertCopyFigure(wxCommandEvent& event)
{
	m_canvas->InsertCopyFigure(false);
	SetStatusText(wxString::Format(wxT("Sheet %d"),m_canvas->currentSheet+1));
}
void MyFrame::OnInsertCopyAll(wxCommandEvent& event)
{
	m_canvas->InsertCopyFigure(true);
	SetStatusText(wxString::Format(wxT("Sheet %d"),m_canvas->currentSheet+1));
}
void MyFrame::OnDeleteSheet(wxCommandEvent& event)
{
	m_canvas->DeleteSheet();
}

void MyFrame::OnBenchMark(wxCommandEvent& event)
{
	m_canvas->OnBenchMark();
}

void MyFrame::OnModeZoomIn(wxCommandEvent& event)
{
	m_canvas->OnModeZoomIn();
	m_canvas->NewConst(CONST_ZOOMIN);
}
void MyCanvas::OnModeZoomIn()
{
	if(geomperdot>0.001){
		geomperdot/=1.2;
		snapradius/=1.2;
		snapradius2=snapradius*snapradius;
		boxleft=geomcx+(relRect.GetLeft()-centerx)*geomperdot;
		boxright=geomcx+(relRect.GetRight()-centerx)*geomperdot;
		boxtop=geomcy-(relRect.GetTop()-centery)*geomperdot;
		boxbottom=geomcy-(relRect.GetBottom()-centery)*geomperdot;
		for(GConst* cnp=cns;cnp!=NULL;cnp=cnp->next){
			cnp->geomperdot = geomperdot;
			cnp->boxleft = boxleft;
			cnp->boxright = boxright;
			cnp->boxtop = boxtop;
			cnp->boxbottom = boxbottom;
		}
		EvaluateConst(cns);
	}
	m_owner->enableToolbar();
	Refresh(false);
}

void MyFrame::OnModeZoomOut(wxCommandEvent& event)
{
	m_canvas->OnModeZoomOut();
	m_canvas->NewConst(CONST_ZOOMOUT);
}

void MyCanvas::OnModeZoomOut()
{
	if(geomperdot<0.1){
		geomperdot*=1.2;
		snapradius*=1.2;
		snapradius2=snapradius*snapradius;
		boxleft=geomcx+(relRect.GetLeft()-centerx)*geomperdot;
		boxright=geomcx+(relRect.GetRight()-centerx)*geomperdot;
		boxtop=geomcy-(relRect.GetTop()-centery)*geomperdot;
		boxbottom=geomcy-(relRect.GetBottom()-centery)*geomperdot;
		for(GConst* cnp=cns;cnp!=NULL;cnp=cnp->next){
			cnp->geomperdot = geomperdot;
			cnp->boxleft = boxleft;
			cnp->boxright = boxright;
			cnp->boxtop = boxtop;
			cnp->boxbottom = boxbottom;
		}
		EvaluateConst(cns);
	}
	m_owner->enableToolbar();
	Refresh(false);
}



